/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.spectrim.dicom;

import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.LinkedList;
import javax.swing.JFrame;

/**
 *
 * @author slotboom
 */
public class DicomNetworkNodeDefinerAndSelectionFrame extends JFrame implements ActionListener
{
    
    public DicomNetworkNodeDefinerAndSelectionFrame( JFrame parent )
    {
        m_panel = new DicomNetworkNodeDefinerAndSelectionPanel( this );
        setContentPane( m_panel );
        
        m_parent = parent;
        m_panel.addActionListener( this );

        this.setTitle( "DICOM Nodes Properties Settings Panel" );
        
        pack( );
        // Put the Dialog nicely in the middle of its parent
        Point centerParent = new Point( m_parent.getX( ) + ( m_parent.getWidth( ) - getWidth( ) ) / 2,
                                       m_parent.getY( ) + ( m_parent.getHeight( ) - getHeight( ) ) / 2 );

        setLocation( centerParent );
        
        
        setVisible( true );
    }


    /**
     * Quits and disposes the control
     */
    public void quitAndDispose( )
    {
        setVisible( false );
        dispose( );
    }

    /**
     * Notify listeners that something in the object has changed
     */
    protected void notifyActionListeners( int eventType )
    {

        Iterator it = m_actionListeners.iterator( );
        while( it.hasNext( ) )
        {
            ( ( ActionListener )it.next( ) ).actionPerformed( new ActionEvent( this, eventType, "" ) );
        }

    }


    /**
     * Adds an actionlistener to the list of action listeners who are notified
     * when something happens in this component
     */
    public void addActionListener( ActionListener e )
    {
        m_actionListeners.add( e );
    }

    /**
     * Is called whenever a registered object raises an action event.
     * @param arg0
     */
    public void actionPerformed( ActionEvent arg0 )
    {
        Object sender = arg0.getSource( );
        if (  sender == m_panel )
        {
            notifyActionListeners( OK_BUTTON_PRESSED );
        }
    }


    // attributes
    private DicomNetworkNodeDefinerAndSelectionPanel m_panel;

    private LinkedList<ActionListener> m_actionListeners = new LinkedList<ActionListener>( );

    public final static int OK_BUTTON_PRESSED = 0;
    
    private JFrame m_parent;
}
