/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * DicomTagsManipulationControl.java
 *
 * Created on 17-May-2010, 18:06:29
 */

package org.spectrim.dicom;

import java.util.Iterator;
import java.util.LinkedHashMap;

/**
 * Allows the user to view AND edit certain Dicom tags.
 * @author slotboom
 */
public class DicomTagsManipulationControl extends javax.swing.JPanel
{

    /** 
     * Creates new form DicomTagsManipulationControl.
     */
    public DicomTagsManipulationControl( )
    {
        initComponents( );
    }

    /**
     *
     * Sets the patient related Dicom tags.
     *
     * @param patientRelatedDicomTagsAndValues
     */
    void setPatientRelatedDicomTags( LinkedHashMap<String, DicomTagAndValue> patientRelatedDicomTagsAndValues )
    {
        int cntr = 0;

        ( (DicomTagAndTagValueTableModel)m_patientRelatedDicomTagAndTagValueTable.getModel( ) ).setDataVectorSize( patientRelatedDicomTagsAndValues.keySet( ).size( ), 4 );

        Iterator it = patientRelatedDicomTagsAndValues.keySet( ).iterator( );
        while ( it.hasNext( ) )
        {
            DicomTagAndValue tagsAttribs = (DicomTagAndValue)patientRelatedDicomTagsAndValues.get( it.next( ) );

            ( (DicomTagAndTagValueTableModel)m_patientRelatedDicomTagAndTagValueTable.getModel( ) ).setValueAt( tagsAttribs.getTagDescription( ), cntr, 0 );
            ( (DicomTagAndTagValueTableModel)m_patientRelatedDicomTagAndTagValueTable.getModel( ) ).setValueAt( tagsAttribs.getTagID( ), cntr, 1 );
            ( (DicomTagAndTagValueTableModel)m_patientRelatedDicomTagAndTagValueTable.getModel( ) ).setValueAt( tagsAttribs.getTagEcodingID( ), cntr, 2 );
            ( (DicomTagAndTagValueTableModel)m_patientRelatedDicomTagAndTagValueTable.getModel( ) ).setValueAt( tagsAttribs.getTagValueAsString( ), cntr, 3 );

            cntr++;
        }
    }

    /**
     *
     * Sets the MR related Dicom tags.
     *
     * @param MRRelatedDicomTagsAndValues
     */
    void setMRRelatedDicomTags( LinkedHashMap<String, DicomTagAndValue> mrRelatedDicomTagsAndValues )
    {
        int cntr = 0;

        ( (DicomTagAndTagValueTableModel)m_mrRelatedDicomTagAndTagValueTable.getModel( ) ).setDataVectorSize( mrRelatedDicomTagsAndValues.keySet( ).size( ), 4 );

        Iterator it = mrRelatedDicomTagsAndValues.keySet( ).iterator( );
        while ( it.hasNext( ) )
        {
            DicomTagAndValue tagsAttribs = (DicomTagAndValue)mrRelatedDicomTagsAndValues.get( it.next( ) );

            ( (DicomTagAndTagValueTableModel)m_mrRelatedDicomTagAndTagValueTable.getModel( ) ).setValueAt( tagsAttribs.getTagDescription( ), cntr, 0 );
            ( (DicomTagAndTagValueTableModel)m_mrRelatedDicomTagAndTagValueTable.getModel( ) ).setValueAt( tagsAttribs.getTagID( ), cntr, 1 );
            ( (DicomTagAndTagValueTableModel)m_mrRelatedDicomTagAndTagValueTable.getModel( ) ).setValueAt( tagsAttribs.getTagEcodingID( ), cntr, 2 );
            ( (DicomTagAndTagValueTableModel)m_mrRelatedDicomTagAndTagValueTable.getModel( ) ).setValueAt( tagsAttribs.getTagValueAsString( ), cntr, 3 );

            cntr++;
        }
    }

    /**
     *
     * Sets the patient related Dicom tags.
     *
     * @param patientRelatedDicomTagsAndValues
     */
    void setOtherDicomTags( LinkedHashMap<String, DicomTagAndValue> otherDicomTagsAndValues )
    {
        int cntr = 0;

        ( (DicomTagAndTagValueTableModel)m_otherDicomTagAndTagValueTable.getModel( ) ).setDataVectorSize( otherDicomTagsAndValues.keySet( ).size( ), 4 );

        Iterator it = otherDicomTagsAndValues.keySet( ).iterator( );
        while ( it.hasNext( ) )
        {
            DicomTagAndValue tagsAttribs = (DicomTagAndValue)otherDicomTagsAndValues.get( it.next( ) );

            ( (DicomTagAndTagValueTableModel)m_otherDicomTagAndTagValueTable.getModel( ) ).setValueAt( tagsAttribs.getTagDescription( ), cntr, 0 );
            ( (DicomTagAndTagValueTableModel)m_otherDicomTagAndTagValueTable.getModel( ) ).setValueAt( tagsAttribs.getTagID( ), cntr, 1 );
            ( (DicomTagAndTagValueTableModel)m_otherDicomTagAndTagValueTable.getModel( ) ).setValueAt( tagsAttribs.getTagEcodingID( ), cntr, 2 );
            ( (DicomTagAndTagValueTableModel)m_otherDicomTagAndTagValueTable.getModel( ) ).setValueAt( tagsAttribs.getTagValueAsString( ), cntr, 3 );

            cntr++;
        }
    }

    /**
     *
     * Sets the patient related Dicom tags.
     *
     * @param patientRelatedDicomTagsAndValues
     */
    void setGeometryRelatedDicomTags( LinkedHashMap<String, DicomTagAndValue> geometryRelatedDicomTagsAndValues )
    {
        int cntr = 0;

        ( (DicomTagAndTagValueTableModel)m_geometryRelatedDicomTagAndTagValueTable.getModel( ) ).setDataVectorSize( geometryRelatedDicomTagsAndValues.keySet( ).size( ), 4 );

        Iterator it = geometryRelatedDicomTagsAndValues.keySet( ).iterator( );
        while ( it.hasNext( ) )
        {
            DicomTagAndValue tagsAttribs = (DicomTagAndValue)geometryRelatedDicomTagsAndValues.get( it.next( ) );

            ( (DicomTagAndTagValueTableModel)m_geometryRelatedDicomTagAndTagValueTable.getModel( ) ).setValueAt( tagsAttribs.getTagDescription( ), cntr, 0 );
            ( (DicomTagAndTagValueTableModel)m_geometryRelatedDicomTagAndTagValueTable.getModel( ) ).setValueAt( tagsAttribs.getTagID( ), cntr, 1 );
            ( (DicomTagAndTagValueTableModel)m_geometryRelatedDicomTagAndTagValueTable.getModel( ) ).setValueAt( tagsAttribs.getTagEcodingID( ), cntr, 2 );
            ( (DicomTagAndTagValueTableModel)m_geometryRelatedDicomTagAndTagValueTable.getModel( ) ).setValueAt( tagsAttribs.getTagValueAsString( ), cntr, 3 );

            cntr++;
        }
    }

    /**
     *
     * Sets the patient related Dicom tags.
     *
     * @param patientRelatedDicomTagsAndValues
     */
    void setStudySeriesInstanceRelatedDicomTags( LinkedHashMap<String, DicomTagAndValue> studySeriesInstanceDicomTagsAndValues )
    {
        int cntr = 0;

        ( (DicomTagAndTagValueTableModel)m_studySeriesInstanceRelatedDicomTagAndTagValueTable.getModel( ) ).setDataVectorSize( studySeriesInstanceDicomTagsAndValues.keySet( ).size( ), 4 );

        Iterator it = studySeriesInstanceDicomTagsAndValues.keySet( ).iterator( );
        while ( it.hasNext( ) )
        {
            DicomTagAndValue tagsAttribs = (DicomTagAndValue)studySeriesInstanceDicomTagsAndValues.get( it.next( ) );

            ( (DicomTagAndTagValueTableModel)m_studySeriesInstanceRelatedDicomTagAndTagValueTable.getModel( ) ).setValueAt( tagsAttribs.getTagDescription( ), cntr, 0 );
            ( (DicomTagAndTagValueTableModel)m_studySeriesInstanceRelatedDicomTagAndTagValueTable.getModel( ) ).setValueAt( tagsAttribs.getTagID( ), cntr, 1 );
            ( (DicomTagAndTagValueTableModel)m_studySeriesInstanceRelatedDicomTagAndTagValueTable.getModel( ) ).setValueAt( tagsAttribs.getTagEcodingID( ), cntr, 2 );
            ( (DicomTagAndTagValueTableModel)m_studySeriesInstanceRelatedDicomTagAndTagValueTable.getModel( ) ).setValueAt( tagsAttribs.getTagValueAsString( ), cntr, 3 );

            cntr++;
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings( "unchecked" )
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        m_dicomTagGroupsTabbedPane = new javax.swing.JTabbedPane();
        m_patientRelatedTagsScrollPane = new javax.swing.JScrollPane();
        m_patientRelatedDicomTagAndTagValueTable = new org.spectrim.dicom.DicomTagAndTagValueTable();
        m_studySeriesInstanceTagsScrollPanel = new javax.swing.JScrollPane();
        m_studySeriesInstanceRelatedDicomTagAndTagValueTable = new org.spectrim.dicom.DicomTagAndTagValueTable();
        m_geometryRelatedTagsScrollPane = new javax.swing.JScrollPane();
        m_geometryRelatedDicomTagAndTagValueTable = new org.spectrim.dicom.DicomTagAndTagValueTable();
        m_mrRelatedTagsScrollPane = new javax.swing.JScrollPane();
        m_mrRelatedDicomTagAndTagValueTable = new org.spectrim.dicom.DicomTagAndTagValueTable();
        m_otherTagsScrollPane = new javax.swing.JScrollPane();
        m_otherDicomTagAndTagValueTable = new org.spectrim.dicom.DicomTagAndTagValueTable();

        m_patientRelatedTagsScrollPane.setViewportView(m_patientRelatedDicomTagAndTagValueTable);

        m_dicomTagGroupsTabbedPane.addTab("Patient related tags", m_patientRelatedTagsScrollPane);

        m_studySeriesInstanceTagsScrollPanel.setViewportView(m_studySeriesInstanceRelatedDicomTagAndTagValueTable);

        m_dicomTagGroupsTabbedPane.addTab("Study/Series/Instance tags", m_studySeriesInstanceTagsScrollPanel);

        m_geometryRelatedTagsScrollPane.setViewportView(m_geometryRelatedDicomTagAndTagValueTable);

        m_dicomTagGroupsTabbedPane.addTab("Geometry related tags", m_geometryRelatedTagsScrollPane);

        m_mrRelatedTagsScrollPane.setViewportView(m_mrRelatedDicomTagAndTagValueTable);

        m_dicomTagGroupsTabbedPane.addTab("MR-related tags", m_mrRelatedTagsScrollPane);

        m_otherTagsScrollPane.setViewportView(m_otherDicomTagAndTagValueTable);

        m_dicomTagGroupsTabbedPane.addTab("Other tags", m_otherTagsScrollPane);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(m_dicomTagGroupsTabbedPane, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 786, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(m_dicomTagGroupsTabbedPane, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(80, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTabbedPane m_dicomTagGroupsTabbedPane;
    private org.spectrim.dicom.DicomTagAndTagValueTable m_geometryRelatedDicomTagAndTagValueTable;
    private javax.swing.JScrollPane m_geometryRelatedTagsScrollPane;
    private org.spectrim.dicom.DicomTagAndTagValueTable m_mrRelatedDicomTagAndTagValueTable;
    private javax.swing.JScrollPane m_mrRelatedTagsScrollPane;
    private org.spectrim.dicom.DicomTagAndTagValueTable m_otherDicomTagAndTagValueTable;
    private javax.swing.JScrollPane m_otherTagsScrollPane;
    private org.spectrim.dicom.DicomTagAndTagValueTable m_patientRelatedDicomTagAndTagValueTable;
    private javax.swing.JScrollPane m_patientRelatedTagsScrollPane;
    private org.spectrim.dicom.DicomTagAndTagValueTable m_studySeriesInstanceRelatedDicomTagAndTagValueTable;
    private javax.swing.JScrollPane m_studySeriesInstanceTagsScrollPanel;
    // End of variables declaration//GEN-END:variables

}
