/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.geometricobjects;

import org.spectrim.imagegraphicobjects.Point3D;
import org.apache.commons.math3.linear.Array2DRowRealMatrix;
import org.apache.commons.math3.linear.ArrayRealVector;
import org.apache.commons.math3.linear.DecompositionSolver;
import org.apache.commons.math3.linear.LUDecomposition;
import org.apache.commons.math3.linear.RealMatrix;
import org.apache.commons.math3.linear.RealVector;

/**
 *
 * @author nunopbarros
 */
public class ImagePlane {

    public Point3D p;
    public Point3D v1;
    public Point3D v2;

    public ImagePlane(Point3D p, Point3D v1, Point3D v2) {
        this.p = p;
        this.v1 = v1;
        this.v2 = v2;
    }

    public boolean IsInPlane(Point3D point) {
        Point3D v3 = Point3D.crossProduct(v1, v2);
        v3.normalize();
        boolean res = false;
        
        double[][] matrixData = {
            {v1.m_x1, v2.m_x1, v3.m_x1},
            {v1.m_x2, v2.m_x2, v3.m_x2},
            {v1.m_x3, v2.m_x3, v3.m_x3}};
        
        RealVector constants = new ArrayRealVector(new double[]{point.m_x1-p.m_x1,point.m_x2-p.m_x2,point.m_x3-p.m_x3}, false);
        RealMatrix n = new Array2DRowRealMatrix(matrixData);
        DecompositionSolver solver = new LUDecomposition(n).getSolver();
        try {
            RealVector solution = solver.solve(constants);
            double[] sol;
            sol = solution.toArray();
            if (sol[2] > -0.5 && sol[2] < 0.5) {
                res = true;
            }
        } catch (Exception ex) {
        }
        return res;
    }
}
