/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.geometricobjects;

import org.spectrim.imagegraphicobjects.Point3D;
import java.util.LinkedList;


/**
 *
 * @author Giezi
 */
public class Polygon3D {
    
    
    public LinkedList<Point3D> points;

    public Polygon3D() {
        points = new LinkedList<>();
    }

    public Polygon3D(double[] x, double[] y, double[] z, int i) {
        points = new LinkedList<>();
        for (int j = 0; j < i; j++) {
            points.add(new Point3D(x[j],y[j],z[j]));
        }
    }
    
    public Polygon3D Clone()
    {
        Polygon3D pl = new Polygon3D();
        for(Point3D p: points)
        {
            pl.addPoint(p.Clone());
        }
        return pl;
    }
    
    /*public Polygon3D(Polygon p, int z)
    {
        super(p.xpoints,p.ypoints,p.npoints);
        zpoints = new int[p.npoints];
        java.util.Arrays.fill(zpoints,z);
    }*/

    public void addPoint(double x, double y, double z) {
        points.add(new Point3D(x,y,z));
    }
    
    public void addPoint(Point3D p)
    {
        points.add(p);
    }
    
    public LinkedList<Point3D> getPoints()
    {
        return points;
    }
    
    public Point3D getPoint(int pos)
    {
        return points.get(pos);
    }
    
    public double[] getXPoints()
    {
        double[] x = new double[points.size()];
        int i = 0;
        for(Point3D p: points)
            x[i++] = p.m_x1;
        return x;
    }
    
    public double[] getYPoints()
    {
        double[] y = new double[points.size()];
        int i = 0;
        for(Point3D p: points)
            y[i++] = p.m_x2;
        return y;
    }
    
    public double[] getZPoints()
    {
        double[] z = new double[points.size()];
        int i = 0;
        for(Point3D p: points)
            z[i++] = p.m_x3;
        return z;
    }
    
    /**
     * Projects the polygon on the plane and returns the new polygon
     */
    public static Polygon3D projectPolygonOnPlane(Polygon3D plg, Point3D p, Point3D e1, Point3D e2)
    {
        Polygon3D prjctPlg = new Polygon3D();
        for(Point3D pt:plg.getPoints())
        {
            prjctPlg.addPoint(pt.projectPointOnPlane(pt, p, e1, e2));
        }
        return prjctPlg;
    }
    
    /**
     * returns the center of the polygon
     */
    public Point3D getCenter()
    {
        double x = 0;
        int xc = 0;
        double y = 0;
        int yc = 0;
        double z = 0;
        int zc = 0;
        for(double xi:getXPoints())
        {
            x += xi;
            xc++;
        }
        for(double yi:getYPoints())
        {
            y += yi;
            yc++;
        }
        for(double zi:getZPoints())
        {
            z += zi;
            zc++;
        }
        return new Point3D(x / ((double)xc),y / ((double)yc),z / ((double)zc));
    }
    
    /**
     * returns the maximum distance from the point to all the points in the polygon
     */
    public double getMaxDitanceToPoints(Point3D p)
    {
        double dist = Double.MIN_VALUE;
        for(Point3D pt:points)
            dist = Point3D.getDistance(pt, p) > dist ? Point3D.getDistance(pt, p):dist;
        return dist;
    }
    
    /**
     * returns the minimum distance of the polygon to the point
     */
//    public double getMinimumDistanceToPoint(Point3D p)
//    {
//        double dist = Double.MAX_VALUE;
//        for(Point3D pt:points)
//            dist = Point3D.getDistance(pt, p) < dist ? Point3D.getDistance(pt, p):dist;
//        return dist;
//    }
    
    /**
     * projects the polygon on the plane and returns the xy coordinates in the new
     * space created by the reference vectors of the plane
     */
//    public static Polygon projectPolygonOnReferencePlane(Polygon3D plg, Point3D p, Point3D e1, Point3D e2)
//    {
//        /*plg = Polygon3D.projectPolygonOnPlane(plg, p, e1, e2);
//        e1 = e1.normalize();*/
//        
//        return null;
//    }
    
    public int size()
    {
        return points.size();
    }
    
    public void replacePoint(int position, Point3D pt)
    {
        points.get(position).setPoint(pt);
    }
    
    public void replaceLastPoint(Point3D pt)
    {
        points.getLast().setPoint(pt);
    }
    
    public double getPerimeter()
    {
        double pr = 0.0;
        for(int i = 0; i < points.size(); i ++)
        {
            pr += Point3D.getDistance(points.get(i), points.get((i + 1) % points.size()));
        }
        return pr;
    }
    
    /*
    public boolean contains(Point3D p)
    {
        Polygon p1 = new Polygon();
        return false;
    }
    */
    
    /*public Polygon3D getBounds3D() {
        Rectangle2D rect = super.getBounds2D(); //To change body of generated methods, choose Tools | Templates).
        int [] z = new int[2];
        int[] sortedArray = new int[npoints];
        System.arraycopy(zpoints, 0, sortedArray, 0, npoints);
        java.util.Arrays.sort(sortedArray);
        z[0] = sortedArray[0];
        z[1] = sortedArray[npoints - 1];
        Polygon3D
    }*/
    /*
    public int getMinX()
    {
        int[] sortedArray = new int[npoints];
        System.arraycopy(xpoints, 0, sortedArray, 0, npoints);
        java.util.Arrays.sort(sortedArray);
        return sortedArray[0];
    }
    
    public int getMaxX()
    {
        int[] sortedArray = new int[npoints];
        System.arraycopy(xpoints, 0, sortedArray, 0, npoints);
        java.util.Arrays.sort(sortedArray);
        return sortedArray[npoints - 1];
    }    
    
    public int getMinY()
    {
        int[] sortedArray = new int[npoints];
        System.arraycopy(ypoints, 0, sortedArray, 0, npoints);
        java.util.Arrays.sort(sortedArray);
        return sortedArray[0];
    }
    
    public int getMaxY()
    {
        int[] sortedArray = new int[npoints];
        System.arraycopy(ypoints, 0, sortedArray, 0, npoints);
        java.util.Arrays.sort(sortedArray);
        return sortedArray[npoints - 1];
    }  
    
    public int getMinZ()
    {
        int[] sortedArray = new int[npoints];
        System.arraycopy(zpoints, 0, sortedArray, 0, npoints);
        java.util.Arrays.sort(sortedArray);
        return sortedArray[0];
    }
    
    public int getMaxZ()
    {
        int[] sortedArray = new int[npoints];
        System.arraycopy(zpoints, 0, sortedArray, 0, npoints);
        java.util.Arrays.sort(sortedArray);
        return sortedArray[npoints - 1];
    }  */
}
