/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.grid;

import org.spectrim.imagegraphicobjects.Point3D;
import org.spectrim.geometricobjects.Cube3D;

/**
 *
 * @author nunopbarros
 */
public class SaturationBand {

    public double thickness;
    public Point3D position;
    public Point3D orientation;
    public Point3D p1;
    public Point3D p2;
    public Point3D p3;
    public Point3D p4;
    public Point3D p5;
    public Point3D p6;
    public Point3D p7;
    public Point3D p8;
    double pseudoInf = 1000;

    public SaturationBand(double t, double p1, double p2, double p3, double o1, double o2, double o3) {
        thickness = t;
        position = new Point3D(p1, p2, p3);
        orientation = new Point3D(o1, o2, o3);
        calcPoints();
    }

    private void calcPoints() {
        Point3D v2 = new Point3D(orientation.m_x2, -orientation.m_x1, 0);
        Point3D v3 = Point3D.crossProduct(orientation, v2);
        orientation = Point3D.normalize(orientation);
        v2 = Point3D.normalize(v2);
        v3 = Point3D.normalize(v3);

        p5 = Point3D.vectorCombination(orientation, v2, v3, -thickness / 2, -pseudoInf, -pseudoInf);
        p3 = Point3D.vectorCombination(orientation, v2, v3, thickness / 2, pseudoInf, pseudoInf);
        p6 = Point3D.vectorCombination(orientation, v2, v3, thickness / 2, -pseudoInf, -pseudoInf);
        p1 = Point3D.vectorCombination(orientation, v2, v3, -thickness / 2, pseudoInf, -pseudoInf);
        p8 = Point3D.vectorCombination(orientation, v2, v3, -thickness / 2, -pseudoInf, pseudoInf);
        p2 = Point3D.vectorCombination(orientation, v2, v3, thickness / 2, pseudoInf, -pseudoInf);
        p4 = Point3D.vectorCombination(orientation, v2, v3, -thickness / 2, pseudoInf, pseudoInf);
        p7 = Point3D.vectorCombination(orientation, v2, v3, thickness / 2, -pseudoInf, pseudoInf);
        p1.translate(position);
        p2.translate(position);
        p3.translate(position);
        p4.translate(position);
        p5.translate(position);
        p6.translate(position);
        p7.translate(position);
        p8.translate(position);
    }
}
