/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.spectrim.imagegraphicobjects;

import java.awt.Color;
import java.awt.Point;

/**
 *
 * @author slotboom
 */
public class Distance
{
 
    /**
     * Default constructor
     */
    public Distance( )
    {
    }

    /**
     * Creates a Distance object
     * @param begin
     * @param end
     */
    public Distance( Point begin, Point end )
    {
        m_beginPoint = begin;
        m_endPoint = end;
        m_imageNumber = -1;
        m_distanceNumber = -1;
        m_distanceName = "no_name";
        m_distanceColor = Color.CYAN;
    }

    /**
     *
     * @param begin
     * @param end
     * @param imageNumber
     */
    public Distance( Point begin, Point end, int imageNumber )
    {
        m_beginPoint = begin;
        m_endPoint = end;
        m_imageNumber =imageNumber;
        m_distanceNumber = -1;
        m_distanceName = "no_name";
        m_distanceColor = Color.CYAN;
    }

    /**
     *
     * @param begin
     * @param end
     * @param imageNumber
     */
    public Distance( int distanceNumber, String distanceName, float distance, int imageNumber,
                     Point begin, Point end, Point3D begin3D, Point3D end3D, Color color )
    {
        m_distanceNumber = distanceNumber;

        m_distance = distance;

        m_distanceName = distanceName;

        m_beginPoint = begin;
        m_endPoint = end;

        m_beginPoint3D = begin3D;
        m_endPoint3D = end3D;


        m_imageNumber =imageNumber;
        m_distanceColor = color;
    }


    /**
     * Returns the distance (float) value
     * @return
     */
    public float getDistanceValue( )
    {
        return m_distance;
    }

    /**
     *  Sets the distance (float) value
     * @return
     */
    public void setDistanceValue( float distance )
    {
        m_distance = distance;
    }
    
    /**
     * Returns the image number the distance belongs to
     * @return
     */
    public int getImageNumber( )
    {
        return m_imageNumber;
    }

    /**
     * Sets the image number the distance belongs to
     * @return
     */
    public void setImageNumber( int imageNumber )
    {
        m_imageNumber = imageNumber;
    }

    /**
     * Returns the beginning point of the distance
     * @return
     */
    public Point getBeginPoint( )
    {
        return m_beginPoint;
    }

    /**
     * Sets the beginning point of the distance
     * @return
     */
    public void setBeginPoint( Point beginPoint )
    {
        m_beginPoint = beginPoint;
    }

    /**
     * Returns the end point of the distance
     * @return
     */
    public Point getEndPoint( )
    {
        return m_endPoint;
    }

    /**
     * Sets the end point of the distance
     * @return
     */
    public void setEndPoint( Point endPoint )
    {
        m_endPoint = endPoint;
    }


    /**
     * Returns the beginning point of the distance
     * @return
     */
    public Point3D getBeginPoint3D( )
    {
        return m_beginPoint3D;
    }

    /**
     * Sets the beginning point of the distance
     * @return
     */
    public void setBeginPoint3D( Point3D beginPoint3D )
    {
        m_beginPoint3D = beginPoint3D;
    }

    /**
     * Returns the end point of the distance
     * @return
     */
    public Point3D getEndPoint3D( )
    {
        return m_endPoint3D;
    }

    /**
     * Sets the end point of the distance
     * @return
     */
    public void setEndPoint3D( Point3D endPoint3D )
    {
        m_endPoint3D = endPoint3D;
    }


    /** 
     * Sets the name of the distance object
     * @param name
     */
    public void setDistanceName( String name )
    {
        m_distanceName = name;
    }

    /**
     * Sets the name of the distance object
     * @param name
     */
    public String getDistanceName( )
    {
        return m_distanceName;
    }

    /**
     * Sets the name of the distance object
     * @param name
     */
    public Color getDistanceColor( )
    {
        return m_distanceColor;
    }


     /**
     * Sets the name of the distance object
     * @param name
     */
    public void setDistanceColor( Color color )
    {
        m_distanceColor = color;
    }

    /**
     * Sets the name of the distance object
     * @param name
     */
    public void setDistanceNumber( int number )
    {
        m_distanceNumber = number;
    }


    /**
     * Sets the name of the distance object
     * @param name
     */
    public int getDistanceNumber( )
    {
        return m_distanceNumber;
    }



    // Returns the image number it belongs to
    private int m_imageNumber = -1;

    // beginning and ending points in pixel values
    private Point m_beginPoint;
    private Point m_endPoint;

    private Point3D m_beginPoint3D;
    private Point3D m_endPoint3D;

    private float m_distance;

    private String m_distanceName = null;
    private int m_distanceNumber = -1;
    private Color m_distanceColor = Color.CYAN;
}
