/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * RegionManupulationFrame.java
 *
 * Created on 29-Jun-2009, 08:08:28
 */

package org.spectrim.imagegraphicobjects;

import java.awt.Color;
import java.awt.Point;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.text.DecimalFormat;
import javax.swing.JFrame;
import org.spectrim.dicom.DicomSliceCanvasPolyDraw;

/**
 * Enables the manipulation of regions (ie affine transformations).
 * @author slotboom
 */
public class RegionManipulationFrame extends javax.swing.JFrame 
{


    /** 
     * Creates new form RegionManupulationFrame.
     * @param parent
     * @param polygon
     * @param image
     * @param createNewPolygon
     * @param title
     */
    public RegionManipulationFrame( JFrame parent, 
                                    RegioPolygon polygon, 
                                    DicomSliceCanvasPolyDraw image, 
                                    boolean createNewPolygon,
                                    String title )
    {

        setTitle( title );

        //setTitle( "Affine transformation of regions" );

        m_createNewPolygon = createNewPolygon;

        m_originalPolygon = new RegioPolygon( polygon );

        m_originalPolygon.setColor( Color.YELLOW );
        
        m_transformedPolygon = new RegioPolygon( polygon );

        m_parent = parent;
        m_image = image;

        if ( m_createNewPolygon == true )
        {
            image.addPolygon( m_transformedPolygon );
        }

        initComponents( );

        Point p = m_transformedPolygon.getPointOfGravity( );

        m_originalTranslationX = p.x;
        m_originalTranslationY = p.y;

        m_regionNameTextField.setText( m_transformedPolygon.getLabel( ) );
        m_horizontalScaleTextField.setText( "1.0" );
        m_verticalScaleTextField.setText( "1.0" );
        m_rotationAngleStepTextfield.setText( "" + m_currentRotation );

        m_roiCenterX.setText( "" + p.x );
        m_roiCenterY.setText( "" + p.y );

        // add window listener necessary to handle the window closing
        // event properly
        addWindowListener(
            new WindowAdapter( )
            {
                @Override
                public void windowClosing( WindowEvent event )
                {
                   setVisible( false );
                }
            }
        );

        pack( );
        // Put the Dialog nicely in the middle of its parent
        Point centerParent = new Point( m_parent.getX( ) + ( m_parent.getWidth( ) - getWidth( ) ) / 2,
                                        m_parent.getY( ) + ( m_parent.getHeight( ) - getHeight( ) ) / 2 );

        setLocation( centerParent );
        setVisible( true );
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings( "unchecked" )
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jPanel1 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        m_horizontalScaleTextField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        m_verticalScaleTextField = new javax.swing.JTextField();
        m_keepAspectRatioCheckBox = new javax.swing.JCheckBox();
        m_horizontalScaleUpButton = new javax.swing.JButton();
        m_horizontalScaleDownButton = new javax.swing.JButton();
        m_verticalScaleDownButton = new javax.swing.JButton();
        m_verticalScaleUpButton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        m_roiMoveUpButton = new javax.swing.JButton();
        m_roiCenterX = new javax.swing.JTextField();
        m_roiCenterY = new javax.swing.JTextField();
        m_roiMoveRightButton = new javax.swing.JButton();
        m_roiMoveLeftStepButton = new javax.swing.JButton();
        m_roiMoveDownButton = new javax.swing.JButton();
        jLabel4 = new javax.swing.JLabel();
        m_rotateLeftStepButton = new javax.swing.JButton();
        m_rotationAngleStepTextfield = new javax.swing.JTextField();
        m_rotateRightStepButton = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();
        m_applyButton = new javax.swing.JButton();
        m_applyAndQuitButton = new javax.swing.JButton();
        m_undoButton = new javax.swing.JButton();
        m_cancelButton = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        m_regionNameTextField = new javax.swing.JTextField();
        m_regionNameLabel = new javax.swing.JLabel();

        jLabel1.setText("jLabel1");

        jTextArea1.setColumns(20);
        jTextArea1.setRows(5);
        jScrollPane1.setViewportView(jTextArea1);

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Scale region"));

        jLabel2.setText("Horizontal scale");

        m_horizontalScaleTextField.setText("1");

        jLabel3.setText("Vertical scale");

        m_verticalScaleTextField.setText("1");

        m_keepAspectRatioCheckBox.setText("Keep aspect ratio");
        m_keepAspectRatioCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_keepAspectRatioCheckBoxActionPerformed(evt);
            }
        });

        m_horizontalScaleUpButton.setText(">");
        m_horizontalScaleUpButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_horizontalScaleUpButtonActionPerformed(evt);
            }
        });

        m_horizontalScaleDownButton.setText("<");
        m_horizontalScaleDownButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_horizontalScaleDownButtonActionPerformed(evt);
            }
        });

        m_verticalScaleDownButton.setText("<");
        m_verticalScaleDownButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_verticalScaleDownButtonActionPerformed(evt);
            }
        });

        m_verticalScaleUpButton.setText(">");
        m_verticalScaleUpButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_verticalScaleUpButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel3)
                    .addComponent(jLabel2))
                .addGap(12, 12, 12)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(m_horizontalScaleDownButton)
                            .addComponent(m_verticalScaleDownButton))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(m_horizontalScaleTextField, javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(m_verticalScaleTextField, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 83, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(m_verticalScaleUpButton)
                            .addComponent(m_horizontalScaleUpButton)))
                    .addComponent(m_keepAspectRatioCheckBox))
                .addContainerGap(124, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_horizontalScaleTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2)
                    .addComponent(m_horizontalScaleUpButton)
                    .addComponent(m_horizontalScaleDownButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_verticalScaleTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3)
                    .addComponent(m_verticalScaleDownButton)
                    .addComponent(m_verticalScaleUpButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(m_keepAspectRatioCheckBox))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Translate & rotate region"));

        m_roiMoveUpButton.setText("up");
        m_roiMoveUpButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_roiMoveUpButtonActionPerformed(evt);
            }
        });

        m_roiCenterX.setText("0");

        m_roiCenterY.setText("0");

        m_roiMoveRightButton.setText("right");
        m_roiMoveRightButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_roiMoveRightButtonActionPerformed(evt);
            }
        });

        m_roiMoveLeftStepButton.setText("left");
        m_roiMoveLeftStepButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_roiMoveLeftStepButtonActionPerformed(evt);
            }
        });

        m_roiMoveDownButton.setText("down");
        m_roiMoveDownButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_roiMoveDownButtonActionPerformed(evt);
            }
        });

        jLabel4.setText("Rotate (degrees)");

        m_rotateLeftStepButton.setText("<");
        m_rotateLeftStepButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_rotateLeftStepButtonActionPerformed(evt);
            }
        });

        m_rotateRightStepButton.setText(">");
        m_rotateRightStepButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_rotateRightStepButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(m_roiMoveLeftStepButton, javax.swing.GroupLayout.PREFERRED_SIZE, 99, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(m_roiMoveDownButton, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(m_roiMoveUpButton, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(m_roiCenterX, javax.swing.GroupLayout.PREFERRED_SIZE, 60, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(m_roiCenterY, javax.swing.GroupLayout.PREFERRED_SIZE, 60, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(m_roiMoveRightButton, javax.swing.GroupLayout.PREFERRED_SIZE, 106, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jLabel4)
                        .addGap(8, 8, 8)
                        .addComponent(m_rotateLeftStepButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(m_rotationAngleStepTextfield, javax.swing.GroupLayout.PREFERRED_SIZE, 83, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(m_rotateRightStepButton)))
                .addContainerGap(36, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(m_roiMoveUpButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_roiCenterX, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(m_roiCenterY, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(m_roiMoveRightButton)
                    .addComponent(m_roiMoveLeftStepButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(m_roiMoveDownButton)
                .addGap(33, 33, 33)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(m_rotateLeftStepButton)
                    .addComponent(m_rotationAngleStepTextfield, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(m_rotateRightStepButton))
                .addContainerGap(22, Short.MAX_VALUE))
        );

        m_applyButton.setText("Apply");
        m_applyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_applyButtonActionPerformed(evt);
            }
        });

        m_applyAndQuitButton.setText("Apply & Quit");
        m_applyAndQuitButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_applyAndQuitButtonActionPerformed(evt);
            }
        });

        m_undoButton.setText("Undo");
        m_undoButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_undoButtonActionPerformed(evt);
            }
        });

        m_cancelButton.setText("Cancel");
        m_cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_cancelButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addComponent(m_applyButton, javax.swing.GroupLayout.PREFERRED_SIZE, 91, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(m_applyAndQuitButton, javax.swing.GroupLayout.PREFERRED_SIZE, 100, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(m_undoButton, javax.swing.GroupLayout.PREFERRED_SIZE, 78, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(m_cancelButton, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(m_applyButton)
                .addComponent(m_applyAndQuitButton)
                .addComponent(m_undoButton)
                .addComponent(m_cancelButton))
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));

        m_regionNameLabel.setText("Region name");

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGap(30, 30, 30)
                .addComponent(m_regionNameLabel)
                .addGap(18, 18, 18)
                .addComponent(m_regionNameTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 259, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(m_regionNameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addComponent(m_regionNameLabel))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(18, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void m_applyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_applyButtonActionPerformed
        
        m_transformedPolygon.setLabel( m_regionNameTextField.getText( ) );
        m_image.repaint( );
        m_image.update( true );

    }//GEN-LAST:event_m_applyButtonActionPerformed

    /**
     * Moves currently selected ROI upwards.
     * @param evt
     */
    private void m_roiMoveUpButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_roiMoveUpButtonActionPerformed

        m_currentTranslationY = m_currentTranslationY + 1;
        m_roiCenterY.setText( "" +  ( m_originalTranslationY + m_currentTranslationY )  );

        m_image.deletePoly( m_image.getSelectedPolygon( ) );

        m_transformedPolygon = new RegioPolygon( m_originalPolygon );

        m_transformedPolygon.setLabel( m_regionNameTextField.getText( ) );

        m_image.addPolygon( m_transformedPolygon );

        m_image.getSelectedPolygon( ).setHorizontalScalingFactor( (float)m_totalHorizontalScale );
        m_image.getSelectedPolygon( ).setVerticalScalingFactor( (float)m_totalVerticalScale );
        
        m_image.getSelectedPolygon( ).rotateAboutPointOfGravity( m_currentRotation );
        m_image.getSelectedPolygon( ).setTranslatePointOfGravity( new Point( -m_currentTranslationX , m_currentTranslationY ) );

        m_image.repaint( );
        m_image.update( true );
    }//GEN-LAST:event_m_roiMoveUpButtonActionPerformed

    /**
     * Moves currently selected ROI downwards.
     * @param evt
     */
    private void m_roiMoveDownButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_roiMoveDownButtonActionPerformed
        m_currentTranslationY = m_currentTranslationY - 1;
        m_roiCenterY.setText( "" +  ( m_originalTranslationY + m_currentTranslationY ) );

        m_image.deletePoly( m_image.getSelectedPolygon( ) );

        m_transformedPolygon = new RegioPolygon( m_originalPolygon );

         m_transformedPolygon.setLabel( m_regionNameTextField.getText( ) );

        m_image.addPolygon( m_transformedPolygon );

        m_image.getSelectedPolygon( ).setHorizontalScalingFactor( (float)m_totalHorizontalScale );
        m_image.getSelectedPolygon( ).setVerticalScalingFactor( (float)m_totalVerticalScale );

        m_image.getSelectedPolygon( ).rotateAboutPointOfGravity( m_currentRotation );
        m_image.getSelectedPolygon( ).setTranslatePointOfGravity( new Point( -m_currentTranslationX , m_currentTranslationY ) );

        m_image.repaint( );
        m_image.update( true );
    }//GEN-LAST:event_m_roiMoveDownButtonActionPerformed

    /**
     * Moves currently selected ROI to the left.
     * @param evt
     */
    private void m_roiMoveLeftStepButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_roiMoveLeftStepButtonActionPerformed
         
        m_currentTranslationX = m_currentTranslationX - 1;
        m_roiCenterX.setText( "" + ( m_originalTranslationX + m_currentTranslationX ) );

        m_image.deletePoly( m_image.getSelectedPolygon( ) );

        m_transformedPolygon = new RegioPolygon( m_originalPolygon );

        m_transformedPolygon.setLabel( m_regionNameTextField.getText( ) );

        m_image.addPolygon( m_transformedPolygon );

        m_image.getSelectedPolygon( ).setHorizontalScalingFactor( (float)m_totalHorizontalScale );
        m_image.getSelectedPolygon( ).setVerticalScalingFactor( (float)m_totalVerticalScale );

        m_image.getSelectedPolygon( ).rotateAboutPointOfGravity( m_currentRotation );
        m_image.getSelectedPolygon( ).setTranslatePointOfGravity( new Point( -m_currentTranslationX , m_currentTranslationY ) );

        m_image.repaint( );
        m_image.update( true );
    }//GEN-LAST:event_m_roiMoveLeftStepButtonActionPerformed


    /**
     * Moves the currently selected ROI to the right
     * @param evt
     */
    private void m_roiMoveRightButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_roiMoveRightButtonActionPerformed

        m_currentTranslationX = m_currentTranslationX + 1;
        m_roiCenterX.setText( "" + ( m_originalTranslationX + m_currentTranslationX ) );

        m_image.deletePoly( m_image.getSelectedPolygon( ) );

        m_transformedPolygon = new RegioPolygon( m_originalPolygon );

         m_transformedPolygon.setLabel( m_regionNameTextField.getText( ) );

        m_image.addPolygon( m_transformedPolygon );


        m_image.getSelectedPolygon( ).setHorizontalScalingFactor( (float)m_totalHorizontalScale );
        m_image.getSelectedPolygon( ).setVerticalScalingFactor( (float)m_totalVerticalScale );


        m_image.getSelectedPolygon( ).rotateAboutPointOfGravity( m_currentRotation );
        m_image.getSelectedPolygon( ).setTranslatePointOfGravity( new Point( -m_currentTranslationX , m_currentTranslationY ) );

        m_image.repaint( );
        m_image.update( true );
    }//GEN-LAST:event_m_roiMoveRightButtonActionPerformed

    

    /**
     * Undo all translations and rotations : return to original settings
     * @param evt
     */
    private void m_undoButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_undoButtonActionPerformed

        m_image.deletePoly( m_image.getSelectedPolygon( ) );
        
        m_transformedPolygon = new RegioPolygon( m_originalPolygon );

        m_transformedPolygon.setLabel( m_regionNameTextField.getText( ) );

        m_image.addPolygon( m_transformedPolygon );
        
        m_image.repaint( );
        m_image.update( true );

        m_regionNameTextField.setText( m_originalPolygon.getLabel( ) );
        m_roiCenterX.setText( "" + m_originalPolygon.getPointOfGravity( ).x );
        m_roiCenterY.setText( "" + m_originalPolygon.getPointOfGravity( ).y );
        m_rotationAngleStepTextfield.setText( "" + 0.0 );

        m_currentRotation = 0;
        m_currentTranslationX = 0;
        m_currentTranslationY = 0;

        m_verticalScaleTextField.setText( "1.0" );
        m_horizontalScaleTextField.setText( "1.0" );

        m_totalHorizontalScale = 1.0;
        m_totalVerticalScale = 1.0;

}//GEN-LAST:event_m_undoButtonActionPerformed

    /**
     * Rotates the selected polygon rightward
     * @param evt
     */
    private void m_rotateRightStepButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_rotateRightStepButtonActionPerformed


        m_currentRotation += m_rotateDelta;
        m_rotationAngleStepTextfield.setText( "" + m_currentRotation );

        m_image.deletePoly( m_image.getSelectedPolygon( ) );

        m_transformedPolygon = new RegioPolygon( m_originalPolygon );

        m_transformedPolygon.setLabel( m_regionNameTextField.getText( ) );
        m_image.addPolygon( m_transformedPolygon );
        
        m_image.getSelectedPolygon( ).setHorizontalScalingFactor( (float)m_totalHorizontalScale );
        m_image.getSelectedPolygon( ).setVerticalScalingFactor( (float)m_totalVerticalScale );

        m_image.getSelectedPolygon( ).rotateAboutPointOfGravity( m_currentRotation );
        m_image.getSelectedPolygon( ).setTranslatePointOfGravity( new Point( -m_currentTranslationX , m_currentTranslationY ) );

        m_image.repaint( );
        m_image.update( true );
        
    }//GEN-LAST:event_m_rotateRightStepButtonActionPerformed

    /**
     * Rotates the selected polygon leftward
     * @param evt
     */
    private void m_rotateLeftStepButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_rotateLeftStepButtonActionPerformed

        m_currentRotation -= m_rotateDelta;
        m_rotationAngleStepTextfield.setText( "" + m_currentRotation );

        m_image.deletePoly( m_image.getSelectedPolygon( ) );

        m_transformedPolygon = new RegioPolygon( m_originalPolygon );

        m_transformedPolygon.setLabel( m_regionNameTextField.getText( ) );
        m_image.addPolygon( m_transformedPolygon );
        
        m_image.getSelectedPolygon( ).setHorizontalScalingFactor( (float)m_totalHorizontalScale );
        m_image.getSelectedPolygon( ).setVerticalScalingFactor( (float)m_totalVerticalScale );

        m_image.getSelectedPolygon( ).rotateAboutPointOfGravity( m_currentRotation );
        m_image.getSelectedPolygon( ).setTranslatePointOfGravity( new Point( -m_currentTranslationX , m_currentTranslationY ) );

        m_image.repaint( );
        m_image.update( true );      
    }//GEN-LAST:event_m_rotateLeftStepButtonActionPerformed

    /**
     * Scales up the horizontal zoom factor of the currently selected ROI
     * @param evt
     */
    private void m_horizontalScaleUpButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_horizontalScaleUpButtonActionPerformed
        m_image.deletePoly( m_image.getSelectedPolygon( ) );
        m_transformedPolygon = new RegioPolygon( m_originalPolygon );
        
        m_transformedPolygon.setLabel( m_regionNameTextField.getText( ) );

        m_image.addPolygon( m_transformedPolygon );

        m_totalHorizontalScale = m_totalHorizontalScale + 0.1;
        
        if ( m_keepAspectRatioCheckBox.isSelected( ) )
        {
            m_totalVerticalScale = m_totalHorizontalScale;
            m_horizontalScaleTextField.setText( "" + m_formatter.format( m_totalHorizontalScale ) );
            m_verticalScaleTextField.setText( "" + m_formatter.format( m_totalVerticalScale ) );
            m_image.getSelectedPolygon( ).setScalingFactor( (float)m_totalHorizontalScale );
        }
        else
        {
            m_horizontalScaleTextField.setText( "" + m_formatter.format( m_totalHorizontalScale ) );
            m_image.getSelectedPolygon( ).setHorizontalScalingFactor( (float)m_totalHorizontalScale );
        }

        m_image.getSelectedPolygon( ).rotateAboutPointOfGravity( m_currentRotation );
        m_image.getSelectedPolygon( ).setTranslatePointOfGravity( new Point( -m_currentTranslationX , m_currentTranslationY ) );
}//GEN-LAST:event_m_horizontalScaleUpButtonActionPerformed

    /**
     * Scales down the horizontal zoom factor of the currently selected ROI
     * @param evt
     */
    private void m_horizontalScaleDownButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_horizontalScaleDownButtonActionPerformed
         m_image.deletePoly( m_image.getSelectedPolygon( ) );
         m_transformedPolygon = new RegioPolygon( m_originalPolygon );

         m_transformedPolygon.setLabel( m_regionNameTextField.getText( ) );

         m_image.addPolygon( m_transformedPolygon );

         m_totalHorizontalScale = m_totalHorizontalScale - 0.1;

         if ( m_keepAspectRatioCheckBox.isSelected( ) )
         {
             m_totalVerticalScale = m_totalHorizontalScale;
             m_horizontalScaleTextField.setText( "" + m_formatter.format( m_totalHorizontalScale ) );
             m_verticalScaleTextField.setText( "" + m_formatter.format( m_totalVerticalScale ) );
             m_image.getSelectedPolygon( ).setScalingFactor( (float)m_totalHorizontalScale );
         }
         else
         {
             m_horizontalScaleTextField.setText( "" + m_formatter.format( m_totalHorizontalScale ) );
             m_image.getSelectedPolygon( ).setHorizontalScalingFactor( (float)m_totalHorizontalScale );
         }

         m_image.getSelectedPolygon( ).rotateAboutPointOfGravity( m_currentRotation );
         m_image.getSelectedPolygon( ).setTranslatePointOfGravity( new Point( -m_currentTranslationX , m_currentTranslationY ) );
}//GEN-LAST:event_m_horizontalScaleDownButtonActionPerformed

    /**
     * Scales down the vertical zoom factor of the currently selected ROI
     * @param evt
     */
    private void m_verticalScaleDownButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_verticalScaleDownButtonActionPerformed
         m_image.deletePoly( m_image.getSelectedPolygon( ) );
         m_transformedPolygon = new RegioPolygon( m_originalPolygon );

         m_transformedPolygon.setLabel( m_regionNameTextField.getText( ) );

         m_image.addPolygon( m_transformedPolygon );


         m_totalVerticalScale = m_totalVerticalScale - 0.1;

         if ( m_keepAspectRatioCheckBox.isSelected( ) )
         {
             m_totalHorizontalScale = m_totalVerticalScale;
             m_horizontalScaleTextField.setText( "" + m_formatter.format( m_totalHorizontalScale ) );
             m_verticalScaleTextField.setText( "" + m_formatter.format( m_totalVerticalScale ) );
             m_image.getSelectedPolygon( ).setScalingFactor( (float)m_totalHorizontalScale );
         }
         else
         {
             m_verticalScaleTextField.setText( "" + m_formatter.format( m_totalVerticalScale ) );
             m_image.getSelectedPolygon( ).setVerticalScalingFactor( (float)m_totalVerticalScale );
         }

         m_image.getSelectedPolygon( ).rotateAboutPointOfGravity( m_currentRotation );
         m_image.getSelectedPolygon( ).setTranslatePointOfGravity( new Point( -m_currentTranslationX , m_currentTranslationY ) );

}//GEN-LAST:event_m_verticalScaleDownButtonActionPerformed

    /**
     * Scales up the vertical zoom factor of the currently selected ROI
     * @param evt
     */
    private void m_verticalScaleUpButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_verticalScaleUpButtonActionPerformed
         m_image.deletePoly( m_image.getSelectedPolygon( ) );
         m_transformedPolygon = new RegioPolygon( m_originalPolygon );
         
         m_transformedPolygon.setLabel( m_regionNameTextField.getText( ) );

         m_image.addPolygon( m_transformedPolygon );

         m_totalVerticalScale = m_totalVerticalScale + 0.1;
 
         if ( m_keepAspectRatioCheckBox.isSelected( ) )
         {
             m_totalHorizontalScale = m_totalVerticalScale;
             m_horizontalScaleTextField.setText( "" + m_formatter.format( m_totalHorizontalScale ) );
             m_verticalScaleTextField.setText( "" + m_formatter.format( m_totalVerticalScale ) );
             m_image.getSelectedPolygon( ).setScalingFactor( (float)m_totalHorizontalScale );
         }
         else
         {
             m_verticalScaleTextField.setText( "" + m_formatter.format( m_totalVerticalScale ) );
             m_image.getSelectedPolygon( ).setVerticalScalingFactor( (float)m_totalVerticalScale );
         }

         m_image.getSelectedPolygon( ).rotateAboutPointOfGravity( m_currentRotation );
         m_image.getSelectedPolygon( ).setTranslatePointOfGravity( new Point( -m_currentTranslationX , m_currentTranslationY ) );   
}//GEN-LAST:event_m_verticalScaleUpButtonActionPerformed

    /**
     * Cancels the complete operation. Nothing is pasted and this is disposed.
     * @param evt
     */
    private void m_cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_cancelButtonActionPerformed

        m_image.deletePoly( m_image.getSelectedPolygon( ) );

        // dispose this
        dispose( );
    }//GEN-LAST:event_m_cancelButtonActionPerformed

    private void m_keepAspectRatioCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_keepAspectRatioCheckBoxActionPerformed

        if ( m_keepAspectRatioCheckBox.isSelected( ) == true )
        {
            m_totalVerticalScale = m_totalHorizontalScale;

            m_horizontalScaleTextField.setText( "" + m_formatter.format( m_totalHorizontalScale ) );
            m_verticalScaleTextField.setText( "" + m_formatter.format( m_totalVerticalScale ) );

            m_image.deletePoly( m_image.getSelectedPolygon( ) );
            m_transformedPolygon = new RegioPolygon( m_originalPolygon );

            m_transformedPolygon.setLabel( m_regionNameTextField.getText( ) );

            m_image.addPolygon( m_transformedPolygon );

            m_image.getSelectedPolygon( ).setScalingFactor( (float)m_totalHorizontalScale );

            m_image.getSelectedPolygon( ).rotateAboutPointOfGravity( m_currentRotation );
            m_image.getSelectedPolygon( ).setTranslatePointOfGravity( new Point( -m_currentTranslationX , m_currentTranslationY ) );
        }

    }//GEN-LAST:event_m_keepAspectRatioCheckBoxActionPerformed

    private void m_applyAndQuitButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_applyAndQuitButtonActionPerformed
       // just dispose this frame, the region remains existent!
       dispose( );
}//GEN-LAST:event_m_applyAndQuitButtonActionPerformed

   
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JButton m_applyAndQuitButton;
    private javax.swing.JButton m_applyButton;
    private javax.swing.JButton m_cancelButton;
    private javax.swing.JButton m_horizontalScaleDownButton;
    private javax.swing.JTextField m_horizontalScaleTextField;
    private javax.swing.JButton m_horizontalScaleUpButton;
    private javax.swing.JCheckBox m_keepAspectRatioCheckBox;
    private javax.swing.JLabel m_regionNameLabel;
    private javax.swing.JTextField m_regionNameTextField;
    private javax.swing.JTextField m_roiCenterX;
    private javax.swing.JTextField m_roiCenterY;
    private javax.swing.JButton m_roiMoveDownButton;
    private javax.swing.JButton m_roiMoveLeftStepButton;
    private javax.swing.JButton m_roiMoveRightButton;
    private javax.swing.JButton m_roiMoveUpButton;
    private javax.swing.JButton m_rotateLeftStepButton;
    private javax.swing.JButton m_rotateRightStepButton;
    private javax.swing.JTextField m_rotationAngleStepTextfield;
    private javax.swing.JButton m_undoButton;
    private javax.swing.JButton m_verticalScaleDownButton;
    private javax.swing.JTextField m_verticalScaleTextField;
    private javax.swing.JButton m_verticalScaleUpButton;
    // End of variables declaration//GEN-END:variables

    // Addition member variables
    private final RegioPolygon m_originalPolygon;
    private RegioPolygon m_transformedPolygon;
    private final JFrame m_parent;
    private final DicomSliceCanvasPolyDraw m_image;
    private final int m_rotateDelta = 5;
    
    private int m_currentRotation = 0;
    
    private int m_currentTranslationX = 0;
    private int m_currentTranslationY = 0;

    private final int m_originalTranslationX;
    private final int m_originalTranslationY;

    private double m_totalHorizontalScale = 1.0;
    private double m_totalVerticalScale = 1.0;

    private final DecimalFormat m_formatter = new DecimalFormat( "###.0" );
    private final boolean m_createNewPolygon;
}
