/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * MeasureDistancesFrame.java
 *
 * Created on 22-Oct-2009, 11:54:45
 */

package org.spectrim.imageprocessing;

import org.spectrim.imagegraphicobjects.Distance;
import org.spectrim.imagegraphicobjects.Point3D;
import java.awt.Color;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Vector;
import javax.swing.JFrame;

/**
 * Displays the selected distances in a table
 * @author slotboom
 */
public class MeasureDistancesFrame extends javax.swing.JFrame implements ActionListener
{

    /** 
     * Creates new form MeasureDistancesFrame.
     * @param parent
     * @param distancesVector
     */
    public MeasureDistancesFrame( JFrame parent , 
                                  Vector< LinkedList <Distance> > distancesVector )
    {
        m_parent = parent;

        if ( distancesVector != null )
        {
            for ( int i = 0; i < distancesVector.size( ); i++ )
            {

                LinkedList<Distance> llist = distancesVector.get( i );

                for ( Distance llist1 : llist ) 
                {
                    m_sliceNumbers.add(llist1.getImageNumber());
                    m_distancesNames.add(llist1.getDistanceName());
                    m_distancesColors.add(llist1.getDistanceColor());
                    m_distances.add(llist1.getDistanceValue());
                    m_startingPoints2D.add(llist1.getBeginPoint());
                    m_endingPoints2D.add(llist1.getEndPoint());
                    m_startingPoints3D.add(llist1.getBeginPoint3D());
                    m_endingPoints3D.add(llist1.getEndPoint3D());
                }

            }
        }
        
        initComponents( );

        setTableValuesAccordingtoSettings( );

        pack( );

        if ( m_parent != null )
        {
            // Put the Dialog nicely in the middle of its parent
            Point centerParent = new Point( m_parent.getX( ) + ( m_parent.getWidth( ) / 2 ) - this.getWidth( ) / 2,
                                            m_parent.getY( ) + ( m_parent.getHeight( ) / 2 ) - this.getHeight( ) / 2 );


            setLocation( centerParent );
        }

        m_measuredDistancesTable.addActionListener( this );

        setVisible( true );

    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings( "unchecked" )
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel2 = new javax.swing.JPanel();
        m_saveDistancesInFile = new javax.swing.JButton();
        m_stopMeasuringDistances = new javax.swing.JButton();
        m_deleteSelectedDistances = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        m_measuredDistancesTable = new org.spectrim.imageprocessing.MeasuredDistancesTable();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        m_saveDistancesInFile.setText("Save all distances in file(s) and close..");
        m_saveDistancesInFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_saveDistancesInFileActionPerformed(evt);
            }
        });

        m_stopMeasuringDistances.setText("Stop measuring distances & close");
        m_stopMeasuringDistances.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_stopMeasuringDistancesActionPerformed(evt);
            }
        });

        m_deleteSelectedDistances.setText("Delete selected distances");
        m_deleteSelectedDistances.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_deleteSelectedDistancesActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addGap(57, 57, 57)
                .addComponent(m_saveDistancesInFile, javax.swing.GroupLayout.PREFERRED_SIZE, 249, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(166, 166, 166)
                .addComponent(m_deleteSelectedDistances)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 145, Short.MAX_VALUE)
                .addComponent(m_stopMeasuringDistances)
                .addGap(48, 48, 48))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap(42, Short.MAX_VALUE)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_stopMeasuringDistances)
                    .addComponent(m_saveDistancesInFile)
                    .addComponent(m_deleteSelectedDistances))
                .addContainerGap())
        );

        jScrollPane2.setViewportView(m_measuredDistancesTable);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 1011, Short.MAX_VALUE)
            .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 232, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void m_stopMeasuringDistancesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_stopMeasuringDistancesActionPerformed
        notifyActionListeners( STOP_MEASURING_DISTANCES );
        dispose( );
}//GEN-LAST:event_m_stopMeasuringDistancesActionPerformed

    private void m_saveDistancesInFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_saveDistancesInFileActionPerformed

        notifyActionListeners( SAVE_DISTANCES );
        dispose( );
    }//GEN-LAST:event_m_saveDistancesInFileActionPerformed

    private void m_deleteSelectedDistancesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_deleteSelectedDistancesActionPerformed

        int[] selectedRowsNumbers = m_measuredDistancesTable.getSelectedRows( );
        m_selectedDistancesNames.clear( );
        m_selectedSliceNumbers.clear( );

        for ( int i = 0; i < selectedRowsNumbers.length; i++ )
        {
            m_selectedDistancesNames.add( m_distancesNames.get( selectedRowsNumbers[i] ) );
            m_selectedSliceNumbers.add( this.m_sliceNumbers.get( selectedRowsNumbers[i] ) );
        }

        notifyActionListeners( DELETE_SELECTED_DISTANCES );

        for ( int i = selectedRowsNumbers.length - 1; i >= 0 ; i-- )
        {
            ((MeasuredDistancesTableModel)m_measuredDistancesTable.getModel( ) ).removeRow( selectedRowsNumbers[i] );

            // also remove in model data
            m_sliceNumbers.remove( selectedRowsNumbers[i] );
            m_distancesNames.remove( selectedRowsNumbers[i] );
            m_distancesColors.remove( selectedRowsNumbers[i] );
            m_distances.remove( selectedRowsNumbers[i] );

            m_startingPoints2D.remove( selectedRowsNumbers[i] );
            m_endingPoints2D.remove(selectedRowsNumbers[i] );
            m_startingPoints3D.remove( selectedRowsNumbers[i] );
            m_endingPoints3D.remove( selectedRowsNumbers[i] );
        }
        
        setTableValuesAccordingtoSettings( );
    }//GEN-LAST:event_m_deleteSelectedDistancesActionPerformed



    /**
    * @param args the command line arguments
    */
    public static void main( String args[] )
    {
        java.awt.EventQueue.invokeLater(new Runnable( )
        {
            @Override
            public void run()
            {
                new MeasureDistancesFrame( null, null ).setVisible( true );
            }
        });
    }

    /**
     * Adds an action listener to the list of action listeners who are notified
     * when something happens within this object.
     * @param e
     */
    public void addActionListener( ActionListener e )
    {
        m_listeners.add( e );
    }

    /**
     * Adds a 3D point to the list of clicked points.
     * @param imageNumber
     * @param x_coord
     * @param y_coord
     * @param point
     * @param name
     * @param color
     */
    public void setClickedPoint( int imageNumber, int x_coord, int y_coord, Point3D point, String name, Color color )
    {
        if ( m_isBeginningPoint == true )
        {
            m_sliceNumbers.add( new Integer( imageNumber ) );
            m_startingPoints2D.add( new Point( x_coord, y_coord ) );
            m_startingPoints3D.add( point );
            m_distancesNames.add( name );
            m_isBeginningPoint = false;
            m_distancesColors.add( color );
        }
        else
        {
            m_endingPoints2D.add( new Point( x_coord, y_coord ) );
            m_endingPoints3D.add( point );
            m_isBeginningPoint = true;
        }

        setTableValuesAccordingtoSettings( );
    }


    /**
     * Sets the values according to the current Dicom nodes.
     */
    private void setTableValuesAccordingtoSettings( )
    {

        if ( m_startingPoints3D.size( ) > 0 )
        {
            m_data = new Object[ m_startingPoints3D.size( ) ][ 10 ];

            for ( int i = 0; i < m_startingPoints3D.size( ); i++ )
            {
                m_data[i][0] = "" + i;
                m_data[i][1] = ((Integer)m_sliceNumbers.get( i ) ).intValue( );
                m_data[i][2] = m_distancesNames.get( i );


                m_data[i][3] = "" + ((Point)m_startingPoints2D.get( i ) ).x;
                m_data[i][4] = "" + ((Point)m_startingPoints2D.get( i ) ).y;

                
                m_data[i][5] =  m_startingPoints3D.get( i ).asString( );

                m_data[i][6] = "";
                m_data[i][7] = "";
                m_data[i][8] = "";
                m_data[i][9] = "";

            }
            
            // clear the distance value vector, before building it again!
            m_distances.clear( );
            for ( int j = 0; j < m_endingPoints3D.size( ) ; j++ )
            {
                
                m_data[j][6] = "" + ((Point)m_endingPoints2D.get( j ) ).x;
                m_data[j][7] = "" + ((Point)m_endingPoints2D.get( j ) ).y;
                
                m_data[j][8] = m_endingPoints3D.get( j ).asString( );

                Point3D begin = m_startingPoints3D.get( j );
                Point3D end   = m_endingPoints3D.get( j );

                Point3D diff = new Point3D ( ( begin.m_x1 - end.m_x1 ),
                                             ( begin.m_x2 - end.m_x2 ),
                                             ( begin.m_x3 - end.m_x3 ) );

                m_data[j][9] =  "" + new Float( diff.length( ) );
                
                m_distances.add( new Float( diff.length( ) ) );

            }

            ( (MeasuredDistancesTableModel)m_measuredDistancesTable.getModel( ) ).setDataVector( m_startingPoints3D.size( ), 10, m_data );

            notifyActionListeners( ADDED_POINT );
        }
    }


    /**
     * Notify listeners that something in the object has changed.
     * @param eventType
     */
    protected void notifyActionListeners( int eventType )
    {

        Iterator it = m_listeners.iterator( );
        while( it.hasNext( ) )
        {
            ( ( ActionListener )it.next( ) ).actionPerformed( new ActionEvent( this, eventType, "" ) );
        }

    }

    /**
     * Returns the Vector of starting 2D points.
     * @return
     */
    public Vector<Point> getStartingPoints2D( )
    {
        return m_startingPoints2D;
    }

    /**
     * Returns the Vector of starting 2D points.
     * @return
     */
    public Vector<Point> getEndingPoints2D( )
    {
        return m_endingPoints2D;
    }

    /**
     * Returns the Vector of starting 3D points.
     * @return
     */
    public Vector<Point3D> getStartingPoints3D( )
    {
        return m_startingPoints3D;
    }

    /**
     * Returns the Vector of starting 3D points.
     * @return
     */
    public Vector<Point3D> getEndingPoints3D( )
    {
        return m_endingPoints3D;
    }



    /**
     * Returns the Vector of selected slice numbers.
     * @return
     */
    public Vector<Integer> getSelectedSliceNumbers( )
    {
        return m_selectedSliceNumbers;
    }


    /**
     * Returns the Vector of slice numbers.
     * @return
     */
    public Vector<Integer> getSliceNumbers( )
    {
        return m_sliceNumbers;
    }

    /**
     * Returns the Vector of distance names.
     * @return
     */
     public Vector<String> getDistancesNames( )
     {
         return m_distancesNames;
     }

     /**
     * Returns the Vector of selected distance names.
     * @return
     */
     public Vector<String> getSelectedDistancesNames( )
     {
         return m_selectedDistancesNames;
     }

     /**
     * Returns the Vector of distances.
     * @return
     */
     public Vector<Float> getDistances( )
     {
         return m_distances;
     }


   /**
    * Returns the Vector of distance colors.
    * @return
    */
    public Vector<Color> getDistancesColors( )
    {
        return m_distancesColors;
    }



    /**
     * 
     * Called if a registered command raises an action event.
     * 
     * @param e 
     */
    @Override
    public void actionPerformed( ActionEvent e )
    {
        if ( e.getSource( ) == m_measuredDistancesTable )
        {
            if ( e.getID( ) == MeasuredDistancesTable.RENAMING_EVENT )
            {
                m_distancesNames.setElementAt( m_measuredDistancesTable.getRenamedString( ), m_measuredDistancesTable.getSelectedRow( ) );
                notifyActionListeners( DISTANCES_CHANGED );
            }
        }
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JButton m_deleteSelectedDistances;
    private org.spectrim.imageprocessing.MeasuredDistancesTable m_measuredDistancesTable;
    private javax.swing.JButton m_saveDistancesInFile;
    private javax.swing.JButton m_stopMeasuringDistances;
    // End of variables declaration//GEN-END:variables

    // Listeners to action events in this class
    private LinkedList<ActionListener> m_listeners = new LinkedList<ActionListener>( );
    private JFrame m_parent;

    private Vector<Integer> m_sliceNumbers = new Vector<Integer>( );
    private Vector<String> m_distancesNames = new Vector<String>( );
    private Vector<Color> m_distancesColors = new Vector<Color>( );
    private Vector<Float> m_distances = new Vector<Float>( );


    private Vector<Point> m_startingPoints2D = new Vector<Point>( );
    private Vector<Point> m_endingPoints2D   = new Vector<Point>( );
    private Vector<Point3D> m_startingPoints3D = new Vector<Point3D>( );
    private Vector<Point3D> m_endingPoints3D   = new Vector<Point3D>( );


    private Vector<String> m_selectedDistancesNames = new Vector<String>( );
    private Vector<Integer> m_selectedSliceNumbers = new Vector<Integer>( );


    private boolean m_isBeginningPoint = true;
    private Object[][] m_data;

    public final static int ADDED_POINT = 0;
    public final static int SAVE_DISTANCES = 1;
    public final static int DELETE_SELECTED_DISTANCES = 2;
    public final static int STOP_MEASURING_DISTANCES = 3;
    public final static int DISTANCES_CHANGED = 4;
}
