/*
 * PixelValueReplacementFrame.java
 *
 * Created on September 4, 2008, 12:57 PM
 */

package org.spectrim.imageprocessing;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.LinkedList;

/**
 * Frame that enables the replacement of certain pixel values with other 
 * pixel values.
 * 
 * @author  hans
 */
public class PixelValueReplacementFrame extends javax.swing.JFrame implements ActionListener 
{
  
    /** 
     * Creates new form PixelValueReplacementFrame. 
     * @param currentMinPixValue
     * @param currentMaxPixValue
     */
    public PixelValueReplacementFrame( int currentMinPixValue, 
                                       int currentMaxPixValue ) 
    {
        m_currentMinPixValue = currentMinPixValue;
        m_currentMaxPixValue = currentMaxPixValue;
        
        initComponents( );
        
        m_currentMinimumValue.setText( "" + m_currentMinPixValue );
        m_currentMaximumValue.setText( "" + m_currentMaxPixValue );
        m_applyButton.addActionListener( this );
        m_cancelButton.addActionListener( this );
        m_higherThanMaximumOnlyRadioButton.addActionListener( this );
        m_lowerThanMinimumOnlyRadioButton.addActionListener( this );
        m_ousideRangeOnlyRadioButton.addActionListener( this );
        m_withinRangeOnlyRadioButton.addActionListener( this );
        setVisible( true );
        
        setDefaultCloseOperation( javax.swing.WindowConstants.EXIT_ON_CLOSE );
        
        m_selectedButton = REPLACE_OUTSIDE_INTERVAL;
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        m_whichOperationIsRequiredButtonGroup = new javax.swing.ButtonGroup();
        m_imageInfoPanel = new javax.swing.JPanel();
        m_minimumPixelValueLabellLabel = new javax.swing.JLabel();
        m_maximumPixelValueLabel = new javax.swing.JLabel();
        m_currentMinimumValue = new javax.swing.JLabel();
        m_currentMaximumValue = new javax.swing.JLabel();
        m_definePixelvalueReplacementOperationPanel = new javax.swing.JPanel();
        m_minPixValRangeTextField = new javax.swing.JTextField();
        m_minPixValLabel = new javax.swing.JLabel();
        m_maxPixValLabel = new javax.swing.JLabel();
        m_maxPixValRangeTextField = new javax.swing.JTextField();
        m_replacePixelValueWithTextField = new javax.swing.JTextField();
        m_lowerThanMinimumOnlyRadioButton = new javax.swing.JRadioButton();
        m_maxPixValLabel1 = new javax.swing.JLabel();
        m_higherThanMaximumOnlyRadioButton = new javax.swing.JRadioButton();
        m_withinRangeOnlyRadioButton = new javax.swing.JRadioButton();
        m_ousideRangeOnlyRadioButton = new javax.swing.JRadioButton();
        m_cancelButton = new javax.swing.JButton();
        m_applyButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        m_imageInfoPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Image properties"));

        m_minimumPixelValueLabellLabel.setText("Minimum pixel value");

        m_maximumPixelValueLabel.setText("Maximum pixel value");

        m_currentMinimumValue.setText("0");

        m_currentMaximumValue.setText("0");

        javax.swing.GroupLayout m_imageInfoPanelLayout = new javax.swing.GroupLayout(m_imageInfoPanel);
        m_imageInfoPanel.setLayout(m_imageInfoPanelLayout);
        m_imageInfoPanelLayout.setHorizontalGroup(
            m_imageInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(m_imageInfoPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(m_imageInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(m_minimumPixelValueLabellLabel)
                    .addComponent(m_maximumPixelValueLabel))
                .addGap(46, 46, 46)
                .addGroup(m_imageInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(m_currentMaximumValue)
                    .addComponent(m_currentMinimumValue))
                .addContainerGap(224, Short.MAX_VALUE))
        );
        m_imageInfoPanelLayout.setVerticalGroup(
            m_imageInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(m_imageInfoPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(m_imageInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_minimumPixelValueLabellLabel)
                    .addComponent(m_currentMinimumValue))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(m_imageInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_maximumPixelValueLabel)
                    .addComponent(m_currentMaximumValue))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        m_definePixelvalueReplacementOperationPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Define pixel value replacement operation"));

        m_minPixValRangeTextField.setText("1000");

        m_minPixValLabel.setText("Pixel value  range minimum");

        m_maxPixValLabel.setText("Pixel value  range maximum");

        m_maxPixValRangeTextField.setText("1150");

        m_replacePixelValueWithTextField.setText("0");

        m_whichOperationIsRequiredButtonGroup.add(m_lowerThanMinimumOnlyRadioButton);
        m_lowerThanMinimumOnlyRadioButton.setText("Replace only pixel values lower than minimum value");

        m_maxPixValLabel1.setText("Replace Pixel value  to");

        m_whichOperationIsRequiredButtonGroup.add(m_higherThanMaximumOnlyRadioButton);
        m_higherThanMaximumOnlyRadioButton.setText("Replace only pixel values higher than maximum value");

        m_whichOperationIsRequiredButtonGroup.add(m_withinRangeOnlyRadioButton);
        m_withinRangeOnlyRadioButton.setText("Replace only pixel values between minimum and maximum value");

        m_whichOperationIsRequiredButtonGroup.add(m_ousideRangeOnlyRadioButton);
        m_ousideRangeOnlyRadioButton.setSelected(true);
        m_ousideRangeOnlyRadioButton.setText("Replace only pixel values outside minimum and maximum value");

        javax.swing.GroupLayout m_definePixelvalueReplacementOperationPanelLayout = new javax.swing.GroupLayout(m_definePixelvalueReplacementOperationPanel);
        m_definePixelvalueReplacementOperationPanel.setLayout(m_definePixelvalueReplacementOperationPanelLayout);
        m_definePixelvalueReplacementOperationPanelLayout.setHorizontalGroup(
            m_definePixelvalueReplacementOperationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(m_definePixelvalueReplacementOperationPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(m_definePixelvalueReplacementOperationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(m_ousideRangeOnlyRadioButton)
                    .addComponent(m_withinRangeOnlyRadioButton)
                    .addComponent(m_higherThanMaximumOnlyRadioButton)
                    .addComponent(m_lowerThanMinimumOnlyRadioButton)
                    .addGroup(m_definePixelvalueReplacementOperationPanelLayout.createSequentialGroup()
                        .addGroup(m_definePixelvalueReplacementOperationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(m_maxPixValLabel)
                            .addComponent(m_minPixValLabel)
                            .addComponent(m_maxPixValLabel1))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(m_definePixelvalueReplacementOperationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(m_replacePixelValueWithTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 62, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(m_maxPixValRangeTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 62, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(m_minPixValRangeTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 62, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(43, Short.MAX_VALUE))
        );
        m_definePixelvalueReplacementOperationPanelLayout.setVerticalGroup(
            m_definePixelvalueReplacementOperationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(m_definePixelvalueReplacementOperationPanelLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(m_definePixelvalueReplacementOperationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_minPixValRangeTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(m_minPixValLabel))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(m_definePixelvalueReplacementOperationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_maxPixValRangeTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(m_maxPixValLabel))
                .addGap(15, 15, 15)
                .addGroup(m_definePixelvalueReplacementOperationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_maxPixValLabel1)
                    .addComponent(m_replacePixelValueWithTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(m_lowerThanMinimumOnlyRadioButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(m_higherThanMaximumOnlyRadioButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(m_withinRangeOnlyRadioButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(m_ousideRangeOnlyRadioButton))
        );

        m_cancelButton.setText("Cancel");
        m_cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_cancelButtonActionPerformed(evt);
            }
        });

        m_applyButton.setText("Apply");
        m_applyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_applyButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(m_imageInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(m_cancelButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 256, Short.MAX_VALUE)
                .addComponent(m_applyButton)
                .addContainerGap())
            .addComponent(m_definePixelvalueReplacementOperationPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(m_imageInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(m_definePixelvalueReplacementOperationPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_cancelButton)
                    .addComponent(m_applyButton))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    
    /**
     * User pressed the cancel button: the GUI should be disposed
     * @param evt
     */
    private void m_cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_cancelButtonActionPerformed
        notifyActionListeners( CANCEL_EVENT );
        dispose( );
    }//GEN-LAST:event_m_cancelButtonActionPerformed

    private void m_applyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_applyButtonActionPerformed
        notifyActionListeners( APPLY_EVENT );
        dispose( );
    }//GEN-LAST:event_m_applyButtonActionPerformed

    
    /**
     * Notify listeners that something in the object has changed.
     * @param eventType
     */
    protected void notifyActionListeners( int eventType )
    { 
        Iterator it = m_listeners.iterator( );
        while( it.hasNext( ) )
        {
            ( ( ActionListener )it.next( ) ).actionPerformed( new ActionEvent( this, eventType, "" ) );
        }
    }
    
    /**
     *  Returns the selected replacement option.
     * @return
     */
    public int getSeletedReplcementOption( )
    {
        return m_selectedButton;
    }
    
    /** 
     * Is called whenever a registered component raises an ActionEvent
     * @param e
     */
    @Override
    public void actionPerformed( ActionEvent e ) 
    {
        if ( e.getSource( ) == m_higherThanMaximumOnlyRadioButton )
        {
            m_selectedButton = REPLACE_ONLY_HIGHER_THAN;
        }
        
        if ( e.getSource( ) == m_lowerThanMinimumOnlyRadioButton )
        {
            m_selectedButton = REPLACE_ONLY_LOWER_THAN;
        }
        
         if ( e.getSource( ) == m_ousideRangeOnlyRadioButton )
         {
             m_selectedButton = REPLACE_OUTSIDE_INTERVAL;
         }
        
        if ( e.getSource( ) == m_withinRangeOnlyRadioButton )
        {
             m_selectedButton = REPLACE_INSIDE_INTERVAL;
        }
    }
    
    /**
     * Returns the integer pixel intensity value which should replace 
     * the original value  
     * @return
     */
    public int getNewPixelValue( )
    {
        return Integer.parseInt( m_replacePixelValueWithTextField.getText( ) );
    }
    
    /**
     * Returns the integer pixel intensity value which should replace 
     * the original value.  
     * @return
     */
    public int getMinimumPixelValue( )
    {
        return Integer.parseInt( m_minPixValRangeTextField.getText( ) );
    }
    
    /**
     * Returns the integer pixel intensity value which should replace 
     * the original value.  
     * @return
     */
    public int getMaximumPixelValue( )
    {
        return Integer.parseInt(m_maxPixValRangeTextField.getText( ) );
    }
    
    
    /**
     * Adds an action listener to the list of action listeners who are notified
     * @param e
     */
    public void addActionListener( ActionListener e )
    {
	m_listeners.add( e );
    }
    
    
    /**
     * @param args the command line arguments
     */
    public static void main( String args[] ) 
    {
        java.awt.EventQueue.invokeLater(new Runnable( ) 
        {
            @Override
            public void run( ) 
            {
                new PixelValueReplacementFrame(0,0).setVisible( true );
            }
        });
    }
    
    // Own added members 
    private final int m_currentMinPixValue;
    private final int m_currentMaxPixValue;
    
    private int m_selectedButton;
    
    // Listeners to changes in the segmentation gui control
    private LinkedList<ActionListener> m_listeners = new LinkedList<>( );
    
    // user actions
    public final static int CANCEL_EVENT = 0;
    public final static int APPLY_EVENT = 1;
    
    // state of radio buttons
    public final static int REPLACE_ONLY_HIGHER_THAN = 100;
    public final static int REPLACE_ONLY_LOWER_THAN = 101;
    public final static int REPLACE_OUTSIDE_INTERVAL = 102;
    public final static int REPLACE_INSIDE_INTERVAL = 103;
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton m_applyButton;
    private javax.swing.JButton m_cancelButton;
    private javax.swing.JLabel m_currentMaximumValue;
    private javax.swing.JLabel m_currentMinimumValue;
    private javax.swing.JPanel m_definePixelvalueReplacementOperationPanel;
    private javax.swing.JRadioButton m_higherThanMaximumOnlyRadioButton;
    private javax.swing.JPanel m_imageInfoPanel;
    private javax.swing.JRadioButton m_lowerThanMinimumOnlyRadioButton;
    private javax.swing.JLabel m_maxPixValLabel;
    private javax.swing.JLabel m_maxPixValLabel1;
    private javax.swing.JTextField m_maxPixValRangeTextField;
    private javax.swing.JLabel m_maximumPixelValueLabel;
    private javax.swing.JLabel m_minPixValLabel;
    private javax.swing.JTextField m_minPixValRangeTextField;
    private javax.swing.JLabel m_minimumPixelValueLabellLabel;
    private javax.swing.JRadioButton m_ousideRangeOnlyRadioButton;
    private javax.swing.JTextField m_replacePixelValueWithTextField;
    private javax.swing.ButtonGroup m_whichOperationIsRequiredButtonGroup;
    private javax.swing.JRadioButton m_withinRangeOnlyRadioButton;
    // End of variables declaration//GEN-END:variables
  
    // For proper serialization
    private static final long serialVersionUID = 1482325898863333L;
}
