/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * VolumeOfInterestOverlayManipulationFrame.java
 *
 * Created on 21-Feb-2011, 11:09:43
 */

package org.spectrim.imageprocessing;

import org.spectrim.dicom.DicomSliceCanvasPolyDraw;

import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.LinkedList;
import javax.swing.JFrame;

/**
 * This frame allows manipulation of volumes of interest.
 * @author slotboom
 */
public class VolumeOfInterestOverlayManipulationFrame extends javax.swing.JFrame implements ActionListener
{

    /** 
     * Creates new form VolumeOfInterestOverlayManipulationFrame.
     * @param image
     */
    public VolumeOfInterestOverlayManipulationFrame( DicomSliceCanvasPolyDraw image )
    {

        initComponents( );

        setTitle( "Volume of Interest Properties & Manipulation" );

        m_volumeOfInterestOverlayManipulationPanel.setDicomSliceCanvasPolyDraw( image );
        
        m_volumeOfInterestOverlayManipulationPanel.addActionListener( this );

        JFrame parent = image.getParentFrame( );

        // Put the Dialog nicely in the middle of its parent
        Point centerParent = new Point( parent.getX( ) + ( parent.getWidth( ) / 2 ) - getWidth( ) / 2,
                                        parent.getY( ) + ( parent.getHeight( ) / 2 ) - getHeight( ) / 2 );
        
        setLocation( centerParent );

        setVisible( true );

    }


    /**
     * Method to allow the registration of listeners.
     * @param e
     */
    public void addActionListener( ActionListener e )
    {
        m_actionListeners.add( e );
    }

    /**
     * Notify listeners that something in the object has changed.
     * @param eventType
     * @param actionCommand
     */
    protected void notifyActionListeners( int eventType, String actionCommand )
    {
        Iterator it = m_actionListeners.iterator( );
        while( it.hasNext( ) )
        {
            ( ( ActionListener )it.next( ) ).actionPerformed( new ActionEvent( this, eventType, actionCommand ) );
        }
    }


    /**
     * Called whenever a registered component raises an Action Event.
     * @param e
     */
    public void actionPerformed( ActionEvent e )
    {
        Object sender = e.getSource( );

        if ( sender == this.m_volumeOfInterestOverlayManipulationPanel )
        {
            notifyActionListeners( VolumeOfInterestOverlayPropertiesTable.DELETE_SELECTED_VOLUME_EVENT, "DELETE_SELECTED_VOLUME_EVENT" );
        }
    }



    /**
     * Sets the DicomSliceCanvasPolydraw object again.
     * @param image
     */
    public void setDicomSliceCanvasPolyDraw( DicomSliceCanvasPolyDraw image )
    {
        m_volumeOfInterestOverlayManipulationPanel.setDicomSliceCanvasPolyDrawAgain( image );
    }

    /** 
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings( "unchecked" )
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        m_OKButton = new javax.swing.JButton();
        m_volumeOfInterestOverlayManipulationPanel = new org.spectrim.imageprocessing.VolumeOfInterestOverlayManipulationPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        m_OKButton.setText("OK");
        m_OKButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_OKButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(331, 331, 331)
                .addComponent(m_OKButton, javax.swing.GroupLayout.PREFERRED_SIZE, 83, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(347, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(m_OKButton)
                .addContainerGap(16, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(m_volumeOfInterestOverlayManipulationPanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 761, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(m_volumeOfInterestOverlayManipulationPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 353, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void m_OKButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_OKButtonActionPerformed
        // the user has seen enough -> close this frame
        dispose( );
    }//GEN-LAST:event_m_OKButtonActionPerformed



    /**
    * @param args the command line arguments.
    */
    public static void main( String args[] )
    {
        java.awt.EventQueue.invokeLater(new Runnable( )
        {
            public void run( )
            {
                new VolumeOfInterestOverlayManipulationFrame( null ).setVisible( true );
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel1;
    private javax.swing.JButton m_OKButton;
    private org.spectrim.imageprocessing.VolumeOfInterestOverlayManipulationPanel m_volumeOfInterestOverlayManipulationPanel;
    // End of variables declaration//GEN-END:variables
    
    private LinkedList<ActionListener> m_actionListeners = new LinkedList<ActionListener>( );


}
