/*
 * File: $Id: ProbingRegionPropertiesPanel.java,v 1.1.1.1 2010/03/26 09:38:48 hans Exp $
 * History
 * Date: 26.03.2010  Authors: Hans Slotboom
 *
 * Changes:
 *
 * Copyright (C) 2010 by
 * 
 * Inselspital - Department of Neuroradiology
 * CH 3010 Bern Switzerland
 */ 
        
/*
 * ProbingRegionPropertiesPanel.java
 *
 * Created on March 26, 2010, 11:01 AM
 */

package org.spectrim.imageprocessing.orderstatisticsegmentation;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.LinkedList;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 *
 * @author  hans
 */
public class OrderStatisticsProbingRegionPropertiesPanel extends javax.swing.JPanel implements ActionListener, ChangeListener
{
    
    /** 
     * Creates new form ProbingRegionPropertiesPanel 
     */
    public OrderStatisticsProbingRegionPropertiesPanel( float minPixVal, float maxPixVal )
    {        

        initComponents( );
        // listen to changes in the four sliders position!
        m_minimumPixelValueThresholdSlider.addChangeListener( this );
        m_maximumPixelValueThresholdSlider.addChangeListener( this );
        m_minimumOSFThresholdSlider.addChangeListener( this );
        m_maximumOSFThresholdSlider.addChangeListener( this );



        m_minPixVal = minPixVal;
        m_maxPixVal = maxPixVal;
        m_maximumPixelValueThresholdSliderLabel.setText(  "" + (int)( m_maximumPixelValueThresholdSlider.getValue( ) * this.m_maxPixVal / 1000f ) );
        
        m_pixelRangeDeterminationType = PIXEL_RANGE_DEFINED_BY_STANDARD_DEVIATION;
    
    }

    /**
     * Returns the wanted sorting type selected by the user.
     * @return
     */
    public int getOSFSortingType( )
    {
        if ( m_median2MinMaxSorting.isSelected( ) )
        {
            return MEDIAN_ORDER_MINIMUM_2_MEDIAN_2_MAXIMUM_SORTING;
        }

        if ( m_maximumOrder_Min2MaxSorting.isSelected( ) )
        {
            return MAXIMUM_ORDER_MINIMUM_2_MAXIMUM_SORTING;
        }
        
        if ( m_minimumOrder_Min2MaxSorting.isSelected( ) )
        {
            return MINIMUM_ORDER_MINIMUM_2_MAXIMUM_SORTING;
        }

        return -1;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        m_permutationNumber = new javax.swing.ButtonGroup();
        m_segmentationRegionButtonGroup = new javax.swing.ButtonGroup();
        jLabel10 = new javax.swing.JLabel();
        m_rangeDeterminatedByButtonGroup = new javax.swing.ButtonGroup();
        m_segmentationScopeButtonGroup = new javax.swing.ButtonGroup();
        m_subSegmentationButtonGroup = new javax.swing.ButtonGroup();
        m_OSFSortingTypeToApply = new javax.swing.ButtonGroup();
        m_segmentationProgressPanel = new javax.swing.JPanel();
        m_progressActivityLabel = new javax.swing.JLabel();
        m_segmentationProgressBar = new javax.swing.JProgressBar();
        m_actionButtonPanel = new javax.swing.JPanel();
        m_performAdvancedSegmentationButton = new javax.swing.JButton();
        m_performSimpleSegmentationButton = new javax.swing.JButton();
        m_tabbedControlContentPanel = new javax.swing.JPanel();
        m_SegmentationPropertiesTabbedPane = new javax.swing.JTabbedPane();
        m_regionToSegmentTab = new javax.swing.JPanel();
        m_segmentWholeImageRadioButton = new javax.swing.JRadioButton();
        m_segmentWholeImageAfterThresholdingRadioButton = new javax.swing.JRadioButton();
        m_minimumThresshold = new javax.swing.JTextField();
        m_maximumThresshold = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        m_defineRegionToSegmentRadioButton = new javax.swing.JRadioButton();
        m_defineAreaForSegmentationButton = new javax.swing.JButton();
        m_deleteAreaForSegmentation = new javax.swing.JButton();
        m_segmentationAmplitudeThressholds = new javax.swing.JPanel();
        m_pixelThressholdPanel = new javax.swing.JPanel();
        m_maximumSliderPanel = new javax.swing.JPanel();
        m_maximumPixelValueThresholdSliderLabel = new javax.swing.JLabel();
        m_maximumPixelValueThresholdSlider = new javax.swing.JSlider();
        m_maxiimumPixelValueLabel = new javax.swing.JLabel();
        m_minimuSliderPanel = new javax.swing.JPanel();
        m_minimumPixelValueThresholdSliderLabel = new javax.swing.JLabel();
        m_minimumPixelValueThresholdSlider = new javax.swing.JSlider();
        m_minimumPixelValueLabel = new javax.swing.JLabel();
        m_thressholdingOptionPanel = new javax.swing.JPanel();
        m_performSimplePixelValueThresholdingBeforeSegmentation = new javax.swing.JCheckBox();
        m_autoApplyButton = new javax.swing.JCheckBox();
        m_applyMoprphologicalFilteringAfterThressholding = new javax.swing.JCheckBox();
        m_segmentAmplitudeBoundsAndSegmentationScoopTab = new javax.swing.JPanel();
        m_rangePropertiesSubPanel = new javax.swing.JPanel();
        m_segmentationAmplitudeRangeMultiplyer = new javax.swing.JComboBox();
        m_rangeDefinedByMinMaxPixelRange3 = new javax.swing.JRadioButton();
        jLabel14 = new javax.swing.JLabel();
        m_rangeDefinedByStandardDeviation3 = new javax.swing.JRadioButton();
        m_segmentationScopeSubPanel = new javax.swing.JPanel();
        m_applySegmentationToAllSlices = new javax.swing.JRadioButton();
        m_applySegmentationToCurrentSliceOnly = new javax.swing.JRadioButton();
        m_subSegmentationSubPanel = new javax.swing.JPanel();
        m_applySubSegmentationToAllImages = new javax.swing.JRadioButton();
        m_applySubSegmentationToCurrentlyDisplayedImageOnly = new javax.swing.JRadioButton();
        m_probingRegionPropertiesTab = new javax.swing.JPanel();
        m_probingRegionPropertiesPanel = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        m_defineProbeSizeX = new javax.swing.JComboBox();
        m_defineProbeSizeY = new javax.swing.JComboBox();
        jLabel3 = new javax.swing.JLabel();
        m_numberOfProbingPixels = new javax.swing.JTextField();
        m_initializeOSFlitering = new javax.swing.JButton();
        m_probingCriteriaPropertiesTab = new javax.swing.JPanel();
        m_probingCriteriaTabbedPane = new javax.swing.JTabbedPane();
        m_OSF1PropertyPanel = new javax.swing.JPanel();
        m_pixelThressholdPanel1 = new javax.swing.JPanel();
        m_maximumSliderPanel1 = new javax.swing.JPanel();
        m_maximumOSFThresholdSliderLabel = new javax.swing.JLabel();
        m_maximumOSFThresholdSlider = new javax.swing.JSlider();
        m_maxiimumLabel1 = new javax.swing.JLabel();
        m_thressholdingOptionPanel1 = new javax.swing.JPanel();
        m_applyOSFThresholdingBeforeSegmentation = new javax.swing.JCheckBox();
        m_autoApplySimpleOSFThressholdingButton = new javax.swing.JCheckBox();
        m_minimuSliderPanel1 = new javax.swing.JPanel();
        m_minimumOSFThresholdSliderLabel = new javax.swing.JLabel();
        m_minimumOSFThresholdSlider = new javax.swing.JSlider();
        m_minimumLabel1 = new javax.swing.JLabel();
        m_OSF2PropertiesPanel = new javax.swing.JPanel();
        m_maximumOrder_Min2MaxSorting = new javax.swing.JRadioButton();
        m_median2MinMaxSorting = new javax.swing.JRadioButton();
        m_minimumOrder_Min2MaxSorting = new javax.swing.JRadioButton();
        m_OSF3PropertyPanel = new javax.swing.JPanel();
        m_OSF4PropertiesPanel = new javax.swing.JPanel();
        m_viewHistogramsButton = new javax.swing.JButton();
        m_viewRegionOrderSpectrumButton = new javax.swing.JButton();

        jLabel10.setText("jLabel10");

        setBorder(javax.swing.BorderFactory.createEmptyBorder(3, 3, 3, 3));
        setLayout(new java.awt.BorderLayout());

        m_segmentationProgressPanel.setMaximumSize(new java.awt.Dimension(512, 20));
        m_segmentationProgressPanel.setMinimumSize(new java.awt.Dimension(512, 20));
        m_segmentationProgressPanel.setPreferredSize(new java.awt.Dimension(512, 30));
        m_segmentationProgressPanel.setVerifyInputWhenFocusTarget(false);

        m_progressActivityLabel.setText("Progress");
        m_progressActivityLabel.setMaximumSize(new java.awt.Dimension(180, 20));
        m_progressActivityLabel.setMinimumSize(new java.awt.Dimension(180, 20));
        m_progressActivityLabel.setOpaque(true);
        m_progressActivityLabel.setPreferredSize(new java.awt.Dimension(180, 20));
        m_progressActivityLabel.setRequestFocusEnabled(false);
        m_segmentationProgressPanel.add(m_progressActivityLabel);

        m_segmentationProgressBar.setMaximumSize(new java.awt.Dimension(300, 20));
        m_segmentationProgressBar.setMinimumSize(new java.awt.Dimension(300, 20));
        m_segmentationProgressBar.setPreferredSize(new java.awt.Dimension(300, 20));
        m_segmentationProgressPanel.add(m_segmentationProgressBar);

        m_actionButtonPanel.setMaximumSize(new java.awt.Dimension(512, 40));
        m_actionButtonPanel.setMinimumSize(new java.awt.Dimension(512, 40));
        m_actionButtonPanel.setPreferredSize(new java.awt.Dimension(512, 40));

        m_performAdvancedSegmentationButton.setText("Stop segmentation");
        m_performAdvancedSegmentationButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_performAdvancedSegmentationButtonActionPerformed(evt);
            }
        });

        m_performSimpleSegmentationButton.setText("Perform segmentation");
        m_performSimpleSegmentationButton.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        m_performSimpleSegmentationButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                performSegmentationButtonPressed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout m_actionButtonPanelLayout = new org.jdesktop.layout.GroupLayout(m_actionButtonPanel);
        m_actionButtonPanel.setLayout(m_actionButtonPanelLayout);
        m_actionButtonPanelLayout.setHorizontalGroup(
            m_actionButtonPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_actionButtonPanelLayout.createSequentialGroup()
                .add(m_performSimpleSegmentationButton)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 198, Short.MAX_VALUE)
                .add(m_performAdvancedSegmentationButton))
        );
        m_actionButtonPanelLayout.setVerticalGroup(
            m_actionButtonPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_actionButtonPanelLayout.createSequentialGroup()
                .add(9, 9, 9)
                .add(m_actionButtonPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(m_performSimpleSegmentationButton)
                    .add(m_performAdvancedSegmentationButton)))
        );

        m_segmentationProgressPanel.add(m_actionButtonPanel);

        add(m_segmentationProgressPanel, java.awt.BorderLayout.CENTER);

        m_tabbedControlContentPanel.setMaximumSize(new java.awt.Dimension(512, 260));
        m_tabbedControlContentPanel.setMinimumSize(new java.awt.Dimension(512, 260));
        m_tabbedControlContentPanel.setPreferredSize(new java.awt.Dimension(512, 260));
        m_tabbedControlContentPanel.setLayout(new java.awt.BorderLayout());

        m_SegmentationPropertiesTabbedPane.setMaximumSize(getMaximumSize());
        m_SegmentationPropertiesTabbedPane.setMinimumSize(getMinimumSize());
        m_SegmentationPropertiesTabbedPane.setPreferredSize(new java.awt.Dimension(512, 255));

        m_segmentationRegionButtonGroup.add(m_segmentWholeImageRadioButton);
        m_segmentWholeImageRadioButton.setSelected(true);
        m_segmentWholeImageRadioButton.setText("whole image");
        m_segmentWholeImageRadioButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        m_segmentWholeImageRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                segmentWholeImageRadioButtonSelected(evt);
            }
        });

        m_segmentationRegionButtonGroup.add(m_segmentWholeImageAfterThresholdingRadioButton);
        m_segmentWholeImageAfterThresholdingRadioButton.setText("image after thressholding");
        m_segmentWholeImageAfterThresholdingRadioButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        m_segmentWholeImageAfterThresholdingRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                segmentImageAfterThressholdingButtonPressed(evt);
            }
        });

        m_minimumThresshold.setEditable(false);

        m_maximumThresshold.setEditable(false);

        jLabel8.setText("minimum");

        jLabel9.setText("maximum");

        m_segmentationRegionButtonGroup.add(m_defineRegionToSegmentRadioButton);
        m_defineRegionToSegmentRadioButton.setText("define area for segmentation");
        m_defineRegionToSegmentRadioButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        m_defineRegionToSegmentRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                segmentGraphicelDefinedRegionButtonPressed(evt);
            }
        });

        m_defineAreaForSegmentationButton.setText("Define Area");
        m_defineAreaForSegmentationButton.setEnabled(false);
        m_defineAreaForSegmentationButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                defineAreaForSegmentationButtonPressed(evt);
            }
        });

        m_deleteAreaForSegmentation.setText("Delete Area");
        m_deleteAreaForSegmentation.setEnabled(false);
        m_deleteAreaForSegmentation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteAreaForSegmentationButtonPressed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout m_regionToSegmentTabLayout = new org.jdesktop.layout.GroupLayout(m_regionToSegmentTab);
        m_regionToSegmentTab.setLayout(m_regionToSegmentTabLayout);
        m_regionToSegmentTabLayout.setHorizontalGroup(
            m_regionToSegmentTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_regionToSegmentTabLayout.createSequentialGroup()
                .addContainerGap()
                .add(m_regionToSegmentTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(m_segmentWholeImageRadioButton)
                    .add(m_regionToSegmentTabLayout.createSequentialGroup()
                        .add(m_segmentWholeImageAfterThresholdingRadioButton)
                        .add(16, 16, 16)
                        .add(jLabel8)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(m_minimumThresshold, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 55, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(12, 12, 12)
                        .add(jLabel9)
                        .add(4, 4, 4)
                        .add(m_maximumThresshold, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 53, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(m_regionToSegmentTabLayout.createSequentialGroup()
                        .add(m_defineRegionToSegmentRadioButton)
                        .add(16, 16, 16)
                        .add(m_defineAreaForSegmentationButton)
                        .add(12, 12, 12)
                        .add(m_deleteAreaForSegmentation)))
                .addContainerGap(39, Short.MAX_VALUE))
        );
        m_regionToSegmentTabLayout.setVerticalGroup(
            m_regionToSegmentTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_regionToSegmentTabLayout.createSequentialGroup()
                .add(22, 22, 22)
                .add(m_segmentWholeImageRadioButton)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_regionToSegmentTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(m_segmentWholeImageAfterThresholdingRadioButton)
                    .add(jLabel8)
                    .add(jLabel9)
                    .add(m_maximumThresshold, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(m_minimumThresshold, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_regionToSegmentTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(m_defineRegionToSegmentRadioButton)
                    .add(m_defineAreaForSegmentationButton)
                    .add(m_deleteAreaForSegmentation))
                .addContainerGap(77, Short.MAX_VALUE))
        );

        m_SegmentationPropertiesTabbedPane.addTab("Region to segment", m_regionToSegmentTab);

        m_segmentationAmplitudeThressholds.setMaximumSize(new java.awt.Dimension(512, 330));
        m_segmentationAmplitudeThressholds.setMinimumSize(new java.awt.Dimension(512, 330));
        m_segmentationAmplitudeThressholds.setPreferredSize(new java.awt.Dimension(512, 330));

        m_pixelThressholdPanel.setLayout(new java.awt.BorderLayout());

        m_maximumPixelValueThresholdSliderLabel.setText("1000");
        m_maximumSliderPanel.add(m_maximumPixelValueThresholdSliderLabel);

        m_maximumPixelValueThresholdSlider.setMajorTickSpacing(250);
        m_maximumPixelValueThresholdSlider.setMaximum(1000);
        m_maximumPixelValueThresholdSlider.setMinorTickSpacing(50);
        m_maximumPixelValueThresholdSlider.setPaintLabels(true);
        m_maximumPixelValueThresholdSlider.setPaintTicks(true);
        m_maximumPixelValueThresholdSlider.setValue(1000);
        m_maximumPixelValueThresholdSlider.setPreferredSize(new java.awt.Dimension(300, 69));
        m_maximumSliderPanel.add(m_maximumPixelValueThresholdSlider);

        m_maxiimumPixelValueLabel.setText("Maximum [‰]");
        m_maximumSliderPanel.add(m_maxiimumPixelValueLabel);

        m_pixelThressholdPanel.add(m_maximumSliderPanel, java.awt.BorderLayout.CENTER);

        m_minimumPixelValueThresholdSliderLabel.setText("0");
        m_minimuSliderPanel.add(m_minimumPixelValueThresholdSliderLabel);

        m_minimumPixelValueThresholdSlider.setMajorTickSpacing(250);
        m_minimumPixelValueThresholdSlider.setMaximum(1000);
        m_minimumPixelValueThresholdSlider.setMinorTickSpacing(50);
        m_minimumPixelValueThresholdSlider.setPaintLabels(true);
        m_minimumPixelValueThresholdSlider.setPaintTicks(true);
        m_minimumPixelValueThresholdSlider.setValue(0);
        m_minimumPixelValueThresholdSlider.setMaximumSize(new java.awt.Dimension(512, 69));
        m_minimumPixelValueThresholdSlider.setMinimumSize(new java.awt.Dimension(250, 69));
        m_minimumPixelValueThresholdSlider.setPreferredSize(new java.awt.Dimension(300, 69));
        m_minimuSliderPanel.add(m_minimumPixelValueThresholdSlider);

        m_minimumPixelValueLabel.setText("Minimum [‰]");
        m_minimuSliderPanel.add(m_minimumPixelValueLabel);

        m_pixelThressholdPanel.add(m_minimuSliderPanel, java.awt.BorderLayout.PAGE_START);

        m_performSimplePixelValueThresholdingBeforeSegmentation.setSelected(true);
        m_performSimplePixelValueThresholdingBeforeSegmentation.setText("Apply thresholding");
        m_performSimplePixelValueThresholdingBeforeSegmentation.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));

        m_autoApplyButton.setSelected(true);
        m_autoApplyButton.setText("auto-apply");
        m_autoApplyButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));

        m_applyMoprphologicalFilteringAfterThressholding.setText("Apply Morphological Filtering");
        m_applyMoprphologicalFilteringAfterThressholding.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_applyMoprphologicalFilteringAfterThressholdingActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout m_thressholdingOptionPanelLayout = new org.jdesktop.layout.GroupLayout(m_thressholdingOptionPanel);
        m_thressholdingOptionPanel.setLayout(m_thressholdingOptionPanelLayout);
        m_thressholdingOptionPanelLayout.setHorizontalGroup(
            m_thressholdingOptionPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_thressholdingOptionPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(m_performSimplePixelValueThresholdingBeforeSegmentation)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_autoApplyButton)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_applyMoprphologicalFilteringAfterThressholding)
                .addContainerGap(32, Short.MAX_VALUE))
        );
        m_thressholdingOptionPanelLayout.setVerticalGroup(
            m_thressholdingOptionPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_thressholdingOptionPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(m_thressholdingOptionPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(m_performSimplePixelValueThresholdingBeforeSegmentation)
                    .add(m_autoApplyButton)
                    .add(m_applyMoprphologicalFilteringAfterThressholding))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        m_pixelThressholdPanel.add(m_thressholdingOptionPanel, java.awt.BorderLayout.PAGE_END);

        org.jdesktop.layout.GroupLayout m_segmentationAmplitudeThressholdsLayout = new org.jdesktop.layout.GroupLayout(m_segmentationAmplitudeThressholds);
        m_segmentationAmplitudeThressholds.setLayout(m_segmentationAmplitudeThressholdsLayout);
        m_segmentationAmplitudeThressholdsLayout.setHorizontalGroup(
            m_segmentationAmplitudeThressholdsLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_pixelThressholdPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        m_segmentationAmplitudeThressholdsLayout.setVerticalGroup(
            m_segmentationAmplitudeThressholdsLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_pixelThressholdPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 195, Short.MAX_VALUE)
        );

        m_SegmentationPropertiesTabbedPane.addTab("Pixel thresholds", m_segmentationAmplitudeThressholds);

        m_segmentAmplitudeBoundsAndSegmentationScoopTab.setMaximumSize(new java.awt.Dimension(512, 330));
        m_segmentAmplitudeBoundsAndSegmentationScoopTab.setMinimumSize(new java.awt.Dimension(512, 330));
        m_segmentAmplitudeBoundsAndSegmentationScoopTab.setPreferredSize(new java.awt.Dimension(512, 330));
        m_segmentAmplitudeBoundsAndSegmentationScoopTab.setLayout(new java.awt.BorderLayout());

        m_rangePropertiesSubPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Segmentation Range Criterium"));

        m_segmentationAmplitudeRangeMultiplyer.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "1", "2", "3", "4", "5", "6", "7", "8", "9", "10" }));
        m_segmentationAmplitudeRangeMultiplyer.setSelectedIndex(1);

        m_rangeDeterminatedByButtonGroup.add(m_rangeDefinedByMinMaxPixelRange3);
        m_rangeDefinedByMinMaxPixelRange3.setText("min/max range");
        m_rangeDefinedByMinMaxPixelRange3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_rangeDefinedByMinMaxPixelRange3ActionPerformed(evt);
            }
        });

        jLabel14.setText("Faktor");

        m_rangeDeterminatedByButtonGroup.add(m_rangeDefinedByStandardDeviation3);
        m_rangeDefinedByStandardDeviation3.setSelected(true);
        m_rangeDefinedByStandardDeviation3.setText("st. dev.");
        m_rangeDefinedByStandardDeviation3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_rangeDefinedByStandardDeviation3ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout m_rangePropertiesSubPanelLayout = new org.jdesktop.layout.GroupLayout(m_rangePropertiesSubPanel);
        m_rangePropertiesSubPanel.setLayout(m_rangePropertiesSubPanelLayout);
        m_rangePropertiesSubPanelLayout.setHorizontalGroup(
            m_rangePropertiesSubPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_rangePropertiesSubPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(m_rangeDefinedByStandardDeviation3)
                .add(18, 18, 18)
                .add(m_rangeDefinedByMinMaxPixelRange3)
                .add(18, 18, 18)
                .add(jLabel14)
                .add(10, 10, 10)
                .add(m_segmentationAmplitudeRangeMultiplyer, 0, 204, Short.MAX_VALUE)
                .addContainerGap())
        );
        m_rangePropertiesSubPanelLayout.setVerticalGroup(
            m_rangePropertiesSubPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_rangePropertiesSubPanelLayout.createSequentialGroup()
                .add(m_rangePropertiesSubPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(m_rangePropertiesSubPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                        .add(m_rangeDefinedByStandardDeviation3)
                        .add(m_rangeDefinedByMinMaxPixelRange3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 29, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(m_rangePropertiesSubPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                        .add(m_segmentationAmplitudeRangeMultiplyer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 29, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(jLabel14, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 29, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(14, Short.MAX_VALUE))
        );

        m_segmentAmplitudeBoundsAndSegmentationScoopTab.add(m_rangePropertiesSubPanel, java.awt.BorderLayout.CENTER);

        m_segmentationScopeSubPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Segmentation Scope"));

        m_segmentationScopeButtonGroup.add(m_applySegmentationToAllSlices);
        m_applySegmentationToAllSlices.setSelected(true);
        m_applySegmentationToAllSlices.setText("Apply to all images");

        m_segmentationScopeButtonGroup.add(m_applySegmentationToCurrentSliceOnly);
        m_applySegmentationToCurrentSliceOnly.setText("Apply to displayed image only");

        org.jdesktop.layout.GroupLayout m_segmentationScopeSubPanelLayout = new org.jdesktop.layout.GroupLayout(m_segmentationScopeSubPanel);
        m_segmentationScopeSubPanel.setLayout(m_segmentationScopeSubPanelLayout);
        m_segmentationScopeSubPanelLayout.setHorizontalGroup(
            m_segmentationScopeSubPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, m_segmentationScopeSubPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(m_applySegmentationToAllSlices)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 120, Short.MAX_VALUE)
                .add(m_applySegmentationToCurrentSliceOnly)
                .addContainerGap())
        );
        m_segmentationScopeSubPanelLayout.setVerticalGroup(
            m_segmentationScopeSubPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_segmentationScopeSubPanelLayout.createSequentialGroup()
                .add(m_segmentationScopeSubPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(m_applySegmentationToCurrentSliceOnly, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 16, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(m_applySegmentationToAllSlices, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 16, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        m_segmentAmplitudeBoundsAndSegmentationScoopTab.add(m_segmentationScopeSubPanel, java.awt.BorderLayout.PAGE_START);

        m_subSegmentationSubPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Sub Segmentation Scope"));

        m_subSegmentationButtonGroup.add(m_applySubSegmentationToAllImages);
        m_applySubSegmentationToAllImages.setText("Apply to all images");
        m_applySubSegmentationToAllImages.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_applySubSegmentationToAllImagesActionPerformed(evt);
            }
        });

        m_subSegmentationButtonGroup.add(m_applySubSegmentationToCurrentlyDisplayedImageOnly);
        m_applySubSegmentationToCurrentlyDisplayedImageOnly.setSelected(true);
        m_applySubSegmentationToCurrentlyDisplayedImageOnly.setText("Apply to displayed image only");
        m_applySubSegmentationToCurrentlyDisplayedImageOnly.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_applySubSegmentationToCurrentlyDisplayedImageOnlyActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout m_subSegmentationSubPanelLayout = new org.jdesktop.layout.GroupLayout(m_subSegmentationSubPanel);
        m_subSegmentationSubPanel.setLayout(m_subSegmentationSubPanelLayout);
        m_subSegmentationSubPanelLayout.setHorizontalGroup(
            m_subSegmentationSubPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, m_subSegmentationSubPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(m_applySubSegmentationToAllImages)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 120, Short.MAX_VALUE)
                .add(m_applySubSegmentationToCurrentlyDisplayedImageOnly)
                .addContainerGap())
        );
        m_subSegmentationSubPanelLayout.setVerticalGroup(
            m_subSegmentationSubPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_subSegmentationSubPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                .add(m_applySubSegmentationToCurrentlyDisplayedImageOnly, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 33, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(m_applySubSegmentationToAllImages, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 37, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
        );

        m_segmentAmplitudeBoundsAndSegmentationScoopTab.add(m_subSegmentationSubPanel, java.awt.BorderLayout.PAGE_END);

        m_SegmentationPropertiesTabbedPane.addTab("Segment Bounds & Scope", m_segmentAmplitudeBoundsAndSegmentationScoopTab);

        m_probingRegionPropertiesPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Properties of probing region"));

        jLabel2.setText("#pixels y-direction");

        jLabel1.setText("#pixels x-direction");

        m_defineProbeSizeX.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15" }));
        m_defineProbeSizeX.setSelectedIndex(2);

        m_defineProbeSizeY.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15" }));
        m_defineProbeSizeY.setSelectedIndex(2);

        jLabel3.setText("#of probe  pixels");

        m_numberOfProbingPixels.setText("9");

        m_initializeOSFlitering.setText("(Re-) Initialize OSF filtering");
        m_initializeOSFlitering.setSelected(true);
        m_initializeOSFlitering.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_initializeOSFliteringActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout m_probingRegionPropertiesPanelLayout = new org.jdesktop.layout.GroupLayout(m_probingRegionPropertiesPanel);
        m_probingRegionPropertiesPanel.setLayout(m_probingRegionPropertiesPanelLayout);
        m_probingRegionPropertiesPanelLayout.setHorizontalGroup(
            m_probingRegionPropertiesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_probingRegionPropertiesPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(m_probingRegionPropertiesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel1)
                    .add(jLabel2)
                    .add(jLabel3))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_probingRegionPropertiesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(m_initializeOSFlitering, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 224, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(m_probingRegionPropertiesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                        .add(m_numberOfProbingPixels)
                        .add(org.jdesktop.layout.GroupLayout.TRAILING, m_defineProbeSizeY, 0, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(org.jdesktop.layout.GroupLayout.TRAILING, m_defineProbeSizeX, 0, 120, Short.MAX_VALUE)))
                .add(135, 135, 135))
        );
        m_probingRegionPropertiesPanelLayout.setVerticalGroup(
            m_probingRegionPropertiesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, m_probingRegionPropertiesPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(m_probingRegionPropertiesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(m_defineProbeSizeX, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_probingRegionPropertiesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2)
                    .add(m_defineProbeSizeY, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_probingRegionPropertiesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel3)
                    .add(m_numberOfProbingPixels, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 29, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_initializeOSFlitering)
                .add(16, 16, 16))
        );

        org.jdesktop.layout.GroupLayout m_probingRegionPropertiesTabLayout = new org.jdesktop.layout.GroupLayout(m_probingRegionPropertiesTab);
        m_probingRegionPropertiesTab.setLayout(m_probingRegionPropertiesTabLayout);
        m_probingRegionPropertiesTabLayout.setHorizontalGroup(
            m_probingRegionPropertiesTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, m_probingRegionPropertiesPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        m_probingRegionPropertiesTabLayout.setVerticalGroup(
            m_probingRegionPropertiesTabLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_probingRegionPropertiesPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        m_SegmentationPropertiesTabbedPane.addTab("Prototype OSF ROI Properties", m_probingRegionPropertiesTab);

        m_probingCriteriaPropertiesTab.setLayout(new java.awt.BorderLayout());

        m_probingCriteriaTabbedPane.setTabPlacement(javax.swing.JTabbedPane.BOTTOM);
        m_probingCriteriaTabbedPane.setMaximumSize(new java.awt.Dimension(536, 208));

        m_pixelThressholdPanel1.setLayout(new java.awt.BorderLayout());

        m_maximumSliderPanel1.setMaximumSize(new java.awt.Dimension(422, 40));
        m_maximumSliderPanel1.setPreferredSize(new java.awt.Dimension(422, 50));

        m_maximumOSFThresholdSliderLabel.setText("10000");
        m_maximumSliderPanel1.add(m_maximumOSFThresholdSliderLabel);

        m_maximumOSFThresholdSlider.setMajorTickSpacing(250);
        m_maximumOSFThresholdSlider.setMaximum(10000);
        m_maximumOSFThresholdSlider.setMinorTickSpacing(10);
        m_maximumOSFThresholdSlider.setValue(10000);
        m_maximumOSFThresholdSlider.setPreferredSize(new java.awt.Dimension(300, 45));
        m_maximumSliderPanel1.add(m_maximumOSFThresholdSlider);

        m_maxiimumLabel1.setText("Maximum [‰]");
        m_maximumSliderPanel1.add(m_maxiimumLabel1);

        m_applyOSFThresholdingBeforeSegmentation.setSelected(true);
        m_applyOSFThresholdingBeforeSegmentation.setText("Thresh. before segmentation");
        m_applyOSFThresholdingBeforeSegmentation.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));

        m_autoApplySimpleOSFThressholdingButton.setSelected(true);
        m_autoApplySimpleOSFThressholdingButton.setText("auto-apply");
        m_autoApplySimpleOSFThressholdingButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));

        org.jdesktop.layout.GroupLayout m_thressholdingOptionPanel1Layout = new org.jdesktop.layout.GroupLayout(m_thressholdingOptionPanel1);
        m_thressholdingOptionPanel1.setLayout(m_thressholdingOptionPanel1Layout);
        m_thressholdingOptionPanel1Layout.setHorizontalGroup(
            m_thressholdingOptionPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_thressholdingOptionPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(m_applyOSFThresholdingBeforeSegmentation)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_autoApplySimpleOSFThressholdingButton)
                .addContainerGap(183, Short.MAX_VALUE))
        );
        m_thressholdingOptionPanel1Layout.setVerticalGroup(
            m_thressholdingOptionPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_thressholdingOptionPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(m_thressholdingOptionPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(m_applyOSFThresholdingBeforeSegmentation)
                    .add(m_autoApplySimpleOSFThressholdingButton))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        m_maximumSliderPanel1.add(m_thressholdingOptionPanel1);

        m_pixelThressholdPanel1.add(m_maximumSliderPanel1, java.awt.BorderLayout.CENTER);

        m_minimuSliderPanel1.setPreferredSize(new java.awt.Dimension(422, 50));

        m_minimumOSFThresholdSliderLabel.setText("0");
        m_minimuSliderPanel1.add(m_minimumOSFThresholdSliderLabel);

        m_minimumOSFThresholdSlider.setMajorTickSpacing(250);
        m_minimumOSFThresholdSlider.setMaximum(10000);
        m_minimumOSFThresholdSlider.setMinorTickSpacing(10);
        m_minimumOSFThresholdSlider.setValue(0);
        m_minimumOSFThresholdSlider.setMaximumSize(new java.awt.Dimension(512, 69));
        m_minimumOSFThresholdSlider.setMinimumSize(new java.awt.Dimension(250, 50));
        m_minimumOSFThresholdSlider.setPreferredSize(new java.awt.Dimension(300, 45));
        m_minimuSliderPanel1.add(m_minimumOSFThresholdSlider);

        m_minimumLabel1.setText("Minimum [‰]");
        m_minimuSliderPanel1.add(m_minimumLabel1);

        m_pixelThressholdPanel1.add(m_minimuSliderPanel1, java.awt.BorderLayout.PAGE_START);

        org.jdesktop.layout.GroupLayout m_OSF1PropertyPanelLayout = new org.jdesktop.layout.GroupLayout(m_OSF1PropertyPanel);
        m_OSF1PropertyPanel.setLayout(m_OSF1PropertyPanelLayout);
        m_OSF1PropertyPanelLayout.setHorizontalGroup(
            m_OSF1PropertyPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_pixelThressholdPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 562, Short.MAX_VALUE)
        );
        m_OSF1PropertyPanelLayout.setVerticalGroup(
            m_OSF1PropertyPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_pixelThressholdPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 151, Short.MAX_VALUE)
        );

        m_probingCriteriaTabbedPane.addTab("OSF-Thresholds", m_OSF1PropertyPanel);

        m_OSFSortingTypeToApply.add(m_maximumOrder_Min2MaxSorting);
        m_maximumOrder_Min2MaxSorting.setText("Maximum-order --> (Min --> Max) sorting");
        m_maximumOrder_Min2MaxSorting.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_maximumOrder_Min2MaxSortingActionPerformed(evt);
            }
        });

        m_OSFSortingTypeToApply.add(m_median2MinMaxSorting);
        m_median2MinMaxSorting.setSelected(true);
        m_median2MinMaxSorting.setText("Median-order --> (Min <-- Med -- > Max) sorting");
        m_median2MinMaxSorting.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_median2MinMaxSortingActionPerformed(evt);
            }
        });

        m_OSFSortingTypeToApply.add(m_minimumOrder_Min2MaxSorting);
        m_minimumOrder_Min2MaxSorting.setText("Minimum-order --> (Min -- > Max) sorting");
        m_minimumOrder_Min2MaxSorting.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_minimumOrder_Min2MaxSortingActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout m_OSF2PropertiesPanelLayout = new org.jdesktop.layout.GroupLayout(m_OSF2PropertiesPanel);
        m_OSF2PropertiesPanel.setLayout(m_OSF2PropertiesPanelLayout);
        m_OSF2PropertiesPanelLayout.setHorizontalGroup(
            m_OSF2PropertiesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_OSF2PropertiesPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(m_OSF2PropertiesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(m_minimumOrder_Min2MaxSorting)
                    .add(m_median2MinMaxSorting)
                    .add(m_maximumOrder_Min2MaxSorting))
                .addContainerGap(166, Short.MAX_VALUE))
        );
        m_OSF2PropertiesPanelLayout.setVerticalGroup(
            m_OSF2PropertiesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_OSF2PropertiesPanelLayout.createSequentialGroup()
                .add(21, 21, 21)
                .add(m_minimumOrder_Min2MaxSorting)
                .add(18, 18, 18)
                .add(m_median2MinMaxSorting)
                .add(18, 18, 18)
                .add(m_maximumOrder_Min2MaxSorting)
                .addContainerGap(22, Short.MAX_VALUE))
        );

        m_probingCriteriaTabbedPane.addTab("OSF-2", m_OSF2PropertiesPanel);

        org.jdesktop.layout.GroupLayout m_OSF3PropertyPanelLayout = new org.jdesktop.layout.GroupLayout(m_OSF3PropertyPanel);
        m_OSF3PropertyPanel.setLayout(m_OSF3PropertyPanelLayout);
        m_OSF3PropertyPanelLayout.setHorizontalGroup(
            m_OSF3PropertyPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 528, Short.MAX_VALUE)
        );
        m_OSF3PropertyPanelLayout.setVerticalGroup(
            m_OSF3PropertyPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 151, Short.MAX_VALUE)
        );

        m_probingCriteriaTabbedPane.addTab("OSF-3", m_OSF3PropertyPanel);

        m_viewHistogramsButton.setText("View Histograms");
        m_viewHistogramsButton.setToolTipText("Shows the histograms of the statistic orders");
        m_viewHistogramsButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_viewHistogramsButtonActionPerformed(evt);
            }
        });

        m_viewRegionOrderSpectrumButton.setText("Rank Order Spectra of ROIs ..");
        m_viewRegionOrderSpectrumButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_viewRegionOrderSpectrumButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout m_OSF4PropertiesPanelLayout = new org.jdesktop.layout.GroupLayout(m_OSF4PropertiesPanel);
        m_OSF4PropertiesPanel.setLayout(m_OSF4PropertiesPanelLayout);
        m_OSF4PropertiesPanelLayout.setHorizontalGroup(
            m_OSF4PropertiesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_OSF4PropertiesPanelLayout.createSequentialGroup()
                .add(46, 46, 46)
                .add(m_OSF4PropertiesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(m_viewRegionOrderSpectrumButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(m_viewHistogramsButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(273, Short.MAX_VALUE))
        );
        m_OSF4PropertiesPanelLayout.setVerticalGroup(
            m_OSF4PropertiesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_OSF4PropertiesPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(m_viewHistogramsButton)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_viewRegionOrderSpectrumButton)
                .addContainerGap(73, Short.MAX_VALUE))
        );

        m_probingCriteriaTabbedPane.addTab("OSF-Histogram viewer..", m_OSF4PropertiesPanel);

        m_probingCriteriaPropertiesTab.add(m_probingCriteriaTabbedPane, java.awt.BorderLayout.CENTER);

        m_SegmentationPropertiesTabbedPane.addTab("Order Statistics Properties", m_probingCriteriaPropertiesTab);

        m_SegmentationPropertiesTabbedPane.setSelectedIndex(3);

        m_tabbedControlContentPanel.add(m_SegmentationPropertiesTabbedPane, java.awt.BorderLayout.NORTH);

        add(m_tabbedControlContentPanel, java.awt.BorderLayout.NORTH);
    }// </editor-fold>//GEN-END:initComponents

    private void performSegmentationButtonPressed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_performSegmentationButtonPressed
        notifyActionListeners( START_SEGMENTATION );
    }//GEN-LAST:event_performSegmentationButtonPressed

    private void deleteAreaForSegmentationButtonPressed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteAreaForSegmentationButtonPressed
        notifyActionListeners( REMOVE_GRAPHIC_SEGMENTATION_REGION_REQUIRED );
        m_segmentWholeImageRadioButton.setSelected( true );
        m_defineAreaForSegmentationButton.setEnabled( false );
        m_deleteAreaForSegmentation.setEnabled( false );
    }//GEN-LAST:event_deleteAreaForSegmentationButtonPressed

    private void defineAreaForSegmentationButtonPressed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_defineAreaForSegmentationButtonPressed
        notifyActionListeners( GRAPHIC_SEGMENTATION_REGION_DEFINITION_REQUIRED );
    }//GEN-LAST:event_defineAreaForSegmentationButtonPressed

    /**
     * User selects the radio button indicating that he wants
     * to define a region in the image for segmentation
     */
    private void segmentGraphicelDefinedRegionButtonPressed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_segmentGraphicelDefinedRegionButtonPressed
        m_minimumThresshold.setEditable( false );
        m_maximumThresshold.setEditable( false );
        m_defineAreaForSegmentationButton.setEnabled( true );
        m_deleteAreaForSegmentation.setEnabled( true );
    }//GEN-LAST:event_segmentGraphicelDefinedRegionButtonPressed

    private void segmentImageAfterThressholdingButtonPressed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_segmentImageAfterThressholdingButtonPressed
        m_minimumThresshold.setEditable( true );
        m_maximumThresshold.setEditable( true );
        m_defineAreaForSegmentationButton.setEnabled( false );
        m_deleteAreaForSegmentation.setEnabled( false );
    }//GEN-LAST:event_segmentImageAfterThressholdingButtonPressed

    private void segmentWholeImageRadioButtonSelected(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_segmentWholeImageRadioButtonSelected
       m_minimumThresshold.setEditable( false );
       m_maximumThresshold.setEditable( false );
       m_defineAreaForSegmentationButton.setEnabled( false );
       m_deleteAreaForSegmentation.setEnabled( false );
    }//GEN-LAST:event_segmentWholeImageRadioButtonSelected

private void m_applySubSegmentationToAllImagesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_applySubSegmentationToAllImagesActionPerformed
// TODO add your handling code here:
        notifyActionListeners( SUBSEGMENT_IN_ALL_SLICES );
}//GEN-LAST:event_m_applySubSegmentationToAllImagesActionPerformed

private void m_applySubSegmentationToCurrentlyDisplayedImageOnlyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_applySubSegmentationToCurrentlyDisplayedImageOnlyActionPerformed
        notifyActionListeners( SUBSEGMENT_IN_CURRENTLY_SELECTED_SLICE_ONLY );
}//GEN-LAST:event_m_applySubSegmentationToCurrentlyDisplayedImageOnlyActionPerformed

private void m_rangeDefinedByMinMaxPixelRange3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_rangeDefinedByMinMaxPixelRange3ActionPerformed
    // TODO add your handling code here:
}//GEN-LAST:event_m_rangeDefinedByMinMaxPixelRange3ActionPerformed

private void m_rangeDefinedByStandardDeviation3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_rangeDefinedByStandardDeviation3ActionPerformed
    // TODO add your handling code here:
}//GEN-LAST:event_m_rangeDefinedByStandardDeviation3ActionPerformed

private void m_initializeOSFliteringActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_initializeOSFliteringActionPerformed
    // TODO add your handling code here:
    notifyActionListeners( INITIALIZE_ORDER_STATISTIC_FILTERING );
}//GEN-LAST:event_m_initializeOSFliteringActionPerformed

private void m_viewHistogramsButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_viewHistogramsButtonActionPerformed

    notifyActionListeners( VIEW_OSF_HISTOGRAMS );
}//GEN-LAST:event_m_viewHistogramsButtonActionPerformed

private void m_performAdvancedSegmentationButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_performAdvancedSegmentationButtonActionPerformed
    // TODO add your handling code here:
}//GEN-LAST:event_m_performAdvancedSegmentationButtonActionPerformed

private void m_median2MinMaxSortingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_median2MinMaxSortingActionPerformed
    if ( m_median2MinMaxSorting.isSelected( ) )
    {
        notifyActionListeners( INITIALIZE_ORDER_STATISTIC_FILTERING );
    }
}//GEN-LAST:event_m_median2MinMaxSortingActionPerformed

private void m_minimumOrder_Min2MaxSortingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_minimumOrder_Min2MaxSortingActionPerformed
    if ( m_minimumOrder_Min2MaxSorting.isSelected( ) )
    {
        notifyActionListeners( INITIALIZE_ORDER_STATISTIC_FILTERING );
    }
}//GEN-LAST:event_m_minimumOrder_Min2MaxSortingActionPerformed

private void m_maximumOrder_Min2MaxSortingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_maximumOrder_Min2MaxSortingActionPerformed
    if ( m_maximumOrder_Min2MaxSorting.isSelected( ) )
    {
        notifyActionListeners( INITIALIZE_ORDER_STATISTIC_FILTERING );
    }
}//GEN-LAST:event_m_maximumOrder_Min2MaxSortingActionPerformed

    private void m_viewRegionOrderSpectrumButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_viewRegionOrderSpectrumButtonActionPerformed
        notifyActionListeners( VIEW_RANK_ORDER_SPECTRA );
    }//GEN-LAST:event_m_viewRegionOrderSpectrumButtonActionPerformed

    private void m_applyMoprphologicalFilteringAfterThressholdingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_applyMoprphologicalFilteringAfterThressholdingActionPerformed
        notifyActionListeners( APPLY_MORPHOLOGICAL_FILTERING_AFTER_THRESSOLDING );
        if ( m_autoApplyButton.isSelected( ) )
        {
            notifyActionListeners( START_SEGMENTATION );
        }
    }//GEN-LAST:event_m_applyMoprphologicalFilteringAfterThressholdingActionPerformed
    
    /**
     * Adds an actionlistener to the list of action listeners who are notified
     * when something happens with the spinbox
     */
    public void addActionListener( ActionListener e )
    {
        m_listeners.add( e );
    }
    
    /**
     * Notify all actionListeners
     */
    private void notifyActionListeners( int eventType )
    {
        Iterator it = m_listeners.iterator( );
        while( it.hasNext( ) )
        {
            ( ( ActionListener )it.next( ) ).actionPerformed( new ActionEvent( this, eventType, "" ) );
        }
    }

    /**
     * Is called when ever a registered class raises an action event
     */
    public void actionPerformed( ActionEvent e ) 
    {
        
        Object sender = e.getSource( );
        
        if ( sender instanceof OrderStatisticSegmentationCalculator  )
        {
            if ( e.getID( ) == OrderStatisticSegmentationCalculator.START_RECALCULATION_OSF_SEGMENTATION_EVENT )
            {
                m_progressActivityLabel.setText( "<HTML><FONT COLOR = RED> Recalculating OSF..</FONT></HTML>" );
                m_segmentationProgressBar.setValue( ( (OrderStatisticSegmentationCalculator)e.getSource( ) ).getProgress( ) );
            }

            if ( e.getID( ) == OrderStatisticSegmentationCalculator.NOTIFY_OSF_PROGRESS_EVENT_PASS_1 )
            {
                m_progressActivityLabel.setText( "<HTML><FONT COLOR = RED> Initializing -> Pass 1</FONT></HTML>" );
                m_segmentationProgressBar.setValue( ( (OrderStatisticSegmentationCalculator)e.getSource( ) ).getProgress( ) );
            }

            if ( e.getID( ) == OrderStatisticSegmentationCalculator.NOTIFY_OSF_PROGRESS_EVENT_PASS_2 )
            {
                m_progressActivityLabel.setText( "<HTML><FONT COLOR = RED>Initializing -> Pass 2</FONT></HTML>" );
                m_segmentationProgressBar.setValue( ( (OrderStatisticSegmentationCalculator)e.getSource( ) ).getProgress( ) );
            }

            if ( e.getID( ) == OrderStatisticSegmentationCalculator.NOTIFY_OSF_PROGRESS_EVENT_PASS_3 )
            {
                m_progressActivityLabel.setText( "<HTML><FONT COLOR = RED>Initializing -> Pass 3</FONT></HTML>" );
                m_segmentationProgressBar.setValue( ( (OrderStatisticSegmentationCalculator)e.getSource( ) ).getProgress( ) );
            }

            if ( e.getID( ) == OrderStatisticSegmentationCalculator.NOTIFY_OSF_PROGRESS_EVENT_PASS_4 )
            {
                m_progressActivityLabel.setText( "<HTML><FONT COLOR = BLUE>Sorting data -> Pass 4</FONT></HTML>" );
                m_segmentationProgressBar.setValue( ( (OrderStatisticSegmentationCalculator)e.getSource( ) ).getProgress( ) );
            }

            if ( e.getID( ) == OrderStatisticSegmentationCalculator.NOTIFY_OSF_PROGRESS_EVENT_PASS_5 )
            {
                m_progressActivityLabel.setText( "<HTML><FONT COLOR = BLUE>OSF-thressholding .. </FONT></HTML>" );
                m_segmentationProgressBar.setValue( ( (OrderStatisticSegmentationCalculator)e.getSource( ) ).getProgress( ) );
            }


            if ( e.getID( ) == OrderStatisticSegmentationCalculator.OSF_INITIALIZATION_READY_EVENT )
            {
                m_segmentationProgressBar.setValue( 0 );
                m_progressActivityLabel.setText( "<HTML><FONT COLOR = GREEN>OSF-control initialized!</FONT></HTML>" );
            }

            if ( e.getID( ) == OrderStatisticSegmentationCalculator.OSF_SEGMENTATION_PERFORMED_EVENT )
            {
                m_segmentationProgressBar.setValue( 0 );
                m_progressActivityLabel.setText( "<HTML><FONT COLOR = GREEN>OSF-segmentation done!</FONT></HTML>" );
            }

        }   
    }
    
    /**
     * Is called whenever a registered component raises a change event
     */
    public void stateChanged( ChangeEvent e ) 
    {
        Object sender = e.getSource( );
        
        if ( sender == m_minimumPixelValueThresholdSlider )
        {
            if ( !m_minimumPixelValueThresholdSlider.getValueIsAdjusting( ) )
            {
                //notifyActionListeners( MINIMUM_VALUE_CHANGE_EVENT );
                
                if ( this.m_autoApplyButton.isSelected( ) )
                {
                    notifyActionListeners( START_SEGMENTATION );
                }
            }
            m_minimumPixelValueThresholdSliderLabel.setText( "" + (int)( m_minimumPixelValueThresholdSlider.getValue( ) * m_maxPixVal / 1000f ) );
        }
        
        if ( sender == m_maximumPixelValueThresholdSlider )
        {
            if ( !m_maximumPixelValueThresholdSlider.getValueIsAdjusting( ) )
            {
                //notifyActionListeners( MAXIMUM_VALUE_CHANGE_EVENT );
                
                if ( this.m_autoApplyButton.isSelected( ) )
                {
                    notifyActionListeners( START_SEGMENTATION );
                }
            }
            m_maximumPixelValueThresholdSliderLabel.setText( "" + (int)( m_maximumPixelValueThresholdSlider.getValue( ) * m_maxPixVal / 1000f ) );
        }

        // The user modifies the order statistics minimum slider value
        if ( sender == m_minimumOSFThresholdSlider )
        {
            if ( !m_minimumOSFThresholdSlider.getValueIsAdjusting( ) )
            {
                notifyActionListeners( MINIMUM_OSF_VALUE_CHANGE_EVENT );

                if ( m_autoApplyButton.isSelected( ) )
                {
                    notifyActionListeners( START_SEGMENTATION );
                }
            }
            m_minimumOSFThresholdSliderLabel.setText( "" + (int)( m_minimumPixelValueThresholdSlider.getValue( ) * m_maxPixVal / 1000f ) );
        }

        if ( sender == m_maximumOSFThresholdSlider )
        {
            if ( !m_maximumOSFThresholdSlider.getValueIsAdjusting( ) )
            {

                notifyActionListeners( MAXIMUM_OSF_VALUE_CHANGE_EVENT );

                if ( m_autoApplyButton.isSelected( ) )
                {
                    notifyActionListeners( START_SEGMENTATION );
                }
            }
            m_maximumOSFThresholdSliderLabel.setText( "" + (int)( m_maximumPixelValueThresholdSlider.getValue( ) * m_maxPixVal / 1000f ) );
        }
    }


    /**
     * Returns the minimum value of the OSF slider
     * @return
     */
    public int getMininumValue_Of_OSF_ThressholdSlider( )
    {
        return m_minimumOSFThresholdSlider.getValue( );
    }

    /**
     * Returns the maximum value of the OSF slider
     * @return
     */
    public int getMaxinumValue_Of_OSF_ThressholdSlider( )
    {
        return m_maximumOSFThresholdSlider.getValue( );
    }

     /**
     * Returns the user defined value of the minimum threshold slider
     */
    public int getValueOfMinimumThresholdSlider( )
    {
        return (int)( m_minimumPixelValueThresholdSlider.getValue( ) * m_maxPixVal / 1000f );
        //return m_minimumThresholdSlider.getValue( );
    }
    
    /**
     * Returns the user defined value of the maximum threshold slider
     */
    public int getValueOfMaximumThresholdSlider( )
    {
        return (int)( m_maximumPixelValueThresholdSlider.getValue( ) * m_maxPixVal / 1000f );
        //return m_maximumThresholdSlider.getValue( );
    }
    
    /**
     * Returns whether the user wants the segmentation calculator to perform
     * a simple thresholding (based on user defined values before the true segmentation
     */ 
    public boolean performSimplePixelValueThresholdingBeforeSegmentation( )
    {
        return m_performSimplePixelValueThresholdingBeforeSegmentation.isSelected( );
    }

    
    /**
     * Returns whether the user wants the segmentation calculator to perform
     * a simple thresholding (based on user defined values before the true segmentation
     */
    public boolean performSimpleOSFThresholdingBeforeSegmentation( )
    {
        return m_applyOSFThresholdingBeforeSegmentation.isSelected( );
    }


    /**
     * Returns the value of probesize X
     */
    public int getProbeSizeX( )
    {
        return m_defineProbeSizeX.getSelectedIndex( ) + 1;
    }
    
    /**
     * Returns the value of probesize Y
     */
    public int getProbeSizeY( )
    {
        return m_defineProbeSizeY.getSelectedIndex( ) + 1;
    }
    
    /**
     * Returns the number of permutations
     */
    public int getNumberOfProbingPixels( )
    {
        return ( new Integer( m_numberOfProbingPixels.getText( ) ) ).intValue( );
    }  
    
    /**
     * Method that determines the scope of the sub segment selection by 
     * double clicking. Apply it either to all or to selected image only.
     * @return int value SUBSEGMENT_IN_ALL_SLICES or SUBSEGMENT_IN_CURRENTLY_SELECTED_SLICE_ONLY
     */
    public int getSubSegmentScope( )
    {
        if ( m_applySubSegmentationToAllImages.isSelected( ) == true )
        {
            return SUBSEGMENT_IN_ALL_SLICES;
        }
        else
        {
            return SUBSEGMENT_IN_CURRENTLY_SELECTED_SLICE_ONLY;
        }
    }
    
    /**
     * Determines the way the pixel range is taken which is used in the
     * segmentation 
     * @return
     */
    public int getPixelRangeComputationType( )
    {
        return m_pixelRangeDeterminationType;
    }


    /**
     * Returns the value with which the range must be mulitplied
     * @return
     */
    public int getRangeMultiplier( )
    {
        String value = (String)m_segmentationAmplitudeRangeMultiplyer.getModel( ).getSelectedItem( );
        return new Integer( value ).intValue( );
    }

    /**
     * Returns whether an automatical Morphological Filtering should be Applied
     * after filtering.
     * @return 
     */
    public boolean getApplyMorphologicalFilteringAfterThresholding( )
    {
        return this.m_applyMoprphologicalFilteringAfterThressholding.isSelected();
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel m_OSF1PropertyPanel;
    private javax.swing.JPanel m_OSF2PropertiesPanel;
    private javax.swing.JPanel m_OSF3PropertyPanel;
    private javax.swing.JPanel m_OSF4PropertiesPanel;
    private javax.swing.ButtonGroup m_OSFSortingTypeToApply;
    private javax.swing.JTabbedPane m_SegmentationPropertiesTabbedPane;
    private javax.swing.JPanel m_actionButtonPanel;
    private javax.swing.JCheckBox m_applyMoprphologicalFilteringAfterThressholding;
    private javax.swing.JCheckBox m_applyOSFThresholdingBeforeSegmentation;
    private javax.swing.JRadioButton m_applySegmentationToAllSlices;
    private javax.swing.JRadioButton m_applySegmentationToCurrentSliceOnly;
    private javax.swing.JRadioButton m_applySubSegmentationToAllImages;
    private javax.swing.JRadioButton m_applySubSegmentationToCurrentlyDisplayedImageOnly;
    private javax.swing.JCheckBox m_autoApplyButton;
    private javax.swing.JCheckBox m_autoApplySimpleOSFThressholdingButton;
    private javax.swing.JButton m_defineAreaForSegmentationButton;
    private javax.swing.JComboBox m_defineProbeSizeX;
    private javax.swing.JComboBox m_defineProbeSizeY;
    private javax.swing.JRadioButton m_defineRegionToSegmentRadioButton;
    private javax.swing.JButton m_deleteAreaForSegmentation;
    private javax.swing.JButton m_initializeOSFlitering;
    private javax.swing.JLabel m_maxiimumLabel1;
    private javax.swing.JLabel m_maxiimumPixelValueLabel;
    private javax.swing.JSlider m_maximumOSFThresholdSlider;
    private javax.swing.JLabel m_maximumOSFThresholdSliderLabel;
    private javax.swing.JRadioButton m_maximumOrder_Min2MaxSorting;
    private javax.swing.JSlider m_maximumPixelValueThresholdSlider;
    private javax.swing.JLabel m_maximumPixelValueThresholdSliderLabel;
    private javax.swing.JPanel m_maximumSliderPanel;
    private javax.swing.JPanel m_maximumSliderPanel1;
    private javax.swing.JTextField m_maximumThresshold;
    private javax.swing.JRadioButton m_median2MinMaxSorting;
    private javax.swing.JPanel m_minimuSliderPanel;
    private javax.swing.JPanel m_minimuSliderPanel1;
    private javax.swing.JLabel m_minimumLabel1;
    private javax.swing.JSlider m_minimumOSFThresholdSlider;
    private javax.swing.JLabel m_minimumOSFThresholdSliderLabel;
    private javax.swing.JRadioButton m_minimumOrder_Min2MaxSorting;
    private javax.swing.JLabel m_minimumPixelValueLabel;
    private javax.swing.JSlider m_minimumPixelValueThresholdSlider;
    private javax.swing.JLabel m_minimumPixelValueThresholdSliderLabel;
    private javax.swing.JTextField m_minimumThresshold;
    private javax.swing.JTextField m_numberOfProbingPixels;
    private javax.swing.JButton m_performAdvancedSegmentationButton;
    private javax.swing.JCheckBox m_performSimplePixelValueThresholdingBeforeSegmentation;
    private javax.swing.JButton m_performSimpleSegmentationButton;
    private javax.swing.ButtonGroup m_permutationNumber;
    private javax.swing.JPanel m_pixelThressholdPanel;
    private javax.swing.JPanel m_pixelThressholdPanel1;
    private javax.swing.JPanel m_probingCriteriaPropertiesTab;
    private javax.swing.JTabbedPane m_probingCriteriaTabbedPane;
    private javax.swing.JPanel m_probingRegionPropertiesPanel;
    private javax.swing.JPanel m_probingRegionPropertiesTab;
    private javax.swing.JLabel m_progressActivityLabel;
    private javax.swing.JRadioButton m_rangeDefinedByMinMaxPixelRange3;
    private javax.swing.JRadioButton m_rangeDefinedByStandardDeviation3;
    private javax.swing.ButtonGroup m_rangeDeterminatedByButtonGroup;
    private javax.swing.JPanel m_rangePropertiesSubPanel;
    private javax.swing.JPanel m_regionToSegmentTab;
    private javax.swing.JPanel m_segmentAmplitudeBoundsAndSegmentationScoopTab;
    private javax.swing.JRadioButton m_segmentWholeImageAfterThresholdingRadioButton;
    private javax.swing.JRadioButton m_segmentWholeImageRadioButton;
    private javax.swing.JComboBox m_segmentationAmplitudeRangeMultiplyer;
    private javax.swing.JPanel m_segmentationAmplitudeThressholds;
    private javax.swing.JProgressBar m_segmentationProgressBar;
    private javax.swing.JPanel m_segmentationProgressPanel;
    private javax.swing.ButtonGroup m_segmentationRegionButtonGroup;
    private javax.swing.ButtonGroup m_segmentationScopeButtonGroup;
    private javax.swing.JPanel m_segmentationScopeSubPanel;
    private javax.swing.ButtonGroup m_subSegmentationButtonGroup;
    private javax.swing.JPanel m_subSegmentationSubPanel;
    private javax.swing.JPanel m_tabbedControlContentPanel;
    private javax.swing.JPanel m_thressholdingOptionPanel;
    private javax.swing.JPanel m_thressholdingOptionPanel1;
    private javax.swing.JButton m_viewHistogramsButton;
    private javax.swing.JButton m_viewRegionOrderSpectrumButton;
    // End of variables declaration//GEN-END:variables
    
    // Listeners to changes in the segmentation gui control
    private LinkedList<ActionListener> m_listeners = new LinkedList<ActionListener>( );
    
    
    // For proper serialization
    private static final long serialVersionUID = 1412325898865493L;
    
    public final static int GRAPHIC_SEGMENTATION_REGION_DEFINITION_REQUIRED = 0;
    public final static int REMOVE_GRAPHIC_SEGMENTATION_REGION_REQUIRED = 1;
    public final static int START_SEGMENTATION = 2;
    public final static int STOP_SEGMENTATION = 3;
    
    public final static int MINIMUM_VALUE_CHANGE_EVENT = 4;
    public final static int MAXIMUM_VALUE_CHANGE_EVENT = 5;

    public final static int MINIMUM_OSF_VALUE_CHANGE_EVENT = 6;
    public final static int MAXIMUM_OSF_VALUE_CHANGE_EVENT = 7;

    public final static int VIEW_OSF_HISTOGRAMS = 10;
    public final static int VIEW_RANK_ORDER_SPECTRA = 11;
    public final static int APPLY_MORPHOLOGICAL_FILTERING_AFTER_THRESSOLDING = 12;

    public final static int SUBSEGMENT_IN_CURRENTLY_SELECTED_SLICE_ONLY     = 100;
    public final static int SUBSEGMENT_IN_ALL_SLICES                        = 101;
    
    public final static int PIXEL_RANGE_DEFINED_BY_STANDARD_DEVIATION       = 200;
    public final static int PIXEL_RANGE_DEFINED_BY_PIXEL_INTENSITY_RANGE    = 201;

    public final static int INITIALIZE_ORDER_STATISTIC_FILTERING = 1000;

    
    private float m_maxPixVal;
    private float m_minPixVal;
    private int   m_pixelRangeDeterminationType;


    public final static int MINIMUM_ORDER_MINIMUM_2_MAXIMUM_SORTING = 10000;
    public final static int MEDIAN_ORDER_MINIMUM_2_MEDIAN_2_MAXIMUM_SORTING = 10001;
    public final static int MAXIMUM_ORDER_MINIMUM_2_MAXIMUM_SORTING = 10002;


}
