/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.io.dicom;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.nio.file.FileVisitResult;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.SimpleFileVisitor;
import java.nio.file.attribute.BasicFileAttributes;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFileChooser;
import javax.swing.SwingWorker;
import javax.swing.SwingWorker.StateValue;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.DefaultTableModel;
import org.dcm4che2.data.DicomObject;
import org.spectrim.data.FileReaderWorker;

/**
 *
 * @author user
 */
public class AnonymizerGUI extends javax.swing.JFrame implements TableModelListener {

    private File outputFolder;
    private File[] inputFolder;
    private File currentFolder;
    private int notProcessedFiles = 0;
    private ArrayList<File> inputFiles = new ArrayList<>();
    private String UPN;
    private HashMap<String, String> UPNMap = new HashMap<>();
    private DefaultTableModel tablemodel;
    private File currentUPNFile;

    /**
     * Creates new form AnonymizerGUI
     */
    public AnonymizerGUI() throws Exception {
        initComponents();
        tablemodel = (DefaultTableModel) jTableUPNList.getModel();
        tablemodel.addTableModelListener(this);
        currentUPNFile = new File("UPNList.txt");
        loadUPNList(currentUPNFile);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jDialog1 = new javax.swing.JDialog();
        jLabelMessageDialog = new javax.swing.JLabel();
        jButtonOKDialog = new javax.swing.JButton();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanelMain = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextAreaLog = new javax.swing.JTextArea();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jTextFieldInputFolder = new javax.swing.JTextField();
        jButtonRun = new javax.swing.JButton();
        jLabelOutput = new javax.swing.JLabel();
        jLabelInput = new javax.swing.JLabel();
        jProgressBar1 = new javax.swing.JProgressBar();
        jTextFieldOutputFolder = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jTextFieldUPN = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jCheckBoxUPNfromList = new javax.swing.JCheckBox();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTableUPNList = new javax.swing.JTable();
        jPanel3 = new javax.swing.JPanel();
        jButtonDeleteLine = new javax.swing.JButton();
        jButtonNewLine = new javax.swing.JButton();
        jButtonReset = new javax.swing.JButton();
        jButtonSave = new javax.swing.JButton();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMenuItemInputFolder = new javax.swing.JMenuItem();
        jMenuItemOutputFolder = new javax.swing.JMenuItem();

        jDialog1.setMinimumSize(new java.awt.Dimension(400, 120));
        jDialog1.setResizable(false);

        jLabelMessageDialog.setText("Message");

        jButtonOKDialog.setText("OK");
        jButtonOKDialog.setFocusCycleRoot(true);
        jButtonOKDialog.setSelected(true);
        jButtonOKDialog.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonOKDialogActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jDialog1Layout = new javax.swing.GroupLayout(jDialog1.getContentPane());
        jDialog1.getContentPane().setLayout(jDialog1Layout);
        jDialog1Layout.setHorizontalGroup(
            jDialog1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jDialog1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jDialog1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabelMessageDialog, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jDialog1Layout.createSequentialGroup()
                        .addGap(0, 319, Short.MAX_VALUE)
                        .addComponent(jButtonOKDialog, javax.swing.GroupLayout.PREFERRED_SIZE, 61, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jDialog1Layout.setVerticalGroup(
            jDialog1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jDialog1Layout.createSequentialGroup()
                .addGap(27, 27, 27)
                .addComponent(jLabelMessageDialog)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 29, Short.MAX_VALUE)
                .addComponent(jButtonOKDialog)
                .addContainerGap())
        );

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle(".::DICOM Anonymizer::.");

        jPanelMain.setLayout(new java.awt.BorderLayout());

        jTextAreaLog.setEditable(false);
        jTextAreaLog.setColumns(20);
        jTextAreaLog.setRows(5);
        jScrollPane1.setViewportView(jTextAreaLog);

        jPanelMain.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jLabel1.setText("Input Folder:");

        jTextFieldInputFolder.setEditable(false);
        jTextFieldInputFolder.setCursor(new java.awt.Cursor(java.awt.Cursor.TEXT_CURSOR));

        jButtonRun.setText("Run");
        jButtonRun.setEnabled(false);
        jButtonRun.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonRunActionPerformed(evt);
            }
        });

        jLabelOutput.setText("0 files created");

        jLabelInput.setText("0 input files");

        jTextFieldOutputFolder.setEditable(false);
        jTextFieldOutputFolder.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextFieldOutputFolderActionPerformed(evt);
            }
        });

        jLabel3.setText("Output Folder:");

        jTextFieldUPN.setEnabled(false);
        jTextFieldUPN.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextFieldUPNActionPerformed(evt);
            }
        });

        jLabel2.setText("UPN:");

        jCheckBoxUPNfromList.setSelected(true);
        jCheckBoxUPNfromList.setText("Use UPN from List");
        jCheckBoxUPNfromList.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxUPNfromListActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addComponent(jLabel2)
                    .addComponent(jLabel3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jTextFieldUPN, javax.swing.GroupLayout.PREFERRED_SIZE, 123, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jCheckBoxUPNfromList)
                        .addGap(18, 18, 18)
                        .addComponent(jProgressBar1, javax.swing.GroupLayout.DEFAULT_SIZE, 487, Short.MAX_VALUE))
                    .addComponent(jTextFieldInputFolder)
                    .addComponent(jTextFieldOutputFolder))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabelOutput, javax.swing.GroupLayout.PREFERRED_SIZE, 108, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButtonRun, javax.swing.GroupLayout.PREFERRED_SIZE, 108, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabelInput, javax.swing.GroupLayout.PREFERRED_SIZE, 140, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jTextFieldInputFolder, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabelInput))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(jTextFieldOutputFolder, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabelOutput))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel2)
                        .addComponent(jTextFieldUPN, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jProgressBar1, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButtonRun)
                    .addComponent(jCheckBoxUPNfromList))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanelMain.add(jPanel1, java.awt.BorderLayout.PAGE_START);

        jTabbedPane1.addTab("Main", jPanelMain);

        jPanel2.setLayout(new java.awt.BorderLayout());

        jTableUPNList.setAutoCreateRowSorter(true);
        jTableUPNList.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Initials + Birth Year", "UPN", "Status"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                true, true, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane2.setViewportView(jTableUPNList);

        jPanel2.add(jScrollPane2, java.awt.BorderLayout.CENTER);

        jButtonDeleteLine.setText("Delete line(s)");
        jButtonDeleteLine.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonDeleteLineActionPerformed(evt);
            }
        });

        jButtonNewLine.setText("Insert new line");
        jButtonNewLine.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonNewLineActionPerformed(evt);
            }
        });

        jButtonReset.setText("Reset");
        jButtonReset.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonResetActionPerformed(evt);
            }
        });

        jButtonSave.setText("Save");
        jButtonSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSaveActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGap(4, 4, 4)
                .addComponent(jButtonDeleteLine)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonNewLine)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 638, Short.MAX_VALUE)
                .addComponent(jButtonReset)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonSave)
                .addGap(6, 6, 6))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                .addGap(0, 10, Short.MAX_VALUE)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonReset)
                    .addComponent(jButtonSave)
                    .addComponent(jButtonNewLine)
                    .addComponent(jButtonDeleteLine)))
        );

        jPanel2.add(jPanel3, java.awt.BorderLayout.PAGE_END);

        jTabbedPane1.addTab("UPN List", jPanel2);

        getContentPane().add(jTabbedPane1, java.awt.BorderLayout.CENTER);

        jMenu1.setText("File");

        jMenuItemInputFolder.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_I, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemInputFolder.setText("Set Input Folder");
        jMenuItemInputFolder.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemInputFolderActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItemInputFolder);

        jMenuItemOutputFolder.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_O, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemOutputFolder.setText("Set Output Folder");
        jMenuItemOutputFolder.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemOutputFolderActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItemOutputFolder);

        jMenuBar1.add(jMenu1);

        setJMenuBar(jMenuBar1);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jMenuItemInputFolderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemInputFolderActionPerformed
        final JFileChooser fileChooser = new JFileChooser();
        fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        fileChooser.setMultiSelectionEnabled(true);
        fileChooser.setDialogTitle("Set Input Folder");
        if (currentFolder != null) {
            fileChooser.setSelectedFile(currentFolder.getParentFile());
        }
        int result = fileChooser.showOpenDialog(this);

        switch (result) {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                jProgressBar1.setValue(0);
                notProcessedFiles = 0;
                inputFiles.clear();
                jLabelOutput.setText(0 + " files created");
                SwingWorker worker = new SwingWorker<Integer, String>() {
                    @Override
                    public Integer doInBackground() {
                        inputFolder = fileChooser.getSelectedFiles();
                        for (int i = 0; i < inputFolder.length; i++) {
                            currentFolder = inputFolder[0];
                            try {
                                Files.walkFileTree(inputFolder[i].toPath(), new SimpleFileVisitor<Path>() {
                                    @Override
                                    public FileVisitResult visitFile(Path file, BasicFileAttributes attrs)
                                            throws IOException {
//                                        if (file.toFile().toString().endsWith(".dcm") || file.toFile().toString().endsWith(".DCM")) {
//                                            inputFiles.add(file.toFile());
//                                            publish(inputFiles.size() + " input files");
//                                        }
                                        if (file.toFile().toString().endsWith(".dcm") || file.toFile().toString().endsWith(".DCM")) {
                                            inputFiles.add(file.toFile());
                                            publish(inputFiles.size() + " input files");

                                            DicomObject object;
                                            String imagetype;
                                            String classUID;
                                            String fieldStrength;
                                            String manufacturer;
                                            String model;
                                            FileReaderWorker.filetype type;

                                            object = DicomHandler.getDicomObject(file.toFile().toString());
                                            imagetype = DicomHandler.getImageType(object);
                                            classUID = DicomHandler.getSOPClassUID(object);
                                            fieldStrength = DicomHandler.getFieldStrength(object);
                                            manufacturer = DicomHandler.getManufacturer(object);
                                            model = DicomHandler.getModelName(object);
                                            String patient = DicomHandler.getPatientName(object);
                                            String study = DicomHandler.getStudyDate(object);
                                            String series = DicomHandler.getSeriesNumber(object) + "-" + DicomHandler.getSeriesDescription(object);
                                            switch (classUID) {
                                                case "1.2.840.10008.5.1.4.1.1.4": // Image
                                                    type = FileReaderWorker.filetype.IMAGE;
                                                    break;
                                                case "1.2.840.10008.5.1.4.1.1.4.2": // Spectro std
                                                    type = FileReaderWorker.filetype.MRS_STD;
                                                    break;
                                                case "1.3.12.2.1107.5.9.1": // Spectro/Tensor Siemens
                                                    if (imagetype.indexOf("TENSOR") >= 0) {
                                                        type = FileReaderWorker.filetype.TENSOR;
//                                                        type = FileReaderWorker.filetype.IMAGE;
                                                    } else {
                                                        type = FileReaderWorker.filetype.MRS_SIEMENS;
                                                    }
                                                    break;
                                                case "1.2.840.10008.5.1.4.1.1.7": // Perfusion derived maps
                                                    type = FileReaderWorker.filetype.PERFUSION;
//                                                    type = FileReaderWorker.filetype.IMAGE;
                                                    break;
                                                default: // Unknown format
                                                    type = FileReaderWorker.filetype.UNKNOWN;
//                                                    type = FileReaderWorker.filetype.IMAGE; //TEMPORARIOOOO
                                                    break;
                                            }
                                            System.out.println(type.toString() + "\t" + manufacturer + "\t" + fieldStrength + "\t" + model + "\t" + patient + "\t" + study + "\t" + series+ "\t" +file.toFile().getParent());
                                        }
//                                        return FileVisitResult.CONTINUE;
                                        return FileVisitResult.SKIP_SIBLINGS;
                                    }
                                });
                            } catch (IOException ex) {
                                Logger.getLogger(AnonymizerGUI.class.getName()).log(Level.SEVERE, null, ex);
                            }
                        }
                        return 1;
                    }

                    @Override
                    public void done() {
                    }

                    @Override
                    public void process(final List<String> chunks) {
                        for (final String string : chunks) {
                            jLabelInput.setText(string);
                        }
                    }
                };
                worker.addPropertyChangeListener(new PropertyChangeListener() {
                    @Override
                    public void propertyChange(final PropertyChangeEvent event) {
                        switch (event.getPropertyName()) {
                            case "state":
                                switch ((StateValue) event.getNewValue()) {
                                    case DONE:
                                        if (inputFiles.size() > 0) {
                                            jLabelInput.setText(inputFiles.size() + " input files");
                                            jTextAreaLog.append(inputFiles.size() + " DICOM files found under folder(s): " + Folders2TXT(fileChooser.getSelectedFiles()) + "\n");
                                            jTextAreaLog.append("Input folder(s) set!\n");
                                            jTextFieldInputFolder.setText(Folders2TXT(fileChooser.getSelectedFiles()));
                                            if (outputFolder != null && (!jTextFieldUPN.getText().isEmpty() || jCheckBoxUPNfromList.isSelected())) {
                                                jButtonRun.setEnabled(true);
                                            } else {
                                                jButtonRun.setEnabled(false);
                                            }
                                        } else {
                                            jLabelInput.setText(0 + " input files");
                                            jTextFieldInputFolder.setText("FOLDER(S) CONTAINS NO DICOM FILES! (" + Folders2TXT(fileChooser.getSelectedFiles()) + ")");
                                            jTextAreaLog.append("No DICOM files found under folder(s): " + Folders2TXT(fileChooser.getSelectedFiles()) + "\n");
                                            jTextAreaLog.append("Please choose an input folder containing DICOM files!\n");
                                        }
                                        break;
                                    case STARTED:
                                        break;
                                }
                        }
                    }
                });
                worker.execute();
                break;
            case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                break;
            case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                break;
        }

    }//GEN-LAST:event_jMenuItemInputFolderActionPerformed

    private String Folders2TXT(File[] files) {
        String res = "";
        for (int i = 0; i < files.length; i++) {
            res = res + files[i] + "; ";
        }
        return res;
    }

    private void jMenuItemOutputFolderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemOutputFolderActionPerformed
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        fileChooser.setDialogTitle("Set Output Folder");
        if (currentFolder != null) {
            fileChooser.setSelectedFile(currentFolder);
        }
        int result = fileChooser.showOpenDialog(this);


        switch (result) {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                outputFolder = fileChooser.getSelectedFile();
                currentFolder = outputFolder;
                if (outputFolder != null) {
                    this.jTextFieldOutputFolder.setText(outputFolder.toString());
                    this.jTextAreaLog.append("Output folder set!(" + outputFolder.toString() + ")\n");
                }
                if (inputFiles != null) {
                    if (UPN != null || jCheckBoxUPNfromList.isSelected()) {
                        if (inputFiles.size() > 0 && (!this.jTextFieldUPN.getText().isEmpty() || this.jCheckBoxUPNfromList.isSelected())) {
                            this.jButtonRun.setEnabled(true);
                        } else {
                            this.jButtonRun.setEnabled(false);
                        }
                    } else {
                        this.jButtonRun.setEnabled(false);
                    }
                } else {
                    this.jButtonRun.setEnabled(false);
                }
                break;
            case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                break;
            case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                break;
        }
    }//GEN-LAST:event_jMenuItemOutputFolderActionPerformed

    private void jTextFieldUPNActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextFieldUPNActionPerformed
        UPN = this.jTextFieldUPN.getText();
        UPN.replace(" ", "");
        if (inputFiles != null) {
            if (inputFiles.size() > 0 && !this.jTextFieldUPN.getText().isEmpty() && outputFolder != null) {
                this.jButtonRun.setEnabled(true);
            } else {
                this.jButtonRun.setEnabled(false);
            }
        } else {
            this.jButtonRun.setEnabled(false);
        }
    }//GEN-LAST:event_jTextFieldUPNActionPerformed

    private void jTextFieldOutputFolderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextFieldOutputFolderActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextFieldOutputFolderActionPerformed

    private void jButtonRunActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonRunActionPerformed

        this.jProgressBar1.setMaximum(this.inputFiles.size());
        jButtonRun.setEnabled(false);
        this.jMenuItemInputFolder.setEnabled(false);
        this.jMenuItemOutputFolder.setEnabled(false);
        UPN = this.jTextFieldUPN.getText();
        UPN.replace(" ", "");
        this.jTextAreaLog.append("Anonymization process started!\n");
        this.jTextAreaLog.append("Input folder(s): " + Folders2TXT(inputFolder) + "\n");
        this.jTextAreaLog.append("Output folder: " + outputFolder.toString() + "\n");
        if (jCheckBoxUPNfromList.isSelected()) {
            this.jTextAreaLog.append("UPN obtained from List" + "\n");
        } else {
            this.jTextAreaLog.append("UPN: " + UPN + "\n");
        }
        this.jTextAreaLog.append("Generating anonymized files...\n");

        SwingWorker worker = new SwingWorker<Integer, String>() {
            @Override
            public Integer doInBackground() {
                DicomObject object;
                String filename;
                DicomHandler handler = new DicomHandler();

                for (int i = 0; i < inputFiles.size(); i++) {
                    object = handler.getDicomObject(inputFiles.get(i).toString());
                    String name = handler.getPatientName(object);
                    int index = name.indexOf("^");
                    String initials = "";
                    if (index != -1) {
                        initials = name.substring(0, 2) + name.substring(index + 1, index + 2);
                    } else {
                        initials = name.substring(0, 2);
                    }
                    String year = handler.getPatientBirthDate(object).substring(0, 4);
                    UPN = null;
                    if (jCheckBoxUPNfromList.isSelected()) {
                        UPN = UPNMap.get(initials.toUpperCase() + year);
                    } else {
                        UPN = jTextFieldUPN.getText();
                    }
                    if (UPN != null) {
                        if (object != null) {
                            filename = removeIllegalCharacters(handler.anonymize(object, UPN));
                            String studyfolder = "";
                            String seriesfolder = "";
                            String patientfolder = "";
                            patientfolder = removeIllegalCharacters(handler.getPatientName(object));
                            studyfolder = removeIllegalCharacters(handler.getPatientName(object) + "-" + handler.getStudyDate(object) + "-" + handler.getStudyID(object));
                            seriesfolder = removeIllegalCharacters(handler.getSeriesNumber(object) + "-" + handler.getSeriesDescription(object));
                            if (studyfolder == "" || seriesfolder == "") {
                                publish("Missing Info! File not saved: " + inputFiles.get(i).toString() + "\n");
                            } else {
                                String fileToSave = outputFolder + File.separator + patientfolder
                                        + File.separator + studyfolder + File.separator + seriesfolder + File.separator + filename + ".dcm";
                                File newfile = new File(fileToSave);
                                newfile.getParentFile().mkdirs();
                                DicomHandler.saveDicom(fileToSave, object);
                            }
                        } else {
                            publish("Error reading file: " + inputFiles.get(i).toString() + "\n");
                        }
                    } else {
                        publish("UPN not defined. File not processed: " + inputFiles.get(i).toString() + "\n");
                    }
                    setProgress((i + 1) * 100 / inputFiles.size());
                }
                return 1;
            }

            @Override
            public void done() {
            }

            @Override
            public void process(final List<String> chunks) {
                for (final String string : chunks) {
                    jTextAreaLog.append(string);
                    notProcessedFiles++;
                }
            }
        };
        worker.addPropertyChangeListener(new PropertyChangeListener() {
            @Override
            public void propertyChange(final PropertyChangeEvent event) {
                switch (event.getPropertyName()) {
                    case "progress":
                        jProgressBar1.setIndeterminate(false);
                        jProgressBar1.setValue((Integer) event.getNewValue() * inputFiles.size() / 100);
                        jLabelOutput.setText(((Integer) event.getNewValue() * inputFiles.size() / 100 - notProcessedFiles) + " files created");
                        break;
                    case "state":
                        switch ((StateValue) event.getNewValue()) {
                            case DONE:
                                jButtonRun.setEnabled(true);
                                jMenuItemInputFolder.setEnabled(true);
                                jMenuItemOutputFolder.setEnabled(true);
                                jTextAreaLog.append((inputFiles.size() - notProcessedFiles) + " anonymized files created!\n");
                                jTextAreaLog.append(notProcessedFiles + " files not processed!\n");
                                jTextAreaLog.append("DONE!\n");
                                break;
                            case STARTED:
                                break;
                        }
                }
            }
        });
        worker.execute();
    }//GEN-LAST:event_jButtonRunActionPerformed

    private void jCheckBoxUPNfromListActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxUPNfromListActionPerformed
        if (this.jCheckBoxUPNfromList.isSelected()) {
            this.jTextFieldUPN.setEnabled(false);
        } else {
            this.jTextFieldUPN.setEnabled(true);
        }

        if (inputFiles != null) {
            if (inputFiles.size() > 0 && (!this.jTextFieldUPN.getText().isEmpty() || this.jCheckBoxUPNfromList.isSelected()) && outputFolder != null) {
                this.jButtonRun.setEnabled(true);
            } else {
                this.jButtonRun.setEnabled(false);
            }
        } else {
            this.jButtonRun.setEnabled(false);
        }
    }//GEN-LAST:event_jCheckBoxUPNfromListActionPerformed

    private void jButtonNewLineActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonNewLineActionPerformed
        tablemodel.addRow(new Object[]{"", "", "New entry. (Needs to be saved to be considered during processing)"});
    }//GEN-LAST:event_jButtonNewLineActionPerformed

    private void jButtonDeleteLineActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonDeleteLineActionPerformed
        for (int i = tablemodel.getRowCount() - 1; i >= 0; i--) {
            if (this.jTableUPNList.isRowSelected(i)) {
                if (tablemodel.getValueAt(i, 2) == "Synchronized with file. (Ready for processing)") {
                    tablemodel.setValueAt("Removed. (Entry will be deleted when list is saved)", i, 2);
                } else {
                    tablemodel.removeRow(i);
                }
            }
        }
    }//GEN-LAST:event_jButtonDeleteLineActionPerformed

    private void jButtonResetActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonResetActionPerformed
        UPNMap.clear();
        for (int i = tablemodel.getRowCount() - 1; i >= 0; i--) {
            tablemodel.removeRow(i);
        }

        try {
            loadUPNList(currentUPNFile);
        } catch (Exception ex) {
            Logger.getLogger(AnonymizerGUI.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_jButtonResetActionPerformed

    private void jButtonSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSaveActionPerformed
//        Check existence of duplicate entries
        if (checkDuplicates()) {
            this.jDialog1.setLocationRelativeTo(this);
            this.jDialog1.setTitle("Warning!");
            this.jLabelMessageDialog.setText("List contains duplicate entries. File not saved!");
            this.jDialog1.setVisible(true);
            this.jButtonOKDialog.setFocusable(true);
            this.jButtonOKDialog.requestFocus();
            this.jButtonOKDialog.setSelected(true);
        } else {
            try (PrintWriter writer = new PrintWriter(currentUPNFile, "UTF-8")) {
                UPNMap.clear();
                writer.println("*Name+BirthYear\tUPN");
                for (int i = 0; i < tablemodel.getRowCount(); i++) {
                    if (tablemodel.getValueAt(i, 2) != "Removed. (Entry will be deleted when list is saved)") {
                        tablemodel.setValueAt("Synchronized with file. (Ready for processing)", i, 2);
                        UPNMap.put((String) tablemodel.getValueAt(i, 0), (String) tablemodel.getValueAt(i, 1));
                        writer.println((String) tablemodel.getValueAt(i, 0) + "\t" + (String) tablemodel.getValueAt(i, 1));
                    }
                }
                for (int i = tablemodel.getRowCount() - 1; i >= 0; i--) {
                    if (tablemodel.getValueAt(i, 2) == "Removed. (Entry will be deleted when list is saved)") {
                        tablemodel.removeRow(i);
                    }
                }
                writer.close();
            } catch (FileNotFoundException ex) {
                Logger.getLogger(AnonymizerGUI.class.getName()).log(Level.SEVERE, null, ex);
            } catch (UnsupportedEncodingException ex) {
                Logger.getLogger(AnonymizerGUI.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }//GEN-LAST:event_jButtonSaveActionPerformed

    private void jButtonOKDialogActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOKDialogActionPerformed
        this.jDialog1.setVisible(false);
    }//GEN-LAST:event_jButtonOKDialogActionPerformed

    private void loadUPNList(File file) throws Exception {
        BufferedReader reader;
        String line;
        int linesize;
        if (file.exists()) {
            try {
                reader = new BufferedReader(new FileReader(file));
                while ((line = reader.readLine()) != null) {
                    String[] parts = line.split("\\s");
                    linesize = parts.length;
                    if (linesize > 0) {
                        if (!parts[0].startsWith("*")) {
                            if (linesize == 2) {
                                UPNMap.put(parts[0], parts[1]);
                                tablemodel.addRow(new Object[]{parts[0], parts[1], "Synchronized with file. (Ready for processing)"});
                            }
                        }
                    }
                }
            } catch (FileNotFoundException ex) {
                ex.printStackTrace();
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(AnonymizerGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(AnonymizerGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(AnonymizerGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(AnonymizerGUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                try {
                    new AnonymizerGUI().setVisible(true);
                } catch (Exception ex) {
                    Logger.getLogger(AnonymizerGUI.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonDeleteLine;
    private javax.swing.JButton jButtonNewLine;
    private javax.swing.JButton jButtonOKDialog;
    private javax.swing.JButton jButtonReset;
    private javax.swing.JButton jButtonRun;
    private javax.swing.JButton jButtonSave;
    private javax.swing.JCheckBox jCheckBoxUPNfromList;
    private javax.swing.JDialog jDialog1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabelInput;
    private javax.swing.JLabel jLabelMessageDialog;
    private javax.swing.JLabel jLabelOutput;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItemInputFolder;
    private javax.swing.JMenuItem jMenuItemOutputFolder;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanelMain;
    private javax.swing.JProgressBar jProgressBar1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTable jTableUPNList;
    private javax.swing.JTextArea jTextAreaLog;
    private javax.swing.JTextField jTextFieldInputFolder;
    private javax.swing.JTextField jTextFieldOutputFolder;
    private javax.swing.JTextField jTextFieldUPN;
    // End of variables declaration//GEN-END:variables

    public String removeIllegalCharacters(String inputst) {
        String res = inputst.replaceAll(" ", "");
        res = res.replaceAll("[\\\\/:*?\"<>|]", "");
        return res;
    }

    @Override
    public void tableChanged(TableModelEvent tme) {
        if (tme.getColumn() == 1 || tme.getColumn() == 0) {
            tme.getFirstRow();
            if (tablemodel.getValueAt(tme.getFirstRow(), 2) == "Synchronized with file. (Ready for processing)"
                    || tablemodel.getValueAt(tme.getFirstRow(), 2) == "Removed. (Entry will be deleted when list is saved)"
                    || tablemodel.getValueAt(tme.getFirstRow(), 2) == "Edited. (Save to file for changes to be considered during processing)") {
                String storedval = UPNMap.get((String) tablemodel.getValueAt(tme.getFirstRow(), 0));
                String tableval = (String) tablemodel.getValueAt(tme.getFirstRow(), 1);
                if (storedval == null) {
                    tablemodel.setValueAt("Edited. (Save to file for changes to be considered during processing)", tme.getFirstRow(), 2);
                } else if (!storedval.matches(tableval)) {
                    tablemodel.setValueAt("Edited. (Save to file for changes to be considered during processing)", tme.getFirstRow(), 2);
                } else {
                    tablemodel.setValueAt("Synchronized with file. (Ready for processing)", tme.getFirstRow(), 2);
                }
            }
        }
    }

    private boolean checkDuplicates() {
        boolean res = false;
        HashMap<String, String> UPNMapaux = new HashMap<>();
        int i = tablemodel.getRowCount() - 1;
        while (i > -1) {
            if (tablemodel.getValueAt(i, 2) != "Removed. (Entry will be deleted when list is saved)") {
                if (UPNMapaux.containsKey((String) tablemodel.getValueAt(i, 0))) {
                    tablemodel.setValueAt("DUPLICATE ENTRY!", i, 2);
                    res = true;
                } else {
                    UPNMapaux.put((String) tablemodel.getValueAt(i, 0), (String) tablemodel.getValueAt(i, 1));
                }

            }
            i--;
        }
        return res;
    }
}
