/*
 * PatientTableModel.java
 *
 * Created on October 18, 2006, 2:42 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.spectrim.patientdatabase;

import java.sql.ResultSet;
import java.util.ArrayList;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author hans
 */
public class StudyTableModel extends AbstractTableModel
{
    
    private int m_colnum=5;
    private int m_rownum;
    private String[] m_colNames = {
        "Patient Name",  "Date of Birth", "Study date", "Study ID", "Modality"
    };
    
    private  ArrayList<String[]> ResultSets;
    private Object[][] m_data;
    
    /**
     * Creates a new instance of PatientTableModel 
     */
    public StudyTableModel( ResultSet rs )
    {
        ResultSets = new ArrayList<String[]>( );  
    
        try
        {
            while( rs.next( ) )
            {
                // not all results from the table are required
                String[] row={
                
                rs.getString( "patient_name" ),
                rs.getString( "date_of_birth" ),
                rs.getString( "study_date" ),
                rs.getString( "study_id" ),
                rs.getString( "modality" )
          
                };
                
                ResultSets.add( row );
            }
        }
        catch( Exception e )
        {
            System.out.println( "Exception in PatientTableModel");
        }
    }

    /**
     * Returns the row count of the table
     */ 
    public int getRowCount( )
    {
        return ResultSets.size( );
    }

    /**
     * Returns the column count of the patient table
     */
    public int getColumnCount( )
    {
        return m_colnum;
    }

    /**
     * Returns the cell value of table at (rowIndex,ColumnIndex)
     */
    public Object getValueAt( int rowIndex, int columnIndex )
    {
        String[] row = ResultSets.get( rowIndex );
        return row[columnIndex];
    }
    
    /**
     * Returns the column name of the
     */ 
    public String getColumnName( int param ) 
    {
        return null;
//       return m_colNames[param];
    }
    
    /**
     * Returns the results from the patient table (adapted)
     */
     public ArrayList<String[]> getPatientTableModelResults( )
     {
        return ResultSets;
     }
     
     /**
      * Returns the column names
      */
     public String[] getColumnNames( )
     {
         return m_colNames;
     }
     
     /**
      * Get table data
      */
     public Object[][] getTableData( )
     {
         
         m_data = new Object[ResultSets.size( )][m_colnum];
         
         for ( int i = 0 ; i < m_colnum ; i++ )
         {
             for ( int j = 0 ; j < ResultSets.size( ); j++ )
             {
                 m_data[j][i] = getValueAt( j, i );
             }
         }
         
         return m_data;
     }
     
    // For proper serialization
    private static final long serialVersionUID = 6482323338121223L;
}
