/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.registration;

import org.spectrim.dicom.DicomDataLoaderPanel;
import org.spectrim.dicom.DicomFileSelectionControl;
import org.spectrim.dicom.DicomFileSelectionTable;
import org.spectrim.dicom.DicomImageSeriesData;
import org.spectrim.imagegraphicobjects.Point3D;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.LinkedList;
import javax.swing.JFileChooser;
import javax.swing.JLayer;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.SwingWorker;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.table.DefaultTableModel;
import org.spectrim.data.FileReaderListener;
import org.spectrim.data.FileReaderWorker;
import org.spectrim.io.nifti.NiftiHandler;
import org.spectrim.model.GlobalModel;
import static org.spectrim.registration.ImageTools.getSimilarityMeasures;
import org.spectrim.settings.RegistrationSettings;
import org.spectrim.view.ImageViewerPanel;

/**
 *
 * @author nuno
 */
public class GUIRegistration extends javax.swing.JFrame implements FileReaderListener, ActionListener, RegistrationWorkerListener, OutputListener {

    private File currentFile;
    private File refFile;
    private File floatingFile;
    private String aladinAffFile;
    private String f3dAffFile;
    private String f3dPCGFile;
    private ImageViewerPanel refPanel;
    private ImageViewerPanel floatingPanel;
    private ImageViewerPanel resPanel;
    private JLayer<JPanel> waitlayer;
    private int activeImage;
    private GlobalModel csimodelRef;
    private GlobalModel csimodelFloating;
    private GlobalModel csimodelRes;
    private DicomDataLoaderPanel dicomManager;
    private DicomFileSelectionTable dicomseltab;
    private DefaultTableModel resultsTabModel;
    private double[] valuesBefore;

    /**
     * Creates new form GUIRegistration
     */
    public GUIRegistration() {
        initComponents();
        this.refPanel = new ImageViewerPanel();
        this.refPanel.setBackground(Color.BLACK);
        this.pnlRef.add(refPanel);
        this.floatingPanel = new ImageViewerPanel();
        this.floatingPanel.setBackground(Color.BLACK);
        this.pnlFloating.add(floatingPanel);
        this.resPanel = new ImageViewerPanel();
        this.resPanel.setBackground(Color.BLACK);
        this.pnlRes.add(resPanel);

        currentFile = new File("E:\\cases");
        refPanel.setSpacialInfoVisible(true);
        floatingPanel.setSpacialInfoVisible(true);
        resPanel.setSpacialInfoVisible(true);
        dicomManager = (DicomDataLoaderPanel) pnlFileManager;
        dicomManager.addActionListener(this);
        dicomseltab = dicomManager.getDicomFileSelectionTable();
        initOptionValues();
        resultsTabModel = (DefaultTableModel) jTableResults.getModel();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        jSplitPane2 = new javax.swing.JSplitPane();
        jPanel2 = new javax.swing.JPanel();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanelOptionsAladin = new javax.swing.JPanel();
        jCheckBoxAladinActive = new javax.swing.JCheckBox();
        jPanel5 = new javax.swing.JPanel();
        jCheckBoxAladinAffineFromFile = new javax.swing.JCheckBox();
        jButtonAladinAffineFromFile = new javax.swing.JButton();
        jCheckBoxAladinSym = new javax.swing.JCheckBox();
        jCheckBoxAladinRigidOnly = new javax.swing.JCheckBox();
        jCheckBoxAladinInitTranslHeader = new javax.swing.JCheckBox();
        jLabel1 = new javax.swing.JLabel();
        jFormattedTextFieldAladinPercBlock = new javax.swing.JFormattedTextField();
        jLabel2 = new javax.swing.JLabel();
        jFormattedTextFieldAladinNrLevels = new javax.swing.JFormattedTextField();
        jLabel3 = new javax.swing.JLabel();
        jFormattedTextFieldAladinSigmaRef = new javax.swing.JFormattedTextField();
        jLabel4 = new javax.swing.JLabel();
        jFormattedTextFieldAladinNrFirstLevels = new javax.swing.JFormattedTextField();
        jLabel5 = new javax.swing.JLabel();
        jFormattedTextFieldAladinMaxIter = new javax.swing.JFormattedTextField();
        jCheckBoxAladinAffineDirect = new javax.swing.JCheckBox();
        jLabel6 = new javax.swing.JLabel();
        jFormattedTextFieldAladinPercInlierLTS = new javax.swing.JFormattedTextField();
        jLabel7 = new javax.swing.JLabel();
        jFormattedTextFieldAladinSigmaFloating = new javax.swing.JFormattedTextField();
        jPanelOptionsF3D = new javax.swing.JPanel();
        jCheckBoxF3DActive = new javax.swing.JCheckBox();
        jPanelOptionsTabbed = new javax.swing.JPanel();
        jTabbedPane2 = new javax.swing.JTabbedPane();
        jPanelOptionsF3DGeneral = new javax.swing.JPanel();
        jPanel13 = new javax.swing.JPanel();
        jCheckBoxF3DApplyControlPointGrid = new javax.swing.JCheckBox();
        jButtonF3DSetControlPointGridFile = new javax.swing.JButton();
        jPanel6 = new javax.swing.JPanel();
        jCheckBoxF3DAffineFromFile = new javax.swing.JCheckBox();
        jButtonF3DSetAffineFile = new javax.swing.JButton();
        jLabel8 = new javax.swing.JLabel();
        jFormattedTextFieldF3DSigmaRef = new javax.swing.JFormattedTextField();
        jFormattedTextFieldF3DNrBinsRef = new javax.swing.JFormattedTextField();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jFormattedTextFieldF3DNrBinsFloating = new javax.swing.JFormattedTextField();
        jLabel11 = new javax.swing.JLabel();
        jFormattedTextFieldF3DSigmaFloating = new javax.swing.JFormattedTextField();
        jLabel16 = new javax.swing.JLabel();
        jFormattedTextFieldF3DMaxIterLevel = new javax.swing.JFormattedTextField();
        jLabel17 = new javax.swing.JLabel();
        jFormattedTextFieldF3DNrLevels = new javax.swing.JFormattedTextField();
        jLabel18 = new javax.swing.JLabel();
        jFormattedTextFieldF3DNrFirstLevels = new javax.swing.JFormattedTextField();
        jCheckBoxF3DPyramidal = new javax.swing.JCheckBox();
        jPanelF3DOptionsObjectiveFunc = new javax.swing.JPanel();
        jLabel19 = new javax.swing.JLabel();
        jFormattedTextFieldF3DBendingEnergy = new javax.swing.JFormattedTextField();
        jLabel20 = new javax.swing.JLabel();
        jFormattedTextFieldF3DLinElastPenalty1 = new javax.swing.JFormattedTextField();
        jFormattedTextFieldF3DL2NormDispPenalty = new javax.swing.JFormattedTextField();
        jLabel21 = new javax.swing.JLabel();
        jFormattedTextFieldF3DLogJacob = new javax.swing.JFormattedTextField();
        jLabel22 = new javax.swing.JLabel();
        jFormattedTextFieldF3DLinElastPenalty2 = new javax.swing.JFormattedTextField();
        jCheckBoxF3DApproxJLValOnlyControlP = new javax.swing.JCheckBox();
        jLabel24 = new javax.swing.JLabel();
        jComboBoxF3DOptimization = new javax.swing.JComboBox();
        jLabel23 = new javax.swing.JLabel();
        jComboBoxF3DSimilarityMeasure = new javax.swing.JComboBox();
        jPanelF3DOptionsIntensity = new javax.swing.JPanel();
        jPanel10 = new javax.swing.JPanel();
        jCheckBoxF3DUpThreshRef = new javax.swing.JCheckBox();
        jLabel14 = new javax.swing.JLabel();
        jFormattedTextFieldF3DUpThreshRef = new javax.swing.JFormattedTextField();
        jPanel11 = new javax.swing.JPanel();
        jCheckBoxF3DLowThreshRef = new javax.swing.JCheckBox();
        jLabel15 = new javax.swing.JLabel();
        jFormattedTextFieldF3DLowThreshRef = new javax.swing.JFormattedTextField();
        jPanel9 = new javax.swing.JPanel();
        jCheckBoxF3DLowThreshFloating = new javax.swing.JCheckBox();
        jLabel13 = new javax.swing.JLabel();
        jFormattedTextFieldF3DLowThreshFloating = new javax.swing.JFormattedTextField();
        jPanel8 = new javax.swing.JPanel();
        jCheckBoxF3DUpThreshFloating = new javax.swing.JCheckBox();
        jLabel12 = new javax.swing.JLabel();
        jFormattedTextFieldF3DUpThreshFloating = new javax.swing.JFormattedTextField();
        jPanelFiller1 = new javax.swing.JPanel();
        jPanelF3DOptionsOther = new javax.swing.JPanel();
        jPanel15 = new javax.swing.JPanel();
        jCheckBoxF3DSym = new javax.swing.JCheckBox();
        jLabel25 = new javax.swing.JLabel();
        jFormattedTextFieldF3DSymInvPenalty = new javax.swing.JFormattedTextField();
        jPanel16 = new javax.swing.JPanel();
        jCheckBoxF3DDiffeomorphic = new javax.swing.JCheckBox();
        jLabel26 = new javax.swing.JLabel();
        jFormattedTextFieldF3DDiffeoCompStep = new javax.swing.JFormattedTextField();
        jPanel17 = new javax.swing.JPanel();
        jCheckBoxF3DSmoothGrad = new javax.swing.JCheckBox();
        jLabel27 = new javax.swing.JLabel();
        jFormattedTextFieldF3DSmoothGrad = new javax.swing.JFormattedTextField();
        jPanel18 = new javax.swing.JPanel();
        jCheckBoxF3DPaddingVal = new javax.swing.JCheckBox();
        jLabel28 = new javax.swing.JLabel();
        jFormattedTextFieldF3DPaddingVal = new javax.swing.JFormattedTextField();
        jPanelFiller2 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jSplitPane1 = new javax.swing.JSplitPane();
        jTabbedPane3 = new javax.swing.JTabbedPane();
        pnlFileManager = new DicomDataLoaderPanel(this, csimodelRef);
        jPanel4 = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTableResults = new javax.swing.JTable();
        pnlMain = new javax.swing.JPanel();
        pnlRef = new javax.swing.JPanel();
        pnlFloating = new javax.swing.JPanel();
        pnlRes = new javax.swing.JPanel();
        jTextFieldFloating = new javax.swing.JTextField();
        jTextFieldRef = new javax.swing.JTextField();
        jComboBoxResultMode = new javax.swing.JComboBox();
        jSliderRef = new javax.swing.JSlider();
        jSliderFloating = new javax.swing.JSlider();
        jSliderRes = new javax.swing.JSlider();
        jRadioButtonRef = new javax.swing.JRadioButton();
        jRadioButtonFloating = new javax.swing.JRadioButton();
        jPanel7 = new javax.swing.JPanel();
        jButtonLoadDisplacements = new javax.swing.JButton();
        jButtonLoadReference = new javax.swing.JButton();
        jButtonLoadFloatting = new javax.swing.JButton();
        jToggleButtonPinSliders = new javax.swing.JToggleButton();
        jButtonRun = new javax.swing.JButton();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenuImage = new javax.swing.JMenu();
        jMenuItemImageInfo = new javax.swing.JMenuItem();
        jMenuItemImageInfo1 = new javax.swing.JMenuItem();
        jMenuItemInnerProdNormVects = new javax.swing.JMenuItem();
        jMenuItemImageDimensions = new javax.swing.JMenuItem();
        jMenuItemImageDimensions1 = new javax.swing.JMenuItem();
        jMenuItemTemp = new javax.swing.JMenuItem();
        jMenuGrid = new javax.swing.JMenu();
        jMenuItemClearGridRef = new javax.swing.JMenuItem();
        jMenuItemClearGridFloating = new javax.swing.JMenuItem();
        jMenuView = new javax.swing.JMenu();
        jCheckBoxMenuItemShowIntersectsMain = new javax.swing.JCheckBoxMenuItem();
        jCheckBoxShowMapValues = new javax.swing.JCheckBoxMenuItem();
        jCheckBoxMenuItemViewSliceOrientation = new javax.swing.JCheckBoxMenuItem();
        jCheckBoxMenuItemShowPatientName = new javax.swing.JCheckBoxMenuItem();
        jCheckBoxMenuItemShowSeriesInfo = new javax.swing.JCheckBoxMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        getContentPane().setLayout(new java.awt.GridLayout(1, 0));

        jSplitPane2.setDividerLocation(300);
        jSplitPane2.setResizeWeight(0.3);

        jPanel2.setLayout(new java.awt.GridBagLayout());

        jPanelOptionsAladin.setLayout(new java.awt.GridBagLayout());

        jCheckBoxAladinActive.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jCheckBoxAladinActive.setSelected(true);
        jCheckBoxAladinActive.setText("perform Reg. Aladin");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsAladin.add(jCheckBoxAladinActive, gridBagConstraints);

        jPanel5.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel5.setLayout(new java.awt.GridLayout(0, 1));

        jCheckBoxAladinAffineFromFile.setText("apply affine from file");
        jPanel5.add(jCheckBoxAladinAffineFromFile);

        jButtonAladinAffineFromFile.setText("set File...");
        jButtonAladinAffineFromFile.setToolTipText("");
        jButtonAladinAffineFromFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAladinAffineFromFileActionPerformed(evt);
            }
        });
        jPanel5.add(jButtonAladinAffineFromFile);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        jPanelOptionsAladin.add(jPanel5, gridBagConstraints);

        jCheckBoxAladinSym.setText("symmetric transf.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        jPanelOptionsAladin.add(jCheckBoxAladinSym, gridBagConstraints);

        jCheckBoxAladinRigidOnly.setText("rigid only");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsAladin.add(jCheckBoxAladinRigidOnly, gridBagConstraints);

        jCheckBoxAladinInitTranslHeader.setText("init. Transl. from nifti header origins");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        jPanelOptionsAladin.add(jCheckBoxAladinInitTranslHeader, gridBagConstraints);

        jLabel1.setText("% of block to use");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        jPanelOptionsAladin.add(jLabel1, gridBagConstraints);

        jFormattedTextFieldAladinPercBlock.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(java.text.NumberFormat.getIntegerInstance())));
        jFormattedTextFieldAladinPercBlock.setText("50");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        jPanelOptionsAladin.add(jFormattedTextFieldAladinPercBlock, gridBagConstraints);

        jLabel2.setText("numbers of levels");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsAladin.add(jLabel2, gridBagConstraints);

        jFormattedTextFieldAladinNrLevels.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(java.text.NumberFormat.getIntegerInstance())));
        jFormattedTextFieldAladinNrLevels.setText("3");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsAladin.add(jFormattedTextFieldAladinNrLevels, gridBagConstraints);

        jLabel3.setText("smooth reference Img. (sigma)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        jPanelOptionsAladin.add(jLabel3, gridBagConstraints);

        jFormattedTextFieldAladinSigmaRef.setText("0.0");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        jPanelOptionsAladin.add(jFormattedTextFieldAladinSigmaRef, gridBagConstraints);

        jLabel4.setText("perform only the first (levels):");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsAladin.add(jLabel4, gridBagConstraints);

        jFormattedTextFieldAladinNrFirstLevels.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(java.text.NumberFormat.getIntegerInstance())));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsAladin.add(jFormattedTextFieldAladinNrFirstLevels, gridBagConstraints);

        jLabel5.setText("max iterations per level:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        jPanelOptionsAladin.add(jLabel5, gridBagConstraints);

        jFormattedTextFieldAladinMaxIter.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(java.text.NumberFormat.getIntegerInstance())));
        jFormattedTextFieldAladinMaxIter.setText("5");
        jFormattedTextFieldAladinMaxIter.setInheritsPopupMenu(true);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        jPanelOptionsAladin.add(jFormattedTextFieldAladinMaxIter, gridBagConstraints);

        jCheckBoxAladinAffineDirect.setText("affine directly");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsAladin.add(jCheckBoxAladinAffineDirect, gridBagConstraints);

        jLabel6.setText("% of inlier for the LTS");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 12;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanelOptionsAladin.add(jLabel6, gridBagConstraints);

        jFormattedTextFieldAladinPercInlierLTS.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(java.text.NumberFormat.getIntegerInstance())));
        jFormattedTextFieldAladinPercInlierLTS.setText("50");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 12;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsAladin.add(jFormattedTextFieldAladinPercInlierLTS, gridBagConstraints);

        jLabel7.setText("smooth floating Img. (sigma)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsAladin.add(jLabel7, gridBagConstraints);

        jFormattedTextFieldAladinSigmaFloating.setText("0.0");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsAladin.add(jFormattedTextFieldAladinSigmaFloating, gridBagConstraints);

        jTabbedPane1.addTab("Reg Aladin", jPanelOptionsAladin);

        jPanelOptionsF3D.setLayout(new java.awt.GridBagLayout());

        jCheckBoxF3DActive.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jCheckBoxF3DActive.setSelected(true);
        jCheckBoxF3DActive.setText("perform Reg. F3D");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weighty = 1.0;
        jPanelOptionsF3D.add(jCheckBoxF3DActive, gridBagConstraints);

        jPanelOptionsTabbed.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanelOptionsTabbed.setLayout(new java.awt.GridLayout(0, 1));

        jPanelOptionsF3DGeneral.setLayout(new java.awt.GridBagLayout());

        jPanel13.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel13.setLayout(new java.awt.GridLayout(0, 1));

        jCheckBoxF3DApplyControlPointGrid.setText("apply Crtl. Point Grid from file");
        jPanel13.add(jCheckBoxF3DApplyControlPointGrid);

        jButtonF3DSetControlPointGridFile.setText("set File...");
        jButtonF3DSetControlPointGridFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonF3DSetControlPointGridFileActionPerformed(evt);
            }
        });
        jPanel13.add(jButtonF3DSetControlPointGridFile);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsF3DGeneral.add(jPanel13, gridBagConstraints);

        jPanel6.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel6.setLayout(new java.awt.GridLayout(0, 1));

        jCheckBoxF3DAffineFromFile.setText("apply Affine from file");
        jPanel6.add(jCheckBoxF3DAffineFromFile);

        jButtonF3DSetAffineFile.setText("set File...");
        jButtonF3DSetAffineFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonF3DSetAffineFileActionPerformed(evt);
            }
        });
        jPanel6.add(jButtonF3DSetAffineFile);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsF3DGeneral.add(jPanel6, gridBagConstraints);

        jLabel8.setText("smooth reference Img. (sigma)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsF3DGeneral.add(jLabel8, gridBagConstraints);

        jFormattedTextFieldF3DSigmaRef.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter()));
        jFormattedTextFieldF3DSigmaRef.setText("0");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsF3DGeneral.add(jFormattedTextFieldF3DSigmaRef, gridBagConstraints);

        jFormattedTextFieldF3DNrBinsRef.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(java.text.NumberFormat.getIntegerInstance())));
        jFormattedTextFieldF3DNrBinsRef.setText("64");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 12;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsF3DGeneral.add(jFormattedTextFieldF3DNrBinsRef, gridBagConstraints);

        jLabel9.setText("nr. bins reference Img.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 12;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsF3DGeneral.add(jLabel9, gridBagConstraints);

        jLabel10.setText("nr. bins floating Img.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsF3DGeneral.add(jLabel10, gridBagConstraints);

        jFormattedTextFieldF3DNrBinsFloating.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(java.text.NumberFormat.getIntegerInstance())));
        jFormattedTextFieldF3DNrBinsFloating.setText("64");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsF3DGeneral.add(jFormattedTextFieldF3DNrBinsFloating, gridBagConstraints);

        jLabel11.setText("smooth floating Img. (sigma)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsF3DGeneral.add(jLabel11, gridBagConstraints);

        jFormattedTextFieldF3DSigmaFloating.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter()));
        jFormattedTextFieldF3DSigmaFloating.setText("0.0");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsF3DGeneral.add(jFormattedTextFieldF3DSigmaFloating, gridBagConstraints);

        jLabel16.setText("max iterations per level:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsF3DGeneral.add(jLabel16, gridBagConstraints);

        jFormattedTextFieldF3DMaxIterLevel.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(java.text.NumberFormat.getIntegerInstance())));
        jFormattedTextFieldF3DMaxIterLevel.setText("300");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsF3DGeneral.add(jFormattedTextFieldF3DMaxIterLevel, gridBagConstraints);

        jLabel17.setText("numbers of levels");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsF3DGeneral.add(jLabel17, gridBagConstraints);

        jFormattedTextFieldF3DNrLevels.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(java.text.NumberFormat.getIntegerInstance())));
        jFormattedTextFieldF3DNrLevels.setText("3");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsF3DGeneral.add(jFormattedTextFieldF3DNrLevels, gridBagConstraints);

        jLabel18.setText("perform only the first (levels):");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsF3DGeneral.add(jLabel18, gridBagConstraints);

        jFormattedTextFieldF3DNrFirstLevels.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(java.text.NumberFormat.getIntegerInstance())));
        jFormattedTextFieldF3DNrFirstLevels.setCursor(new java.awt.Cursor(java.awt.Cursor.TEXT_CURSOR));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsF3DGeneral.add(jFormattedTextFieldF3DNrFirstLevels, gridBagConstraints);

        jCheckBoxF3DPyramidal.setSelected(true);
        jCheckBoxF3DPyramidal.setText("pyramidal approach");
        jCheckBoxF3DPyramidal.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxF3DPyramidalActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        jPanelOptionsF3DGeneral.add(jCheckBoxF3DPyramidal, gridBagConstraints);

        jTabbedPane2.addTab("General", jPanelOptionsF3DGeneral);

        jPanelF3DOptionsObjectiveFunc.setLayout(new java.awt.GridBagLayout());

        jLabel19.setText("bending energy penalty");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelF3DOptionsObjectiveFunc.add(jLabel19, gridBagConstraints);

        jFormattedTextFieldF3DBendingEnergy.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter()));
        jFormattedTextFieldF3DBendingEnergy.setText("0.005");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelF3DOptionsObjectiveFunc.add(jFormattedTextFieldF3DBendingEnergy, gridBagConstraints);

        jLabel20.setText("linear elasticity penalty");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelF3DOptionsObjectiveFunc.add(jLabel20, gridBagConstraints);

        jFormattedTextFieldF3DLinElastPenalty1.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter()));
        jFormattedTextFieldF3DLinElastPenalty1.setText("0");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        jPanelF3DOptionsObjectiveFunc.add(jFormattedTextFieldF3DLinElastPenalty1, gridBagConstraints);

        jFormattedTextFieldF3DL2NormDispPenalty.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter()));
        jFormattedTextFieldF3DL2NormDispPenalty.setText("0.0");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelF3DOptionsObjectiveFunc.add(jFormattedTextFieldF3DL2NormDispPenalty, gridBagConstraints);

        jLabel21.setText("L2 norm displacement penalty");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelF3DOptionsObjectiveFunc.add(jLabel21, gridBagConstraints);

        jFormattedTextFieldF3DLogJacob.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter()));
        jFormattedTextFieldF3DLogJacob.setText("0");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelF3DOptionsObjectiveFunc.add(jFormattedTextFieldF3DLogJacob, gridBagConstraints);

        jLabel22.setText("log of Jacobian determinant penalty");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelF3DOptionsObjectiveFunc.add(jLabel22, gridBagConstraints);

        jFormattedTextFieldF3DLinElastPenalty2.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter()));
        jFormattedTextFieldF3DLinElastPenalty2.setText("0");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        jPanelF3DOptionsObjectiveFunc.add(jFormattedTextFieldF3DLinElastPenalty2, gridBagConstraints);

        jCheckBoxF3DApproxJLValOnlyControlP.setSelected(true);
        jCheckBoxF3DApproxJLValOnlyControlP.setText("approx. JL value only at control point pos.");
        jCheckBoxF3DApproxJLValOnlyControlP.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxF3DApproxJLValOnlyControlPActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanelF3DOptionsObjectiveFunc.add(jCheckBoxF3DApproxJLValOnlyControlP, gridBagConstraints);

        jLabel24.setText("optimization");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelF3DOptionsObjectiveFunc.add(jLabel24, gridBagConstraints);

        jComboBoxF3DOptimization.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "conjugate gradient", "gradient ascent" }));
        jComboBoxF3DOptimization.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxF3DOptimizationActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelF3DOptionsObjectiveFunc.add(jComboBoxF3DOptimization, gridBagConstraints);

        jLabel23.setText("similarity measure:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelF3DOptionsObjectiveFunc.add(jLabel23, gridBagConstraints);

        jComboBoxF3DSimilarityMeasure.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "bivariate NMI (default)", "additive NMI for multichannel", "SSD", "KL-divergence" }));
        jComboBoxF3DSimilarityMeasure.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxF3DSimilarityMeasureActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelF3DOptionsObjectiveFunc.add(jComboBoxF3DSimilarityMeasure, gridBagConstraints);

        jTabbedPane2.addTab("Objective Fcn.", jPanelF3DOptionsObjectiveFunc);

        jPanelF3DOptionsIntensity.setLayout(new java.awt.GridBagLayout());

        jPanel10.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel10.setLayout(new java.awt.GridBagLayout());

        jCheckBoxF3DUpThreshRef.setText("apply Upper Threshold to Ref. Img.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanel10.add(jCheckBoxF3DUpThreshRef, gridBagConstraints);

        jLabel14.setText("value:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        jPanel10.add(jLabel14, gridBagConstraints);

        jFormattedTextFieldF3DUpThreshRef.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter()));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 10);
        jPanel10.add(jFormattedTextFieldF3DUpThreshRef, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelF3DOptionsIntensity.add(jPanel10, gridBagConstraints);

        jPanel11.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel11.setLayout(new java.awt.GridBagLayout());

        jCheckBoxF3DLowThreshRef.setText("apply Lower Threshold to Ref. Img.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanel11.add(jCheckBoxF3DLowThreshRef, gridBagConstraints);

        jLabel15.setText("value:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        jPanel11.add(jLabel15, gridBagConstraints);

        jFormattedTextFieldF3DLowThreshRef.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter()));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 10);
        jPanel11.add(jFormattedTextFieldF3DLowThreshRef, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelF3DOptionsIntensity.add(jPanel11, gridBagConstraints);

        jPanel9.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel9.setLayout(new java.awt.GridBagLayout());

        jCheckBoxF3DLowThreshFloating.setText("apply Lower Threshold to Floating. Img.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanel9.add(jCheckBoxF3DLowThreshFloating, gridBagConstraints);

        jLabel13.setText("value:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        jPanel9.add(jLabel13, gridBagConstraints);

        jFormattedTextFieldF3DLowThreshFloating.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter()));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 10);
        jPanel9.add(jFormattedTextFieldF3DLowThreshFloating, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelF3DOptionsIntensity.add(jPanel9, gridBagConstraints);

        jPanel8.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel8.setLayout(new java.awt.GridBagLayout());

        jCheckBoxF3DUpThreshFloating.setText("apply Upper Threshold to Floating. Img.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanel8.add(jCheckBoxF3DUpThreshFloating, gridBagConstraints);

        jLabel12.setText("value:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        jPanel8.add(jLabel12, gridBagConstraints);

        jFormattedTextFieldF3DUpThreshFloating.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter()));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 10);
        jPanel8.add(jFormattedTextFieldF3DUpThreshFloating, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelF3DOptionsIntensity.add(jPanel8, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanelF3DOptionsIntensity.add(jPanelFiller1, gridBagConstraints);

        jTabbedPane2.addTab("Intensity Thresh.", jPanelF3DOptionsIntensity);

        jPanelF3DOptionsOther.setLayout(new java.awt.GridBagLayout());

        jPanel15.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel15.setLayout(new java.awt.GridBagLayout());

        jCheckBoxF3DSym.setText("use symmetric approach");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanel15.add(jCheckBoxF3DSym, gridBagConstraints);

        jLabel25.setText("inverse consistency penalty");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        jPanel15.add(jLabel25, gridBagConstraints);

        jFormattedTextFieldF3DSymInvPenalty.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter()));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 10);
        jPanel15.add(jFormattedTextFieldF3DSymInvPenalty, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelF3DOptionsOther.add(jPanel15, gridBagConstraints);

        jPanel16.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel16.setLayout(new java.awt.GridBagLayout());

        jCheckBoxF3DDiffeomorphic.setText("use veloc. field integration to generate deformation");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanel16.add(jCheckBoxF3DDiffeomorphic, gridBagConstraints);

        jLabel26.setText("nr. of composition step");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        jPanel16.add(jLabel26, gridBagConstraints);

        jFormattedTextFieldF3DDiffeoCompStep.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(java.text.NumberFormat.getIntegerInstance())));
        jFormattedTextFieldF3DDiffeoCompStep.setText("6");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 10);
        jPanel16.add(jFormattedTextFieldF3DDiffeoCompStep, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelF3DOptionsOther.add(jPanel16, gridBagConstraints);

        jPanel17.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel17.setLayout(new java.awt.GridBagLayout());

        jCheckBoxF3DSmoothGrad.setText("smooth Gradient");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanel17.add(jCheckBoxF3DSmoothGrad, gridBagConstraints);

        jLabel27.setText("value (mm)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        jPanel17.add(jLabel27, gridBagConstraints);

        jFormattedTextFieldF3DSmoothGrad.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter()));
        jFormattedTextFieldF3DSmoothGrad.setText("0.0");
        jFormattedTextFieldF3DSmoothGrad.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jFormattedTextFieldF3DSmoothGradActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 10);
        jPanel17.add(jFormattedTextFieldF3DSmoothGrad, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelF3DOptionsOther.add(jPanel17, gridBagConstraints);

        jPanel18.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel18.setLayout(new java.awt.GridBagLayout());

        jCheckBoxF3DPaddingVal.setText("padding value");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanel18.add(jCheckBoxF3DPaddingVal, gridBagConstraints);

        jLabel28.setText("value");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        jPanel18.add(jLabel28, gridBagConstraints);

        jFormattedTextFieldF3DPaddingVal.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter()));
        jFormattedTextFieldF3DPaddingVal.setText("NaN");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 10);
        jPanel18.add(jFormattedTextFieldF3DPaddingVal, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelF3DOptionsOther.add(jPanel18, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanelF3DOptionsOther.add(jPanelFiller2, gridBagConstraints);

        jTabbedPane2.addTab("Other", jPanelF3DOptionsOther);

        jPanelOptionsTabbed.add(jTabbedPane2);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanelOptionsF3D.add(jPanelOptionsTabbed, gridBagConstraints);

        jTabbedPane1.addTab("F3D", jPanelOptionsF3D);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        jPanel2.add(jTabbedPane1, gridBagConstraints);

        jTextArea1.setColumns(20);
        jTextArea1.setLineWrap(true);
        jTextArea1.setRows(5);
        jTextArea1.setWrapStyleWord(true);
        jScrollPane2.setViewportView(jTextArea1);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
        jPanel2.add(jScrollPane2, gridBagConstraints);

        jSplitPane2.setLeftComponent(jPanel2);

        jSplitPane1.setDividerLocation(300);
        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jSplitPane1.setResizeWeight(0.8);
        jSplitPane1.setToolTipText("");
        jSplitPane1.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        jSplitPane1.setMinimumSize(new java.awt.Dimension(0, 0));

        pnlFileManager.setFocusable(false);
        pnlFileManager.setPreferredSize(new java.awt.Dimension(1280, 400));
        pnlFileManager.setLayout(new java.awt.GridLayout(1, 0));
        jTabbedPane3.addTab("File Manager", pnlFileManager);

        jPanel4.setLayout(new javax.swing.BoxLayout(jPanel4, javax.swing.BoxLayout.LINE_AXIS));

        jTableResults.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Time", "Running Time", "Reference", "Floating", "Result", "Res. Aff.", "Res. CPP", "MI (before)", "MI (after)", "NMI (before)", "NMI (after)", "Corr. (before)", "Corr. (after)", "Mean Diff(before)", "Mean Diff(after)", "Mode", "Alad - Sym", "Alad - RigOnly", "Alad - AffDirect", "Alad - AffInputFile", "Alad - Nr Iter", "Alad - Nr Levels", "Alad - First Levels", "Alad - Init Transl Header", "Alad - % Block", "Alad - % Inlier LTS", "Alad - sigma Ref.", "Alad - sigma Float.", "F3D - CPGrid File", "F3D - AffInputFile", "F3D - sigma Ref.", "F3D - sigma Float.", "F3D - Bins Ref.", "F3D - Bins Float.", "F3D - Ref. L Thresh ", "F3D - Ref. H Thresh", "F3D - Float. L Thresh", "F3D - Float. H Thresh", "F3D - Final Grid SpaceX", "F3D - Final Grid SpaceY", "F3D - Final Grid SpaceZ", "F3D - Bending Penalty", "F3D - Lin. Elast. Penalty1", "F3D - Lin. Elast. Penalty2", "F3D - L2Norm Disp. Penalty", "F3D - Log.JacobDet. Penalty", "F3D - Approx. JL Only at CPoint", "F3D - Optimization", "F3D - Sim. Measure", "F3D - Max Iter", "F3D - Nr Levels", "F3D - First Levels", "F3D - Pyramidal", "F3D - Sym", "F3D - Sym Inv Penalty", "F3D - Vel. Field", "F3D - Vel. Comp. Steps", "F3D - Smooth Grad", "F3D - Padding Val"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.Float.class, java.lang.Float.class, java.lang.Float.class, java.lang.Float.class, java.lang.Float.class, java.lang.Float.class, java.lang.Object.class, java.lang.Object.class, java.lang.String.class, java.lang.Boolean.class, java.lang.Boolean.class, java.lang.Boolean.class, java.lang.String.class, java.lang.Integer.class, java.lang.Integer.class, java.lang.Integer.class, java.lang.Boolean.class, java.lang.Integer.class, java.lang.Integer.class, java.lang.Float.class, java.lang.Float.class, java.lang.String.class, java.lang.String.class, java.lang.Float.class, java.lang.Float.class, java.lang.Integer.class, java.lang.Integer.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.Float.class, java.lang.Float.class, java.lang.Float.class, java.lang.Float.class, java.lang.Float.class, java.lang.Float.class, java.lang.Float.class, java.lang.Float.class, java.lang.Boolean.class, java.lang.String.class, java.lang.String.class, java.lang.Integer.class, java.lang.Integer.class, java.lang.Integer.class, java.lang.Boolean.class, java.lang.Boolean.class, java.lang.Float.class, java.lang.Boolean.class, java.lang.Integer.class, java.lang.Float.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTableResults.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jTableResults.setColumnSelectionAllowed(true);
        jScrollPane3.setViewportView(jTableResults);
        jTableResults.getColumnModel().getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);

        jPanel4.add(jScrollPane3);

        jTabbedPane3.addTab("Results", jPanel4);

        jSplitPane1.setBottomComponent(jTabbedPane3);

        pnlMain.setMinimumSize(new java.awt.Dimension(132, 99));
        pnlMain.setPreferredSize(new java.awt.Dimension(1280, 384));
        pnlMain.setLayout(new java.awt.GridBagLayout());

        pnlRef.setBackground(new java.awt.Color(0, 0, 0));
        pnlRef.setPreferredSize(new java.awt.Dimension(256, 256));
        pnlRef.setLayout(new java.awt.GridBagLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 4;
        gridBagConstraints.ipady = 4;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        pnlMain.add(pnlRef, gridBagConstraints);

        pnlFloating.setBackground(new java.awt.Color(0, 0, 0));
        pnlFloating.setPreferredSize(new java.awt.Dimension(256, 256));
        pnlFloating.setLayout(new java.awt.GridBagLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 4;
        gridBagConstraints.ipady = 4;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        pnlMain.add(pnlFloating, gridBagConstraints);

        pnlRes.setBackground(new java.awt.Color(0, 0, 0));
        pnlRes.setPreferredSize(new java.awt.Dimension(256, 256));
        pnlRes.setLayout(new java.awt.GridBagLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 4;
        gridBagConstraints.ipady = 4;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 1);
        pnlMain.add(pnlRes, gridBagConstraints);

        jTextFieldFloating.setEditable(false);
        jTextFieldFloating.setMaximumSize(null);
        jTextFieldFloating.setMinimumSize(null);
        jTextFieldFloating.setPreferredSize(new java.awt.Dimension(256, 28));
        jTextFieldFloating.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextFieldFloatingActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pnlMain.add(jTextFieldFloating, gridBagConstraints);

        jTextFieldRef.setEditable(false);
        jTextFieldRef.setMaximumSize(null);
        jTextFieldRef.setMinimumSize(null);
        jTextFieldRef.setName(""); // NOI18N
        jTextFieldRef.setPreferredSize(new java.awt.Dimension(256, 28));
        jTextFieldRef.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextFieldRefActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pnlMain.add(jTextFieldRef, gridBagConstraints);

        jComboBoxResultMode.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Difference", "Checkerboard" }));
        jComboBoxResultMode.setMaximumSize(null);
        jComboBoxResultMode.setMinimumSize(null);
        jComboBoxResultMode.setPreferredSize(new java.awt.Dimension(256, 28));
        jComboBoxResultMode.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxResultModeActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pnlMain.add(jComboBoxResultMode, gridBagConstraints);

        jSliderRef.setMinimumSize(null);
        jSliderRef.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSliderRefStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pnlMain.add(jSliderRef, gridBagConstraints);

        jSliderFloating.setMinimumSize(null);
        jSliderFloating.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSliderFloatingStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pnlMain.add(jSliderFloating, gridBagConstraints);

        jSliderRes.setMinimumSize(null);
        jSliderRes.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSliderResStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pnlMain.add(jSliderRes, gridBagConstraints);

        buttonGroup1.add(jRadioButtonRef);
        jRadioButtonRef.setSelected(true);
        jRadioButtonRef.setText("Reference");
        jRadioButtonRef.setMinimumSize(null);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pnlMain.add(jRadioButtonRef, gridBagConstraints);

        buttonGroup1.add(jRadioButtonFloating);
        jRadioButtonFloating.setText("Floating Image");
        jRadioButtonFloating.setMinimumSize(null);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pnlMain.add(jRadioButtonFloating, gridBagConstraints);

        jButtonLoadDisplacements.setText("load Displacements");
        jButtonLoadDisplacements.setMinimumSize(null);
        jButtonLoadDisplacements.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonLoadDisplacementsActionPerformed(evt);
            }
        });
        jPanel7.add(jButtonLoadDisplacements);

        jButtonLoadReference.setText("load reference Img.");
        jButtonLoadReference.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonLoadReferenceActionPerformed(evt);
            }
        });
        jPanel7.add(jButtonLoadReference);

        jButtonLoadFloatting.setText("load floating Img.");
        jButtonLoadFloatting.setMinimumSize(null);
        jButtonLoadFloatting.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonLoadFloattingActionPerformed(evt);
            }
        });
        jPanel7.add(jButtonLoadFloatting);

        jToggleButtonPinSliders.setText("Pin Sliders");
        jToggleButtonPinSliders.setMinimumSize(null);
        jToggleButtonPinSliders.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButtonPinSlidersActionPerformed(evt);
            }
        });
        jPanel7.add(jToggleButtonPinSliders);

        jButtonRun.setText("Run!");
        jButtonRun.setMinimumSize(null);
        jButtonRun.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonRunActionPerformed(evt);
            }
        });
        jPanel7.add(jButtonRun);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pnlMain.add(jPanel7, gridBagConstraints);

        jSplitPane1.setLeftComponent(pnlMain);

        jSplitPane2.setRightComponent(jSplitPane1);

        getContentPane().add(jSplitPane2);

        jMenuImage.setText("Image");

        jMenuItemImageInfo.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemImageInfo.setText("Print Image Info from Floating");
        jMenuItemImageInfo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemImageInfoActionPerformed(evt);
            }
        });
        jMenuImage.add(jMenuItemImageInfo);

        jMenuItemImageInfo1.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_R, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemImageInfo1.setText("Print Image Info from Reference");
        jMenuItemImageInfo1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemImageInfo1ActionPerformed(evt);
            }
        });
        jMenuImage.add(jMenuItemImageInfo1);

        jMenuItemInnerProdNormVects.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_I, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemInnerProdNormVects.setText("Print Inner Product V3");
        jMenuItemInnerProdNormVects.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemInnerProdNormVectsActionPerformed(evt);
            }
        });
        jMenuImage.add(jMenuItemInnerProdNormVects);

        jMenuItemImageDimensions.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_D, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemImageDimensions.setText("Print Image Dimensions");
        jMenuItemImageDimensions.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemImageDimensionsActionPerformed(evt);
            }
        });
        jMenuImage.add(jMenuItemImageDimensions);

        jMenuItemImageDimensions1.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_N, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemImageDimensions1.setText("Print File Names");
        jMenuItemImageDimensions1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemImageDimensions1ActionPerformed(evt);
            }
        });
        jMenuImage.add(jMenuItemImageDimensions1);

        jMenuItemTemp.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_Y, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItemTemp.setText("TEMP");
        jMenuItemTemp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemTempActionPerformed(evt);
            }
        });
        jMenuImage.add(jMenuItemTemp);

        jMenuBar1.add(jMenuImage);

        jMenuGrid.setText("Grid");

        jMenuItemClearGridRef.setText("Clear Grid Reference");
        jMenuItemClearGridRef.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemClearGridRefActionPerformed(evt);
            }
        });
        jMenuGrid.add(jMenuItemClearGridRef);

        jMenuItemClearGridFloating.setText("Clear Grid Floating");
        jMenuItemClearGridFloating.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemClearGridFloatingActionPerformed(evt);
            }
        });
        jMenuGrid.add(jMenuItemClearGridFloating);

        jMenuBar1.add(jMenuGrid);

        jMenuView.setText("View");

        jCheckBoxMenuItemShowIntersectsMain.setText("Intersections in main image");
        jCheckBoxMenuItemShowIntersectsMain.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItemShowIntersectsMainActionPerformed(evt);
            }
        });
        jMenuView.add(jCheckBoxMenuItemShowIntersectsMain);

        jCheckBoxShowMapValues.setSelected(true);
        jCheckBoxShowMapValues.setText("Map Values");
        jCheckBoxShowMapValues.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxShowMapValuesActionPerformed(evt);
            }
        });
        jMenuView.add(jCheckBoxShowMapValues);

        jCheckBoxMenuItemViewSliceOrientation.setText("Slice Orientation");
        jCheckBoxMenuItemViewSliceOrientation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItemViewSliceOrientationActionPerformed(evt);
            }
        });
        jMenuView.add(jCheckBoxMenuItemViewSliceOrientation);

        jCheckBoxMenuItemShowPatientName.setSelected(true);
        jCheckBoxMenuItemShowPatientName.setText("Patient Name");
        jCheckBoxMenuItemShowPatientName.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItemShowPatientNameActionPerformed(evt);
            }
        });
        jMenuView.add(jCheckBoxMenuItemShowPatientName);

        jCheckBoxMenuItemShowSeriesInfo.setSelected(true);
        jCheckBoxMenuItemShowSeriesInfo.setText("Series Information");
        jCheckBoxMenuItemShowSeriesInfo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItemShowSeriesInfoActionPerformed(evt);
            }
        });
        jMenuView.add(jCheckBoxMenuItemShowSeriesInfo);

        jMenuBar1.add(jMenuView);

        setJMenuBar(jMenuBar1);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jTextFieldFloatingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextFieldFloatingActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextFieldFloatingActionPerformed

    private void jTextFieldRefActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextFieldRefActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextFieldRefActionPerformed

    private void jSliderRefStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSliderRefStateChanged
        if (csimodelRef != null) {
            csimodelRef.setSlice(jSliderRef.getValue());
            if (this.jToggleButtonPinSliders.isSelected()) {
                if (csimodelFloating != null) {
                    csimodelFloating.setSlice(jSliderRef.getValue());
                }
                if (csimodelRes != null) {
                    csimodelRes.setSlice(jSliderRef.getValue());
                }
            }
        }
    }//GEN-LAST:event_jSliderRefStateChanged

    private void jSliderFloatingStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSliderFloatingStateChanged
        if (csimodelFloating != null) {
            csimodelFloating.setSlice(jSliderFloating.getValue());
            if (this.jToggleButtonPinSliders.isSelected()) {
                if (csimodelRef != null) {
                    csimodelRef.setSlice(jSliderFloating.getValue());
                }
                if (csimodelRes != null) {
                    csimodelRes.setSlice(jSliderFloating.getValue());
                }
            }
        }
    }//GEN-LAST:event_jSliderFloatingStateChanged

    private void jButtonRunActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonRunActionPerformed
        if (!this.jTextFieldRef.getText().isEmpty() && !this.jTextFieldFloating.getText().isEmpty()) {
            String outputFolder = RegistrationSettings.getInstance().getOutputFolder();
            String fileRef = jTextFieldRef.getText();
            if (!fileRef.endsWith("nii")) {
                fileRef = NiftiHandler.dcm2nii(this.csimodelRef.getImageStack().getFiles(), outputFolder, this);
                publish("Conversion to Nifti. Created File: " + fileRef);
            }
            String fileFloating = jTextFieldFloating.getText();
            if (!fileFloating.endsWith("nii")) {
                fileFloating = NiftiHandler.dcm2nii(this.csimodelFloating.getImageStack().getFiles(), outputFolder, this);
                publish("Conversion to Nifti. Created File: " + fileFloating);
            }
            String fileRes = outputFolder + File.separator + "res" + System.currentTimeMillis() + ".nii";
            String fileAff = outputFolder + File.separator + "aff" + System.currentTimeMillis() + ".txt";
            String fileCpp = outputFolder + File.separator + "cpp" + System.currentTimeMillis() + ".nii";
            String fileDef = outputFolder + File.separator + "def" + System.currentTimeMillis() + ".nii";
            String fileDisp = outputFolder + File.separator + "disp" + System.currentTimeMillis() + ".nii";
            RegistrationWorkerListener listener = this;

            if (jCheckBoxAladinActive.isSelected() && jCheckBoxF3DActive.isSelected()) {
                publish(">>>>>>>Rigid + Non-Rigid registration (Reg Aladin + Reg F3D) initialized!");
                RegistrationWorker worker = new RegistrationWorker(fileRef, fileFloating, fileRes, fileAff, fileCpp, fileDef, fileDisp, this, RegistrationWorker.Mode.BOTH);
                setRegistrationOptions(worker);
                worker.execute();
                valuesBefore = getSimilarityMeasures(this.csimodelRef.getImageStack(), this.csimodelFloating.getImageStack(), 128, 0.01);
            } else if (jCheckBoxAladinActive.isSelected()) {
                publish(">>>>>>>Rigid registration (Reg Aladin) initialized...");
                RegistrationWorker worker = new RegistrationWorker(fileRef, fileFloating, fileRes, fileAff, fileCpp, fileDef, fileDisp, this, RegistrationWorker.Mode.RIGID);
                setRegistrationOptions(worker);
                worker.execute();
                valuesBefore = getSimilarityMeasures(this.csimodelRef.getImageStack(), this.csimodelFloating.getImageStack(), 128, 0.01);
            } else if (jCheckBoxF3DActive.isSelected()) {
                publish(">>>>>>>Non-Rigid registration (Reg F3D) initialized...");
                RegistrationWorker worker = new RegistrationWorker(fileRef, fileFloating, fileRes, fileAff, fileCpp, fileDef, fileDisp, this, RegistrationWorker.Mode.NONRIGID);
                setRegistrationOptions(worker);
                worker.execute();
                valuesBefore = getSimilarityMeasures(this.csimodelRef.getImageStack(), this.csimodelFloating.getImageStack(), 128, 0.01);
            } else {
            }

        }
    }//GEN-LAST:event_jButtonRunActionPerformed

    private void initOptionValues() {
        //     Values ALADIN
        jFormattedTextFieldAladinNrFirstLevels.setValue(3);
        jFormattedTextFieldAladinMaxIter.setValue(5);
        jFormattedTextFieldAladinNrLevels.setValue(3);
        jFormattedTextFieldAladinPercBlock.setValue(50);
        jFormattedTextFieldAladinPercInlierLTS.setValue(50);
        jFormattedTextFieldAladinSigmaFloating.setValue(0.0);
        jFormattedTextFieldAladinSigmaRef.setValue(0.0);

//          Values F3D
        jFormattedTextFieldF3DBendingEnergy.setValue(0.005);
        jFormattedTextFieldF3DNrFirstLevels.setValue(3);
        jFormattedTextFieldF3DL2NormDispPenalty.setValue(0.0);
        jFormattedTextFieldF3DLinElastPenalty1.setValue(0.0);
        jFormattedTextFieldF3DLinElastPenalty2.setValue(0.0);
        jFormattedTextFieldF3DLogJacob.setValue(0.0);
        jFormattedTextFieldF3DMaxIterLevel.setValue(300);
        jFormattedTextFieldF3DNrBinsFloating.setValue(64);
        jFormattedTextFieldF3DNrBinsRef.setValue(64);
        jFormattedTextFieldF3DNrLevels.setValue(3);
        jFormattedTextFieldF3DSigmaFloating.setValue(0.0);
        jFormattedTextFieldF3DSigmaRef.setValue(0.0);
        jFormattedTextFieldF3DUpThreshFloating.setValue(0.0);
        jFormattedTextFieldF3DLowThreshFloating.setValue(0.0);
        jFormattedTextFieldF3DUpThreshRef.setValue(0.0);
        jFormattedTextFieldF3DLowThreshRef.setValue(0.0);
        jFormattedTextFieldF3DSymInvPenalty.setValue(0.01);
        jFormattedTextFieldF3DDiffeoCompStep.setValue(6);
        jFormattedTextFieldF3DSmoothGrad.setValue(0.0);
        jFormattedTextFieldF3DPaddingVal.setValue(0);
    }

    private int conv2Int(Object val) {
        if (val.getClass() == Long.class) {
            return (int) (long) val;
        } else {
            return (int) val;
        }
    }

    private double conv2Double(Object val) {
        if (val.getClass() == Long.class) {
            return (double) (long) val;
        } else {
            return (double) val;
        }
    }

    private void setRegistrationOptions(RegistrationWorker worker) {
//     OPTIONS ALADIN
        worker.setAladinAffFromFile(jCheckBoxAladinAffineFromFile.isSelected(), this.aladinAffFile);
        worker.setAladinFirstLevels(conv2Int(jFormattedTextFieldAladinNrFirstLevels.getValue()));
        worker.setAladinInitTranslWithNiftiHeader(jCheckBoxAladinInitTranslHeader.isSelected());
        worker.setAladinNrIterations(conv2Int(jFormattedTextFieldAladinMaxIter.getValue()));
        worker.setAladinNrLevels(conv2Int(jFormattedTextFieldAladinNrLevels.getValue()));
        worker.setAladinPercentBlock(conv2Int(jFormattedTextFieldAladinPercBlock.getValue()));
        worker.setAladinPercentInlierLTS(conv2Int(jFormattedTextFieldAladinPercInlierLTS.getValue()));
        worker.setAladinRigOnly(jCheckBoxAladinRigidOnly.isSelected());
        worker.setAladinSigmaFloating(conv2Double(jFormattedTextFieldAladinSigmaFloating.getValue()));
        worker.setAladinSigmaRef(conv2Double(jFormattedTextFieldAladinSigmaRef.getValue()));
        worker.setAladinSym(jCheckBoxAladinSym.isSelected());
        worker.setAladinAffDirect(jCheckBoxAladinAffineDirect.isSelected());

//     OPTIONS F3D
        worker.setF3DAffFromFile(jCheckBoxF3DAffineFromFile.isSelected(), f3dAffFile);
        worker.setF3DApproxJLOnlyAtControlPoint(jCheckBoxF3DApproxJLValOnlyControlP.isSelected());
        worker.setF3DBendingEnergyPenalty(conv2Double(jFormattedTextFieldF3DBendingEnergy.getValue()));
        worker.setF3DCPGFromFile(jCheckBoxF3DApplyControlPointGrid.isSelected(), f3dPCGFile);
        worker.setF3DFirstLevels(conv2Int(jFormattedTextFieldF3DNrFirstLevels.getValue()));
        worker.setF3DL2NormDisplacementPenalty(conv2Double(jFormattedTextFieldF3DL2NormDispPenalty.getValue()));
        worker.setF3DLinearElasticityPenalty(conv2Double(jFormattedTextFieldF3DLinElastPenalty1.getValue()), conv2Double(jFormattedTextFieldF3DLinElastPenalty2.getValue()));
        worker.setF3DLogJacobDeterminantPenalty(conv2Double(jFormattedTextFieldF3DLogJacob.getValue()));
        worker.setF3DMaxIterLevel(conv2Int(jFormattedTextFieldF3DMaxIterLevel.getValue()));
        worker.setF3DNrBinsFloating(conv2Int(jFormattedTextFieldF3DNrBinsFloating.getValue()));
        worker.setF3DNrBinsRef(conv2Int(jFormattedTextFieldF3DNrBinsRef.getValue()));
        worker.setF3DNrLevels(conv2Int(jFormattedTextFieldF3DNrLevels.getValue()));
        worker.setF3DSigmaFloating(conv2Double(jFormattedTextFieldF3DSigmaFloating.getValue()));
        worker.setF3DSigmaRef(conv2Double(jFormattedTextFieldF3DSigmaRef.getValue()));

        switch (jComboBoxF3DSimilarityMeasure.getSelectedIndex()) {
            case 0:
                worker.setF3DSimilarityMeasure(RegistrationWorker.optF3DSimilarityMeasureTypes.NMI);
                break;
            case 1:
                worker.setF3DSimilarityMeasure(RegistrationWorker.optF3DSimilarityMeasureTypes.ADD_NMI);
                break;
            case 2:
                worker.setF3DSimilarityMeasure(RegistrationWorker.optF3DSimilarityMeasureTypes.SSD);
                break;
            case 3:
                worker.setF3DSimilarityMeasure(RegistrationWorker.optF3DSimilarityMeasureTypes.KLDiv);
                break;
        }
        worker.setF3DThresholdFloatingHigh(jCheckBoxF3DUpThreshFloating.isSelected(), conv2Double(jFormattedTextFieldF3DUpThreshFloating.getValue()));
        worker.setF3DThresholdFloatingLow(jCheckBoxF3DLowThreshFloating.isSelected(), conv2Double(jFormattedTextFieldF3DLowThreshFloating.getValue()));
        worker.setF3DThresholdRefHigh(jCheckBoxF3DUpThreshRef.isSelected(), conv2Double(jFormattedTextFieldF3DUpThreshRef.getValue()));
        worker.setF3DThresholdRefLow(jCheckBoxF3DLowThreshRef.isSelected(), conv2Double(jFormattedTextFieldF3DLowThreshRef.getValue()));
        worker.setF3DUseConjugateGradOptim(rootPaneCheckingEnabled);
        worker.setF3DSymInvConsistPenalty((conv2Double(jFormattedTextFieldF3DSymInvPenalty.getValue())));
        worker.setF3DVel(jCheckBoxF3DDiffeomorphic.isSelected());
        worker.setF3DVelNrComposStep(conv2Int(jFormattedTextFieldF3DDiffeoCompStep.getValue()));
        if (jCheckBoxF3DSmoothGrad.isSelected()) {
            worker.setF3DSmoothGrad(conv2Double(jFormattedTextFieldF3DSmoothGrad.getValue()));
        }
        if (jCheckBoxF3DPaddingVal.isSelected()) {
            worker.setF3DPaddingVal(conv2Double(jFormattedTextFieldF3DPaddingVal.getValue()));
        }
        worker.setF3DPyramidal(jCheckBoxF3DPyramidal.isSelected());
        worker.setF3DSym(jCheckBoxF3DSym.isSelected());

        switch (jComboBoxF3DOptimization.getSelectedIndex()) {
            case 0:
                worker.setF3DUseConjugateGradOptim(true);
                break;
            case 1:
                worker.setF3DUseConjugateGradOptim(false);
                break;
        }
    }

    private void jToggleButtonPinSlidersActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButtonPinSlidersActionPerformed
    }//GEN-LAST:event_jToggleButtonPinSlidersActionPerformed

    private void jSliderResStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSliderResStateChanged
        if (csimodelRes != null) {
            csimodelRes.setSlice(jSliderRes.getValue());
            if (this.jToggleButtonPinSliders.isSelected()) {
                if (csimodelRef != null) {
                    csimodelRef.setSlice(jSliderRes.getValue());
                }
                if (csimodelFloating != null) {
                    csimodelFloating.setSlice(jSliderRes.getValue());
                }
            }
        }
    }//GEN-LAST:event_jSliderResStateChanged

    private void jComboBoxResultModeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxResultModeActionPerformed
        if (csimodelFloating != null && csimodelRef != null) {
            GlobalModel model = csimodelRef.createCombinedModel(csimodelFloating, this.jComboBoxResultMode.getSelectedIndex());
            if (model != null) {
                this.setResModel(model);
            }
        }
    }//GEN-LAST:event_jComboBoxResultModeActionPerformed

    private void jButtonLoadFloattingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonLoadFloattingActionPerformed
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setDialogTitle("Open Floating Image");
        fileChooser.setCurrentDirectory(currentFile);
        FileNameExtensionFilter filter = new FileNameExtensionFilter("Nifti", "nii");
        fileChooser.setFileFilter(filter);
        int result = fileChooser.showOpenDialog(this);
        File selected_file;
        switch (result) {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                selected_file = fileChooser.getSelectedFile();
                this.currentFile = fileChooser.getCurrentDirectory();
                if (selected_file != null) {
                    if (csimodelFloating == null) {
                        csimodelFloating = new GlobalModel();
                    }
                    csimodelFloating.setImageStack(NiftiHandler.getImagesFromNifti(selected_file.toString()));
                    setFloatingModel(csimodelFloating);
                    if (csimodelRef != null) {
                        setResModel(csimodelRef.createCombinedModel(csimodelFloating, this.jComboBoxResultMode.getSelectedIndex()));
                    }
                    jTextFieldFloating.setText(selected_file.toString());
                }
                break;
            case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                break;
            case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                break;
        }
    }//GEN-LAST:event_jButtonLoadFloattingActionPerformed

    private void jButtonAladinAffineFromFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAladinAffineFromFileActionPerformed
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setDialogTitle("Open Affine file");
        fileChooser.setCurrentDirectory(currentFile);
        FileNameExtensionFilter filter = new FileNameExtensionFilter("Nifti", "nii");
        fileChooser.setFileFilter(filter);
        int result = fileChooser.showOpenDialog(this);
        File selected_file;
        switch (result) {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                selected_file = fileChooser.getSelectedFile();
                this.currentFile = fileChooser.getCurrentDirectory();
                if (selected_file != null) {
                    this.aladinAffFile = selected_file.toString();
                    this.jButtonAladinAffineFromFile.setText(selected_file.toString());
                }
                break;
            case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                break;
            case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                break;
        }
    }//GEN-LAST:event_jButtonAladinAffineFromFileActionPerformed

    private void jButtonF3DSetAffineFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonF3DSetAffineFileActionPerformed
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setDialogTitle("Open Affine file");
        fileChooser.setCurrentDirectory(currentFile);
        FileNameExtensionFilter filter = new FileNameExtensionFilter("Nifti", "nii");
        fileChooser.setFileFilter(filter);
        int result = fileChooser.showOpenDialog(this);
        File selected_file;
        switch (result) {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                selected_file = fileChooser.getSelectedFile();
                this.currentFile = fileChooser.getCurrentDirectory();
                if (selected_file != null) {
                    this.f3dAffFile = selected_file.toString();
                    this.jButtonF3DSetAffineFile.setText(selected_file.toString());
                }
                break;
            case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                break;
            case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                break;
        }
    }//GEN-LAST:event_jButtonF3DSetAffineFileActionPerformed

    private void jButtonF3DSetControlPointGridFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonF3DSetControlPointGridFileActionPerformed
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setDialogTitle("Open Control Point Grid file");
        fileChooser.setCurrentDirectory(currentFile);
        FileNameExtensionFilter filter = new FileNameExtensionFilter("Nifti", "nii");
        fileChooser.setFileFilter(filter);
        int result = fileChooser.showOpenDialog(this);
        File selected_file;
        switch (result) {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                selected_file = fileChooser.getSelectedFile();
                this.currentFile = fileChooser.getCurrentDirectory();
                if (selected_file != null) {
                    this.f3dPCGFile = selected_file.toString();
                    this.jButtonF3DSetControlPointGridFile.setText(selected_file.toString());
                }
                break;
            case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                break;
            case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                break;
        }
    }//GEN-LAST:event_jButtonF3DSetControlPointGridFileActionPerformed

    private void jComboBoxF3DSimilarityMeasureActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxF3DSimilarityMeasureActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jComboBoxF3DSimilarityMeasureActionPerformed

    private void jCheckBoxF3DPyramidalActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxF3DPyramidalActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jCheckBoxF3DPyramidalActionPerformed

    private void jCheckBoxF3DApproxJLValOnlyControlPActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxF3DApproxJLValOnlyControlPActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jCheckBoxF3DApproxJLValOnlyControlPActionPerformed

    private void jFormattedTextFieldF3DSmoothGradActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jFormattedTextFieldF3DSmoothGradActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jFormattedTextFieldF3DSmoothGradActionPerformed

    private void jComboBoxF3DOptimizationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxF3DOptimizationActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jComboBoxF3DOptimizationActionPerformed

    private void jButtonLoadDisplacementsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonLoadDisplacementsActionPerformed
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setDialogTitle("Open Displacement Field");
        fileChooser.setCurrentDirectory(currentFile);
        FileNameExtensionFilter filter = new FileNameExtensionFilter("Nifti", "nii");
        fileChooser.setFileFilter(filter);
        int result = fileChooser.showOpenDialog(this);
        File selected_file;
        switch (result) {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                selected_file = fileChooser.getSelectedFile();
                this.currentFile = fileChooser.getCurrentDirectory();
                if (selected_file != null) {
                    if (csimodelFloating != null) {
                        if (csimodelFloating.getImageStack() != null) {
                            csimodelFloating.setDisplacementField(selected_file.toString(), true);
                        }
                    }
                }
                break;
            case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                break;
            case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                break;
        }
    }//GEN-LAST:event_jButtonLoadDisplacementsActionPerformed

    private void jButtonLoadReferenceActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonLoadReferenceActionPerformed
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setDialogTitle("Open Floating Image");
        fileChooser.setCurrentDirectory(currentFile);
        FileNameExtensionFilter filter = new FileNameExtensionFilter("Nifti", "nii");
        fileChooser.setFileFilter(filter);
        int result = fileChooser.showOpenDialog(this);
        File selected_file;
        switch (result) {
            case JFileChooser.APPROVE_OPTION:   // Approve Open button was pressed
                selected_file = fileChooser.getSelectedFile();
                this.currentFile = fileChooser.getCurrentDirectory();
                if (selected_file != null) {
                    if (csimodelRef == null) {
                        csimodelRef = new GlobalModel();
                    }
                    csimodelRef.setImageStack(NiftiHandler.getImagesFromNifti(selected_file.toString()));
                    setRefModel(csimodelRef);
                    if (csimodelFloating != null) {
                        setResModel(csimodelRef.createCombinedModel(csimodelFloating, this.jComboBoxResultMode.getSelectedIndex()));
                    }
                    jTextFieldRef.setText(selected_file.toString());
                }
                break;
            case JFileChooser.CANCEL_OPTION:     // Cancel or close dialog was selected
                break;
            case JFileChooser.ERROR_OPTION:      // the selected process did not terminate properly
                break;
        }
    }//GEN-LAST:event_jButtonLoadReferenceActionPerformed

    private void jMenuItemImageInfoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemImageInfoActionPerformed
        if (csimodelFloating != null) {
            if (csimodelFloating.getGridSize() > 0) {
                csimodelFloating.analyseSelectedVoxelsSubImage();
            }
        }
    }//GEN-LAST:event_jMenuItemImageInfoActionPerformed

    private void jMenuItemImageInfo1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemImageInfo1ActionPerformed
        if (csimodelRef != null) {
            if (csimodelRef.getGridSize() > 0) {
                csimodelRef.analyseSelectedVoxelsSubImage();
            }
        }
    }//GEN-LAST:event_jMenuItemImageInfo1ActionPerformed

    private void jMenuItemInnerProdNormVectsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemInnerProdNormVectsActionPerformed
        if (csimodelRef != null && csimodelFloating != null) {
            Point3D exref = csimodelRef.getImageStack().get(0).imageOrientationX;
            Point3D eyref = csimodelRef.getImageStack().get(0).imageOrientationY;
            Point3D exfloat = csimodelFloating.getImageStack().get(0).imageOrientationX;
            Point3D eyfloat = csimodelFloating.getImageStack().get(0).imageOrientationY;
            double res = Point3D.dotProduct(Point3D.crossProduct(exref, eyref), Point3D.crossProduct(exfloat, eyfloat));
            publish("Inner product norms:");
            publish(String.valueOf(res));
        }
    }//GEN-LAST:event_jMenuItemInnerProdNormVectsActionPerformed

    private void jMenuItemImageDimensionsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemImageDimensionsActionPerformed
        if (csimodelRef != null && csimodelFloating != null) {
            double spxref = csimodelRef.getImageStack().get(0).pixelSpacingX;
            double spyref = csimodelRef.getImageStack().get(0).pixelSpacingY;
            double thickref = csimodelRef.getImageStack().get(0).sliceThickness;
            double spzref = csimodelRef.getImageStack().getSpacingBetweenSlices();
            String dimsref = csimodelRef.getImageStack().get(0).image.getWidth() + "x" + csimodelRef.getImageStack().get(0).image.getHeight() + "x" + csimodelRef.getImageStack().size();
            double spxfloat = csimodelFloating.getImageStack().get(0).pixelSpacingX;
            double spyfloat = csimodelFloating.getImageStack().get(0).pixelSpacingY;
            double thickfloat = csimodelFloating.getImageStack().get(0).sliceThickness;
            double spzfloat = csimodelFloating.getImageStack().getSpacingBetweenSlices();
            String dimsfloat = csimodelFloating.getImageStack().get(0).image.getWidth() + "x" + csimodelFloating.getImageStack().get(0).image.getHeight() + "x" + csimodelFloating.getImageStack().size();

            publish("Dimensions Reference Image:");
            publish("matrixdims\tspacingX\tspacingY\tspacingZ\tThickness\t");
            publish(dimsref + "\t" + spxref + "\t" + spyref + "\t" + spzref + "\t" + thickref);
            publish("Dimensions Floating Image:");
            publish("matrixdims\tspacingX\tspacingY\tspacingZ\tThickness\t");
            publish(dimsfloat + "\t" + spxfloat + "\t" + spyfloat + "\t" + spzfloat + "\t" + thickfloat);
        }
    }//GEN-LAST:event_jMenuItemImageDimensionsActionPerformed

    private void jMenuItemClearGridRefActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemClearGridRefActionPerformed
        if (csimodelRef != null) {
            csimodelRef.clearGrid();
            csimodelRef.setSpectraAxisVisible(false);
        }
    }//GEN-LAST:event_jMenuItemClearGridRefActionPerformed

    private void jMenuItemClearGridFloatingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemClearGridFloatingActionPerformed
        if (csimodelFloating != null) {
            csimodelFloating.clearGrid();
            csimodelFloating.setSpectraAxisVisible(false);
        }
    }//GEN-LAST:event_jMenuItemClearGridFloatingActionPerformed

    private void jMenuItemImageDimensions1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemImageDimensions1ActionPerformed
        publish("Reference File" + "\t" + "Floating File");
        publish(this.jTextFieldRef.getText() + "\t" + this.jTextFieldFloating.getText());
    }//GEN-LAST:event_jMenuItemImageDimensions1ActionPerformed

    private void jMenuItemTempActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemTempActionPerformed
        Point3D exref = csimodelRef.getImageStack().get(0).imageOrientationX;
        Point3D eyref = csimodelRef.getImageStack().get(0).imageOrientationY;
        Point3D exfloat = csimodelFloating.getImageStack().get(0).imageOrientationX;
        Point3D eyfloat = csimodelFloating.getImageStack().get(0).imageOrientationY;
        double res = Point3D.dotProduct(Point3D.crossProduct(exref, eyref), Point3D.crossProduct(exfloat, eyfloat));
        double spxref = csimodelRef.getImageStack().get(0).pixelSpacingX;
        double spyref = csimodelRef.getImageStack().get(0).pixelSpacingY;
        double thickref = csimodelRef.getImageStack().get(0).sliceThickness;
        double spzref = csimodelRef.getImageStack().getSpacingBetweenSlices();
        String dimsref = csimodelRef.getImageStack().get(0).image.getWidth() + "x" + csimodelRef.getImageStack().get(0).image.getHeight() + "x" + csimodelRef.getImageStack().size();
        double spxfloat = csimodelFloating.getImageStack().get(0).pixelSpacingX;
        double spyfloat = csimodelFloating.getImageStack().get(0).pixelSpacingY;
        double thickfloat = csimodelFloating.getImageStack().get(0).sliceThickness;
        double spzfloat = csimodelFloating.getImageStack().getSpacingBetweenSlices();
        String dimsfloat = csimodelFloating.getImageStack().get(0).image.getWidth() + "x" + csimodelFloating.getImageStack().get(0).image.getHeight() + "x" + csimodelFloating.getImageStack().size();

        publish(String.valueOf(res) + "\t" + dimsref + "\t" + spxref + "\t" + spyref + "\t" + spzref + "\t" + thickref + "\t" +
                dimsfloat + "\t" + spxfloat + "\t" + spyfloat + "\t" + spzfloat + "\t" + thickfloat + "\t" + "\t" + "\t" +
                this.jTextFieldRef.getText() + "\t" + this.jTextFieldFloating.getText());
    }//GEN-LAST:event_jMenuItemTempActionPerformed

    private void jCheckBoxMenuItemShowIntersectsMainActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItemShowIntersectsMainActionPerformed
        if (csimodelRef != null) {
            this.csimodelRef.showIntersectionsInMain(this.jCheckBoxMenuItemShowIntersectsMain.isSelected());
        }
        if (csimodelFloating != null) {
            this.csimodelFloating.showIntersectionsInMain(this.jCheckBoxMenuItemShowIntersectsMain.isSelected());
        }
        if (csimodelRes != null) {
            this.csimodelRes.showIntersectionsInMain(this.jCheckBoxMenuItemShowIntersectsMain.isSelected());
        }
    }//GEN-LAST:event_jCheckBoxMenuItemShowIntersectsMainActionPerformed

    private void jCheckBoxShowMapValuesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxShowMapValuesActionPerformed
        if (csimodelRef != null) {
            csimodelRef.setValuesVisible(this.jCheckBoxShowMapValues.isSelected());
        }
        if (csimodelFloating != null) {
            csimodelFloating.setValuesVisible(this.jCheckBoxShowMapValues.isSelected());
        }
        if (csimodelRes != null) {
            csimodelRes.setValuesVisible(this.jCheckBoxShowMapValues.isSelected());
        }
    }//GEN-LAST:event_jCheckBoxShowMapValuesActionPerformed

    private void jCheckBoxMenuItemViewSliceOrientationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItemViewSliceOrientationActionPerformed
        this.floatingPanel.setSpacialInfoVisible(jCheckBoxMenuItemViewSliceOrientation.isSelected());
        this.resPanel.setSpacialInfoVisible(jCheckBoxMenuItemViewSliceOrientation.isSelected());
        this.refPanel.setSpacialInfoVisible(jCheckBoxMenuItemViewSliceOrientation.isSelected());
    }//GEN-LAST:event_jCheckBoxMenuItemViewSliceOrientationActionPerformed

    private void jCheckBoxMenuItemShowPatientNameActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItemShowPatientNameActionPerformed
        if (csimodelRef != null) {
            this.csimodelRef.setPatientNameVisible(this.jCheckBoxMenuItemShowPatientName.isSelected());
        }
        if (csimodelFloating != null) {
            this.csimodelFloating.setPatientNameVisible(this.jCheckBoxMenuItemShowPatientName.isSelected());
        }
        if (csimodelRes != null) {
            this.csimodelRes.setPatientNameVisible(this.jCheckBoxMenuItemShowPatientName.isSelected());
        }
    }//GEN-LAST:event_jCheckBoxMenuItemShowPatientNameActionPerformed

    private void jCheckBoxMenuItemShowSeriesInfoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItemShowSeriesInfoActionPerformed
        if (csimodelRef != null) {
            this.csimodelRef.setSeriesInfoVisible(this.jCheckBoxMenuItemShowSeriesInfo.isSelected());
        }
        if (csimodelFloating != null) {
            this.csimodelFloating.setSeriesInfoVisible(this.jCheckBoxMenuItemShowSeriesInfo.isSelected());
        }
        if (csimodelRes != null) {
            this.csimodelRes.setSeriesInfoVisible(this.jCheckBoxMenuItemShowSeriesInfo.isSelected());
        }
    }//GEN-LAST:event_jCheckBoxMenuItemShowSeriesInfoActionPerformed

    private void processFile(String selectedFile) {
        setWaitLayerActive(true);
        if (this.jRadioButtonRef.isSelected()) {
            FileReaderWorker fileworker = new FileReaderWorker(this, selectedFile, dicomManager, csimodelRef);
            fileworker.execute();
        } else if (this.jRadioButtonFloating.isSelected()) {
            FileReaderWorker fileworker = new FileReaderWorker(this, selectedFile, dicomManager, csimodelFloating);
            fileworker.execute();
        }
    }

    @Override
    public void setWaitLayerActive(boolean bool) {
//        if (bool) {
//            if (!refPanel.isAncestorOf(waitlayer)) {
//                WaitLayerUI waitlayerUI = new WaitLayerUI();
//                JPanel panel = new JPanel();
//                waitlayer = new JLayer<>(panel, waitlayerUI);
//                pnlRef.add(waitlayer, java.awt.BorderLayout.CENTER);
//                waitlayerUI.start();
//            }
//            jSliderRef.setVisible(false);
//            jSliderRef.setEnabled(false);
//            refPanel.setEnabled(false);
//
//
//        } else {
//            if (pnlRef.isAncestorOf(waitlayer)) {
//                pnlRef.remove(waitlayer);
//            }
//            jSliderRef.setVisible(true);
//            jSliderRef.setEnabled(true);
//            refPanel.setEnabled(true);
//        }
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(GUIRegistration.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(GUIRegistration.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(GUIRegistration.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(GUIRegistration.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                GUIRegistration gui = new GUIRegistration();
                gui.setVisible(true);
                gui.setTitle("Registration Tool");
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JButton jButtonAladinAffineFromFile;
    private javax.swing.JButton jButtonF3DSetAffineFile;
    private javax.swing.JButton jButtonF3DSetControlPointGridFile;
    private javax.swing.JButton jButtonLoadDisplacements;
    private javax.swing.JButton jButtonLoadFloatting;
    private javax.swing.JButton jButtonLoadReference;
    private javax.swing.JButton jButtonRun;
    private javax.swing.JCheckBox jCheckBoxAladinActive;
    private javax.swing.JCheckBox jCheckBoxAladinAffineDirect;
    private javax.swing.JCheckBox jCheckBoxAladinAffineFromFile;
    private javax.swing.JCheckBox jCheckBoxAladinInitTranslHeader;
    private javax.swing.JCheckBox jCheckBoxAladinRigidOnly;
    private javax.swing.JCheckBox jCheckBoxAladinSym;
    private javax.swing.JCheckBox jCheckBoxF3DActive;
    private javax.swing.JCheckBox jCheckBoxF3DAffineFromFile;
    private javax.swing.JCheckBox jCheckBoxF3DApplyControlPointGrid;
    private javax.swing.JCheckBox jCheckBoxF3DApproxJLValOnlyControlP;
    private javax.swing.JCheckBox jCheckBoxF3DDiffeomorphic;
    private javax.swing.JCheckBox jCheckBoxF3DLowThreshFloating;
    private javax.swing.JCheckBox jCheckBoxF3DLowThreshRef;
    private javax.swing.JCheckBox jCheckBoxF3DPaddingVal;
    private javax.swing.JCheckBox jCheckBoxF3DPyramidal;
    private javax.swing.JCheckBox jCheckBoxF3DSmoothGrad;
    private javax.swing.JCheckBox jCheckBoxF3DSym;
    private javax.swing.JCheckBox jCheckBoxF3DUpThreshFloating;
    private javax.swing.JCheckBox jCheckBoxF3DUpThreshRef;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItemShowIntersectsMain;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItemShowPatientName;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItemShowSeriesInfo;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItemViewSliceOrientation;
    private javax.swing.JCheckBoxMenuItem jCheckBoxShowMapValues;
    private javax.swing.JComboBox jComboBoxF3DOptimization;
    private javax.swing.JComboBox jComboBoxF3DSimilarityMeasure;
    private javax.swing.JComboBox jComboBoxResultMode;
    private javax.swing.JFormattedTextField jFormattedTextFieldAladinMaxIter;
    private javax.swing.JFormattedTextField jFormattedTextFieldAladinNrFirstLevels;
    private javax.swing.JFormattedTextField jFormattedTextFieldAladinNrLevels;
    private javax.swing.JFormattedTextField jFormattedTextFieldAladinPercBlock;
    private javax.swing.JFormattedTextField jFormattedTextFieldAladinPercInlierLTS;
    private javax.swing.JFormattedTextField jFormattedTextFieldAladinSigmaFloating;
    private javax.swing.JFormattedTextField jFormattedTextFieldAladinSigmaRef;
    private javax.swing.JFormattedTextField jFormattedTextFieldF3DBendingEnergy;
    private javax.swing.JFormattedTextField jFormattedTextFieldF3DDiffeoCompStep;
    private javax.swing.JFormattedTextField jFormattedTextFieldF3DL2NormDispPenalty;
    private javax.swing.JFormattedTextField jFormattedTextFieldF3DLinElastPenalty1;
    private javax.swing.JFormattedTextField jFormattedTextFieldF3DLinElastPenalty2;
    private javax.swing.JFormattedTextField jFormattedTextFieldF3DLogJacob;
    private javax.swing.JFormattedTextField jFormattedTextFieldF3DLowThreshFloating;
    private javax.swing.JFormattedTextField jFormattedTextFieldF3DLowThreshRef;
    private javax.swing.JFormattedTextField jFormattedTextFieldF3DMaxIterLevel;
    private javax.swing.JFormattedTextField jFormattedTextFieldF3DNrBinsFloating;
    private javax.swing.JFormattedTextField jFormattedTextFieldF3DNrBinsRef;
    private javax.swing.JFormattedTextField jFormattedTextFieldF3DNrFirstLevels;
    private javax.swing.JFormattedTextField jFormattedTextFieldF3DNrLevels;
    private javax.swing.JFormattedTextField jFormattedTextFieldF3DPaddingVal;
    private javax.swing.JFormattedTextField jFormattedTextFieldF3DSigmaFloating;
    private javax.swing.JFormattedTextField jFormattedTextFieldF3DSigmaRef;
    private javax.swing.JFormattedTextField jFormattedTextFieldF3DSmoothGrad;
    private javax.swing.JFormattedTextField jFormattedTextFieldF3DSymInvPenalty;
    private javax.swing.JFormattedTextField jFormattedTextFieldF3DUpThreshFloating;
    private javax.swing.JFormattedTextField jFormattedTextFieldF3DUpThreshRef;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel23;
    private javax.swing.JLabel jLabel24;
    private javax.swing.JLabel jLabel25;
    private javax.swing.JLabel jLabel26;
    private javax.swing.JLabel jLabel27;
    private javax.swing.JLabel jLabel28;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenu jMenuGrid;
    private javax.swing.JMenu jMenuImage;
    private javax.swing.JMenuItem jMenuItemClearGridFloating;
    private javax.swing.JMenuItem jMenuItemClearGridRef;
    private javax.swing.JMenuItem jMenuItemImageDimensions;
    private javax.swing.JMenuItem jMenuItemImageDimensions1;
    private javax.swing.JMenuItem jMenuItemImageInfo;
    private javax.swing.JMenuItem jMenuItemImageInfo1;
    private javax.swing.JMenuItem jMenuItemInnerProdNormVects;
    private javax.swing.JMenuItem jMenuItemTemp;
    private javax.swing.JMenu jMenuView;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel13;
    private javax.swing.JPanel jPanel15;
    private javax.swing.JPanel jPanel16;
    private javax.swing.JPanel jPanel17;
    private javax.swing.JPanel jPanel18;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JPanel jPanelF3DOptionsIntensity;
    private javax.swing.JPanel jPanelF3DOptionsObjectiveFunc;
    private javax.swing.JPanel jPanelF3DOptionsOther;
    private javax.swing.JPanel jPanelFiller1;
    private javax.swing.JPanel jPanelFiller2;
    private javax.swing.JPanel jPanelOptionsAladin;
    private javax.swing.JPanel jPanelOptionsF3D;
    private javax.swing.JPanel jPanelOptionsF3DGeneral;
    private javax.swing.JPanel jPanelOptionsTabbed;
    private javax.swing.JRadioButton jRadioButtonFloating;
    private javax.swing.JRadioButton jRadioButtonRef;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JSlider jSliderFloating;
    private javax.swing.JSlider jSliderRef;
    private javax.swing.JSlider jSliderRes;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JSplitPane jSplitPane2;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTabbedPane jTabbedPane2;
    private javax.swing.JTabbedPane jTabbedPane3;
    private javax.swing.JTable jTableResults;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextField jTextFieldFloating;
    private javax.swing.JTextField jTextFieldRef;
    private javax.swing.JToggleButton jToggleButtonPinSliders;
    private javax.swing.JPanel pnlFileManager;
    private javax.swing.JPanel pnlFloating;
    private javax.swing.JPanel pnlMain;
    private javax.swing.JPanel pnlRef;
    private javax.swing.JPanel pnlRes;
    // End of variables declaration//GEN-END:variables

    @Override
    public void setGlobalModel(GlobalModel csimodelnew) {
        ImageViewerPanel currentPanel = new ImageViewerPanel();
        JSlider currentSlider = new JSlider();
        if (this.jRadioButtonRef.isSelected()) {
            currentPanel = this.refPanel;
            currentSlider = this.jSliderRef;
        } else if (this.jRadioButtonFloating.isSelected()) {
            currentPanel = this.floatingPanel;
            currentSlider = this.jSliderFloating;
        }

        csimodelnew.setImageViewer(currentPanel);
        csimodelnew.setSliceSlider(currentSlider);
        csimodelnew.removeLocalizers();
        csimodelnew.setTextArea(jTextArea1);
        if (csimodelnew.getImageStackSize() == 0) {
            csimodelnew.setBlankImageStack();
        } else {
            currentSlider.setMinimum(0);
            currentSlider.setMaximum(csimodelnew.getImageStackSize() - 1);
            csimodelnew.showMiddleSliceWithIntersection();
            currentPanel.autoWindowing();
        }

        csimodelnew.updateViewImagePanels();
        if (this.jRadioButtonRef.isSelected()) {
            csimodelRef = csimodelnew;
            if (csimodelFloating != null) {
                GlobalModel model = csimodelRef.createCombinedModel(csimodelFloating, this.jComboBoxResultMode.getSelectedIndex());
                if (model != null) {
                    this.setResModel(model);
                }
            }
        } else if (this.jRadioButtonFloating.isSelected()) {
            csimodelFloating = csimodelnew;
            if (csimodelRef != null) {
                GlobalModel model = csimodelRef.createCombinedModel(csimodelFloating, this.jComboBoxResultMode.getSelectedIndex());
                if (model != null) {
                    this.setResModel(model);
                }
            }
        }
    }

    protected void setRefModel(GlobalModel model) {
        if (model != null) {
            csimodelRef = model;
            csimodelRef.setTextArea(jTextArea1);
            csimodelRef.setImageViewer(this.refPanel);
            csimodelRef.setSliceSlider(jSliderRef);
            if (csimodelRef.getImageStackSize() == 0) {
                csimodelRef.setBlankImageStack();
            } else {
                jSliderRef.setMinimum(0);
                jSliderRef.setMaximum(csimodelRef.getImageStackSize() - 1);
                csimodelRef.showMiddleSliceWithIntersection();
                csimodelRef.autoWindowing();
            }
            csimodelRef.updateViewImagePanels();
        }
    }

    protected void setResModel(GlobalModel model) {
        if (model != null) {
            csimodelRes = model;
            csimodelRes.setTextArea(jTextArea1);
            csimodelRes.setImageViewer(this.resPanel);
            csimodelRes.setSliceSlider(jSliderRes);
            if (csimodelRes.getImageStackSize() == 0) {
                csimodelRes.setBlankImageStack();
            } else {
                jSliderRes.setMinimum(0);
                jSliderRes.setMaximum(csimodelRes.getImageStackSize() - 1);
                csimodelRes.showMiddleSliceWithIntersection();
                csimodelRes.autoWindowing();
            }
            csimodelRes.updateViewImagePanels();
        }
    }

    protected void setFloatingModel(GlobalModel model) {
        csimodelFloating = model;
        csimodelFloating.setTextArea(jTextArea1);
        csimodelFloating.setImageViewer(this.floatingPanel);
        csimodelFloating.setSliceSlider(jSliderFloating);
        if (csimodelFloating.getImageStackSize() == 0) {
            csimodelFloating.setBlankImageStack();
        } else {
            jSliderFloating.setMinimum(0);
            jSliderFloating.setMaximum(csimodelFloating.getImageStackSize() - 1);
            csimodelFloating.showMiddleSliceWithIntersection();
            csimodelFloating.autoWindowing();
        }
        csimodelFloating.updateViewImagePanels();
    }

    @Override
    public void actionPerformed(ActionEvent ae) {
        Object sender = ae.getSource();

        if (sender == this.dicomManager && ae.getActionCommand().matches(DicomFileSelectionControl.TREE_ENTRY_DBL_CLICKED_CMD)) {

            SwingWorker worker = new SwingWorker<Integer, Void>() {
                @Override
                public Integer doInBackground() {
                    final LinkedList<String> fileReferences = dicomseltab.getSelectedSeriesFileReferences();
                    if (fileReferences != null) {
                        DicomImageSeriesData dicomData = new DicomImageSeriesData(fileReferences);
                        dicomData.orderBySlicePosition();

                        processFile(fileReferences.getFirst().toString());
                        if (jRadioButtonRef.isSelected()) {
                            File fileaux = new File(fileReferences.getFirst());
                            jTextFieldRef.setText(fileaux.getParent().toString());
                        } else if (jRadioButtonFloating.isSelected()) {
                            File fileaux = new File(fileReferences.getFirst());
                            jTextFieldFloating.setText(fileaux.getParent().toString());
                        }
                    }
                    return 1;
                }

                @Override
                public void done() {
                }
            };
            worker.execute();
        }
    }

    @Override
    public void registrationFinished(Object obj) {
        RegistrationWorker worker = (RegistrationWorker) obj;
//        csimodelFloating.updateImageStack(NiftiHandler.getRastersFromNifti(file));
        csimodelFloating.setImageStack(NiftiHandler.getImagesFromNifti(worker.fileRes));
        if (csimodelFloating.getImageStackSize() == 0) {
            csimodelFloating.setBlankImageStack();
        } else {
            jSliderFloating.setMinimum(0);
            jSliderFloating.setMaximum(csimodelFloating.getImageStackSize() - 1);
            csimodelFloating.showMiddleSliceWithIntersection();
            csimodelFloating.autoWindowing();
        }
        if (worker.mode == RegistrationWorker.Mode.RIGID || worker.mode == RegistrationWorker.Mode.BOTH) {
            csimodelFloating.setAffineTransform(worker.fileAff, worker.mode != RegistrationWorker.Mode.BOTH);
        }
        if (worker.mode == RegistrationWorker.Mode.NONRIGID || worker.mode == RegistrationWorker.Mode.BOTH) {
            csimodelFloating.setDisplacementField(worker.fileDisp, true);
        }

        csimodelFloating.updateViewImagePanels();

//        this.setResModel(csimodelRef.createCombinedModel(NiftiHandler.getRastersFromNifti(file), this.jComboBoxResultMode.getSelectedIndex()));
        GlobalModel model = csimodelRef.createCombinedModel(csimodelFloating, this.jComboBoxResultMode.getSelectedIndex());
        if (model != null) {
            this.setResModel(model);
        }

        SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss");
        Date now = new Date();
        long duration = now.getTime() - worker.start.getTime();
        int hours = (int) ((double) duration / 3600000d);
        duration -= hours * 3600000;
        int mins = (int) ((double) duration / 60000d);
        duration -= mins * 60000;
        int secs = (int) ((double) duration / 1000d);
        String runTime = hours + ":" + mins + ":" + secs;
        double[] res = getSimilarityMeasures(this.csimodelRef.getImageStack(), this.csimodelFloating.getImageStack(), 128, 0.01);
        String aladAffInput = "-";
        if (worker.optAladinAffFromFile) {
            aladAffInput = worker.optAladinAffInputFile;
        }
        String f3dAffInput = "-";
        if (worker.optF3DAffFromFile) {
            f3dAffInput = worker.optF3DAffInputFile;
        }
        String f3dCPGfile = "-";
        if (worker.optF3DCPGFromFile) {
            f3dCPGfile = worker.optF3DCPGInputFile;
        }
        String f3dRefLThreh = "-";
        if (worker.optF3DApplyThresholdRefLow) {
            f3dRefLThreh = String.valueOf(worker.optF3DThresholdRefLow);
        }
        String f3dRefHThreh = "-";
        if (worker.optF3DApplyThresholdRefHigh) {
            f3dRefHThreh = String.valueOf(worker.optF3DThresholdRefHigh);
        }
        String f3dFloatLThreh = "-";
        if (worker.optF3DApplyThresholdFloatingLow) {
            f3dFloatLThreh = String.valueOf(worker.optF3DThresholdFloatingLow);
        }
        String f3dFloatHThreh = "-";
        if (worker.optF3DApplyThresholdFloatingHigh) {
            f3dFloatHThreh = String.valueOf(worker.optF3DThresholdFloatingHigh);
        }
        String f3dOptim = "Grad. Ascent";
        if (worker.optF3DUseConjugateGradOptim) {
            f3dOptim = "Conjug. Grad.";
        }
        String f3dPadVal = String.valueOf(worker.optF3DPaddingVal);

        resultsTabModel.addRow(new Object[]{
            sdf.format(worker.start),
            runTime,
            worker.fileRef,
            worker.fileFloating,
            worker.fileRes,
            worker.fileAff,
            worker.fileCpp,
            valuesBefore[0], res[0],
            valuesBefore[1], res[1],
            valuesBefore[2], res[2],
            valuesBefore[3], res[3],
            worker.mode,
            worker.optAladinSym,
            worker.optAladinRigOnly,
            worker.optAladinAffDirect,
            aladAffInput,
            worker.optAladinNrIterations,
            worker.optAladinNrLevels,
            worker.optAladinFirstLevels,
            worker.optAladinInitTranslWithNiftiHeader,
            worker.optAladinPercentBlock,
            worker.optAladinPercentInlierLTS,
            worker.optAladinSigmaRef,
            worker.optAladinSigmaFloating,
            f3dCPGfile,
            f3dAffInput,
            worker.optF3DSigmaRef,
            worker.optF3DSigmaFloating,
            worker.optF3DNrBinsRef,
            worker.optF3DNrBinsFloating,
            f3dRefLThreh,
            f3dRefHThreh,
            f3dFloatLThreh,
            f3dFloatHThreh,
            worker.optF3DFinalGridSpacingX,
            worker.optF3DFinalGridSpacingY,
            worker.optF3DFinalGridSpacingZ,
            worker.optF3DBendingEnergyPenalty,
            worker.optF3DLinearElasticityPenalty1,
            worker.optF3DLinearElasticityPenalty2,
            worker.optF3DL2NormDisplacementPenalty,
            worker.optF3DLogJacobDeterminantPenalty,
            worker.optF3DApproxJLOnlyAtControlPoint,
            f3dOptim,
            worker.optF3DSimilarityMeasure,
            worker.optF3DMaxIterLevel,
            worker.optF3DNrLevels,
            worker.optF3DFirstLevels,
            worker.optF3DPyramidal,
            worker.optF3DSym,
            worker.optF3DSymInvConsistPenalty,
            worker.optF3DVel,
            worker.optF3DVelNrComposStep,
            worker.optF3DSmoothGrad,
            f3dPadVal
        });

        jTextFieldFloating.setText(worker.fileRes);

    }

    @Override
    public void publish(String text) {
        jTextArea1.setCaretPosition(jTextArea1.getDocument().getLength());
        SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss.SSS");
        Date now = new Date();
        String strDate = sdf.format(now);
        jTextArea1.append("#" + strDate + ">> " + text + "\n");
    }

    @Override
    public void print(String txt) {
        publish(txt);
    }

    @Override
    public void setCSIReference(GlobalModel csimodelref) {
    }

    @Override
    public void clearResultsData() {
    }
}
