/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.settings;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Properties;
import org.spectrim.main.SpectrImClinicalQMRSBoot;

/**
 *
 * @author Giezi
 */
public class ReportSettings 
{
    SpectrImClinicalQMRSBoot instance = SpectrImClinicalQMRSBoot.getInstance( );
    private final String spectrimRootDir = instance.getProperty(  SpectrImClinicalQMRSBoot.SPECTRIM_CLINICAL_QMRS_BASE_PATH ); // System.getProperty("user.home")+File.separator+".SpectrIm";
    private static  ReportSettings theInstance = null;
    private File prstsPath;
    private File imgOutptFolder;
    private Properties properties;

    private ReportSettings() {
        loadParams();
    }
    
    public static ReportSettings getInstance( )
    {
        if ( theInstance == null )
        {
            theInstance = new ReportSettings( );
        }
        return theInstance;
    }
    
    private void loadParams()
    {
        // Create folder if not existent
        new File(spectrimRootDir+File.separator+"settings").mkdirs();
        new File(spectrimRootDir+File.separator+"ReportPrst").mkdirs();
        properties = new Properties();
        InputStream is = null;

        // First try loading from the current directory
        try {
            File f = new File(spectrimRootDir+File.separator+"settings"+File.separator+"reportSettings.properties");
            is = new FileInputStream(f);
        } catch (Exception e) {}

        try {
            if (is == null) {
                // Try loading from classpath
                is = getClass().getResourceAsStream("reportSettings.properties");
            }

            // Try loading properties from the file (if found)
            properties.load(is);
        } catch (Exception e) {
        }
        
        prstsPath = new File(properties.getProperty("cstmReportPrstFolder",spectrimRootDir+File.separator+"ReportPrst"));
        imgOutptFolder = new File(properties.getProperty("reportOutputFolder", System.getProperty("user.home")));
    }
    
    public void saveProperties(){
        properties.setProperty("cstmReportPrstFolder", prstsPath.toString());
        properties.setProperty("reportOutputFolder", imgOutptFolder.toString());
        try {
            File f = new File(spectrimRootDir+File.separator+"settings"+File.separator+"reportSettings.properties");
            OutputStream out = new FileOutputStream(f);
            properties.store(out, "SpectrIm Report properties");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    //<editor-fold defaultstate="collapsed" desc="Getters">
    public File getPrstsPath() {
        return prstsPath;
    }
    
    public File getImgOutputFolder(){
        return imgOutptFolder;
    }
    //</editor-fold>

    //<editor-fold defaultstate="collapsed" desc="Setters">
    public void setPrstsPath(File prstsPath) {
        this.prstsPath = prstsPath;
    }

    public void setImgOutptFolder(File imgOutptFolder) {
        this.imgOutptFolder = imgOutptFolder;
    }
    //</editor-fold>
    
}
