/*
 * File: $Id: ControlCurve.java,v 1.1.1.1 2006/04/19 09:38:50 hans Exp $
 * History
 * Date: 14.03.2006  Authors: Hans Slotboom  Changes:
 *
 * Copyright (C) 2003 by
 * 
 * Inselspital - Department of Neuroradiology
 * CH 3010 Bern Switzerland
 */


// lambert@cse.unsw.edu.au
// If you want to learn more about the mathematics behind all of this, 
// I recommend An Introduction to Splines for Use in Computer Graphics and 
// Geometric Modelling by Bartels, Beatty and Barsky published by Morgan Kaufman, Los Altos, CA, 1987. 


/** 
 * This class represents a curve defined by a sequence of control points 
 */

package org.spectrim.tdfdfit;

import java.awt.geom.Point2D;
import java.awt.Polygon;

import java.util.Vector;

public class ControlCurve 
{
    /**
     * Control curve.
     */
    public ControlCurve( ) 
    {
        m_polygon = new Vector<Point2D>( );
    }

    /** 
     * Add a control point, return index of new control point. 
     * @param x
     * @param y
     * @return 
     */
    public int addPoint( float x, float y ) 
    {
        m_polygon.add( new Point2D.Float( x, y )  );
        
        return ( m_polygon.size( ) - 1 );
    }
    
    /** 
     * Removes a control point at location "selection". 
     * @param selection
     */
    public void removePoint( int selection ) 
    {    
        m_polygon.remove( selection );   
    }
    
    /** 
     * Remove all control points  
     */
    public void removeAllPoints( ) 
    {    
        m_polygon.clear( );   
    }
    
    
    /**
     * Converts this object to a string.
     * @return 
     */
    @Override
    public String toString( ) 
    {
        StringBuilder result = new StringBuilder( );
        for ( int i = 0; i < m_polygon.size(); i++ ) 
        {
            Point2D.Float pnt = (Point2D.Float)m_polygon.get(i);
            result.append(" ").append((float)pnt.getX( )).append(" ").append((float)pnt.getY( ));
        }
        return result.toString( );
    }
    
    // Attributes
    protected Vector<Point2D> m_polygon;
    protected Polygon pts;
}