/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.tdfdfit.mmbaseline;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import javax.swing.JFrame;
import org.spectrim.tdfdfit.MRSignalProperties;

/**
 * A GUI for fast general baseline model definition.
 * @author johan
 */
public class GeneralBaselineSettingsFrame extends javax.swing.JFrame {

    /**
     * Creates new form GeneralBaselineSettingsFrame
     */
    public GeneralBaselineSettingsFrame( ) 
    {
        initComponents( );
        setDefaultCloseOperation( JFrame.DISPOSE_ON_CLOSE );
        
        MRSignalProperties props = MRSignalProperties.getInstance( );
        // Adapt the internal offset to tdfdfit internal offset representation (Hz)
        float ppmRange  =  props.getAcquistitionBandwidth( ) / ( props.getResonanceFrequency( ) / 1000000f );    
        float ppmCenter =  props.getPPMValueInCenterOfSpectrum( );
        this.m_maximumPPMLabel.setText( "" + ( ppmCenter + ppmRange/2f) );
        this.m_minimumPPMLabel.setText( "" + ( ppmCenter - ppmRange/2f) );
        setVisible( true );
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        m_offsetButtonGroup = new javax.swing.ButtonGroup();
        m_phaseButtonGroup = new javax.swing.ButtonGroup();
        m_lorentzianWidthButtonGroup = new javax.swing.ButtonGroup();
        m_gaussianWidthButtonGroup = new javax.swing.ButtonGroup();
        m_baselineModelTypeButtonGroup = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        m_offsetsAbsolutedFixed = new javax.swing.JRadioButton();
        m_oneCommonlyVaryingOffsetRadioButton = new javax.swing.JRadioButton();
        m_phasesAbsolutelyFixedRadioButton = new javax.swing.JRadioButton();
        m_oneCommonlyVaryingPhaseRadioButton = new javax.swing.JRadioButton();
        m_lorentzianWidthAbsolutelyFixedRadioButton = new javax.swing.JRadioButton();
        m_oneCommonlyVaryingLorentzianWIdthRadioButton = new javax.swing.JRadioButton();
        m_gaussianWidthAbsolutelyFixedRadioButton = new javax.swing.JRadioButton();
        m_oneCommonlyVaryingGaussianWidthRadioButton = new javax.swing.JRadioButton();
        jPanel2 = new javax.swing.JPanel();
        m_generateGeneralBaselineButton = new javax.swing.JButton();
        m_cancelButton = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        m_numberOfComponentsTextField = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        m_startingAmplitudesTextField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        m_startingPhaseTextField = new javax.swing.JTextField();
        m_startingOffsetDifferencesTextField = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        m_startingLorentzianWidthTextField = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        m_startingGaussianWidthTextField = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        m_minimumPPMLabel = new javax.swing.JLabel();
        m_maximumPPMLabel = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        m_freeBaselineModelRadioButton = new javax.swing.JRadioButton();
        m_veryRigidDefaultBaselineModelRadioButton = new javax.swing.JRadioButton();
        m_rigidDefaultBaselineModelRadioButton = new javax.swing.JRadioButton();
        m_flexibleDefaultBaselineModelRadioButton = new javax.swing.JRadioButton();
        m_veryFlexibleDefaultBaselineModelRadioButton = new javax.swing.JRadioButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Baseline parameter group behaviour"));

        m_offsetButtonGroup.add(m_offsetsAbsolutedFixed);
        m_offsetsAbsolutedFixed.setSelected(true);
        m_offsetsAbsolutedFixed.setText("Offsets absolutely fixed");

        m_offsetButtonGroup.add(m_oneCommonlyVaryingOffsetRadioButton);
        m_oneCommonlyVaryingOffsetRadioButton.setText("One commonly varying offset variable");

        m_phaseButtonGroup.add(m_phasesAbsolutelyFixedRadioButton);
        m_phasesAbsolutelyFixedRadioButton.setSelected(true);
        m_phasesAbsolutelyFixedRadioButton.setText("Phases absolutely fixed");

        m_phaseButtonGroup.add(m_oneCommonlyVaryingPhaseRadioButton);
        m_oneCommonlyVaryingPhaseRadioButton.setText("One commonly varying phase variable");

        m_lorentzianWidthButtonGroup.add(m_lorentzianWidthAbsolutelyFixedRadioButton);
        m_lorentzianWidthAbsolutelyFixedRadioButton.setSelected(true);
        m_lorentzianWidthAbsolutelyFixedRadioButton.setText("Lorentzian width absolutely fixed");
        m_lorentzianWidthAbsolutelyFixedRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_lorentzianWidthAbsolutelyFixedRadioButtonActionPerformed(evt);
            }
        });

        m_lorentzianWidthButtonGroup.add(m_oneCommonlyVaryingLorentzianWIdthRadioButton);
        m_oneCommonlyVaryingLorentzianWIdthRadioButton.setText("One commonly varying Lorentzian width varying variable");

        m_gaussianWidthButtonGroup.add(m_gaussianWidthAbsolutelyFixedRadioButton);
        m_gaussianWidthAbsolutelyFixedRadioButton.setSelected(true);
        m_gaussianWidthAbsolutelyFixedRadioButton.setText("Gaussian width absolutely fixed");
        m_gaussianWidthAbsolutelyFixedRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_gaussianWidthAbsolutelyFixedRadioButtonActionPerformed(evt);
            }
        });

        m_gaussianWidthButtonGroup.add(m_oneCommonlyVaryingGaussianWidthRadioButton);
        m_oneCommonlyVaryingGaussianWidthRadioButton.setText("One commonly varying Gaussian width varying variable");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(m_offsetsAbsolutedFixed)
                            .addComponent(m_phasesAbsolutelyFixedRadioButton))
                        .addGap(101, 101, 101)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(m_oneCommonlyVaryingPhaseRadioButton)
                            .addComponent(m_oneCommonlyVaryingOffsetRadioButton)))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(m_lorentzianWidthAbsolutelyFixedRadioButton)
                            .addComponent(m_gaussianWidthAbsolutelyFixedRadioButton))
                        .addGap(47, 47, 47)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(m_oneCommonlyVaryingGaussianWidthRadioButton)
                            .addComponent(m_oneCommonlyVaryingLorentzianWIdthRadioButton))))
                .addGap(17, 17, 17))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_offsetsAbsolutedFixed)
                    .addComponent(m_oneCommonlyVaryingOffsetRadioButton))
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_phasesAbsolutelyFixedRadioButton)
                    .addComponent(m_oneCommonlyVaryingPhaseRadioButton))
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_lorentzianWidthAbsolutelyFixedRadioButton)
                    .addComponent(m_oneCommonlyVaryingLorentzianWIdthRadioButton))
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_gaussianWidthAbsolutelyFixedRadioButton)
                    .addComponent(m_oneCommonlyVaryingGaussianWidthRadioButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        m_generateGeneralBaselineButton.setText("Ok, generate a general baseline with these characteristics");
        m_generateGeneralBaselineButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_generateGeneralBaselineButtonActionPerformed(evt);
            }
        });

        m_cancelButton.setText("Cancel, do not add a general baseline");
        m_cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_cancelButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(m_cancelButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(m_generateGeneralBaselineButton)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_generateGeneralBaselineButton)
                    .addComponent(m_cancelButton))
                .addContainerGap())
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("General numeriic baseline properties"));

        jLabel1.setText("Number of baseline components");

        m_numberOfComponentsTextField.setText("10");

        jLabel2.setText("General starting amplitude ");

        m_startingAmplitudesTextField.setText("0");

        jLabel3.setText("General starting phase  ");

        m_startingPhaseTextField.setText("0");

        m_startingOffsetDifferencesTextField.setText("0");

        jLabel4.setText("General offset differences  ");

        jLabel5.setText("General Lorentzian parameter ");

        m_startingLorentzianWidthTextField.setText("100");

        jLabel6.setText("General Gaussian parameter");

        m_startingGaussianWidthTextField.setText("0");

        jLabel7.setText("Minimum spectrum range (ppm) ");

        jLabel8.setText("Maximum spectrum range (ppm) ");

        m_minimumPPMLabel.setText("-3");

        m_maximumPPMLabel.setText("10");

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGap(43, 43, 43)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addComponent(jLabel2)
                    .addComponent(jLabel3)
                    .addComponent(jLabel4)
                    .addComponent(jLabel5)
                    .addComponent(jLabel6)
                    .addComponent(jLabel7)
                    .addComponent(jLabel8))
                .addGap(57, 57, 57)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(m_maximumPPMLabel)
                    .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addComponent(m_startingGaussianWidthTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 76, Short.MAX_VALUE)
                        .addComponent(m_startingLorentzianWidthTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 76, Short.MAX_VALUE)
                        .addComponent(m_startingOffsetDifferencesTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 76, Short.MAX_VALUE)
                        .addComponent(m_startingPhaseTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 76, Short.MAX_VALUE)
                        .addComponent(m_startingAmplitudesTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 76, Short.MAX_VALUE)
                        .addComponent(m_numberOfComponentsTextField)
                        .addComponent(m_minimumPPMLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                .addContainerGap(35, Short.MAX_VALUE)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel7)
                    .addComponent(m_minimumPPMLabel))
                .addGap(18, 18, 18)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel8)
                    .addComponent(m_maximumPPMLabel))
                .addGap(18, 18, 18)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(m_numberOfComponentsTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(m_startingAmplitudesTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(m_startingPhaseTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(m_startingOffsetDifferencesTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(m_startingLorentzianWidthTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(m_startingGaussianWidthTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(37, 37, 37))
        );

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder("Quick model presets"));

        m_baselineModelTypeButtonGroup.add(m_freeBaselineModelRadioButton);
        m_freeBaselineModelRadioButton.setSelected(true);
        m_freeBaselineModelRadioButton.setText("Free  model");

        m_baselineModelTypeButtonGroup.add(m_veryRigidDefaultBaselineModelRadioButton);
        m_veryRigidDefaultBaselineModelRadioButton.setText("Very rigid");

        m_baselineModelTypeButtonGroup.add(m_rigidDefaultBaselineModelRadioButton);
        m_rigidDefaultBaselineModelRadioButton.setText("Rigid");

        m_baselineModelTypeButtonGroup.add(m_flexibleDefaultBaselineModelRadioButton);
        m_flexibleDefaultBaselineModelRadioButton.setText("Flexilble");

        m_baselineModelTypeButtonGroup.add(m_veryFlexibleDefaultBaselineModelRadioButton);
        m_veryFlexibleDefaultBaselineModelRadioButton.setText("Very flexible");

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addGap(24, 24, 24)
                .addComponent(m_freeBaselineModelRadioButton)
                .addGap(46, 46, 46)
                .addComponent(m_veryRigidDefaultBaselineModelRadioButton, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 54, Short.MAX_VALUE)
                .addComponent(m_rigidDefaultBaselineModelRadioButton, javax.swing.GroupLayout.PREFERRED_SIZE, 82, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(40, 40, 40)
                .addComponent(m_flexibleDefaultBaselineModelRadioButton, javax.swing.GroupLayout.PREFERRED_SIZE, 87, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(47, 47, 47)
                .addComponent(m_veryFlexibleDefaultBaselineModelRadioButton, javax.swing.GroupLayout.PREFERRED_SIZE, 111, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(28, 28, 28))
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_freeBaselineModelRadioButton)
                    .addComponent(m_veryRigidDefaultBaselineModelRadioButton)
                    .addComponent(m_rigidDefaultBaselineModelRadioButton)
                    .addComponent(m_flexibleDefaultBaselineModelRadioButton)
                    .addComponent(m_veryFlexibleDefaultBaselineModelRadioButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void m_lorentzianWidthAbsolutelyFixedRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_lorentzianWidthAbsolutelyFixedRadioButtonActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_m_lorentzianWidthAbsolutelyFixedRadioButtonActionPerformed

    private void m_gaussianWidthAbsolutelyFixedRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_gaussianWidthAbsolutelyFixedRadioButtonActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_m_gaussianWidthAbsolutelyFixedRadioButtonActionPerformed

    private void m_cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_cancelButtonActionPerformed
        dispose( );
    }//GEN-LAST:event_m_cancelButtonActionPerformed

    private void m_generateGeneralBaselineButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_generateGeneralBaselineButtonActionPerformed
       
        if ( this.m_freeBaselineModelRadioButton.isSelected( ) )
        {    
            GeneralBaseline generalBaselineGenerator = new GeneralBaseline( this, GeneralBaseline.FREE_MODEL );
            m_generalBaseLineModel = generalBaselineGenerator.generateRequiredGeneralBaselineType( );
        }
        
        if ( this.m_veryRigidDefaultBaselineModelRadioButton.isSelected( ) )
        {    
            GeneralBaseline generalBaselineGenerator = new GeneralBaseline( this, GeneralBaseline.VERY_RIGID_MODEL );
            m_generalBaseLineModel = generalBaselineGenerator.generateRequiredGeneralBaselineType( );
        }
        
        if ( this.m_rigidDefaultBaselineModelRadioButton.isSelected( ) )
        {    
            GeneralBaseline generalBaselineGenerator = new GeneralBaseline( this, GeneralBaseline.RIGID_MODEL );
            m_generalBaseLineModel = generalBaselineGenerator.generateRequiredGeneralBaselineType( );
        }
        
        if ( this.m_freeBaselineModelRadioButton.isSelected( ) )
        {    
            GeneralBaseline generalBaselineGenerator = new GeneralBaseline( this, GeneralBaseline.FLEXIBLE_MODEL );
            m_generalBaseLineModel = generalBaselineGenerator.generateRequiredGeneralBaselineType( );
        }
        
        if ( this.m_veryFlexibleDefaultBaselineModelRadioButton.isSelected( ) )
        {    
            GeneralBaseline generalBaselineGenerator = new GeneralBaseline( this, GeneralBaseline.VERY_FLEXIBLE_MODEL );
            m_generalBaseLineModel = generalBaselineGenerator.generateRequiredGeneralBaselineType( );
        }
        
        notifyActionListeners( 0, "general_baseline_computed" );
    }//GEN-LAST:event_m_generateGeneralBaselineButtonActionPerformed

    public List getGeneratedGeneralBaselineModelList( )
    {
        return m_generalBaseLineModel;
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main( String args[] ) 
    {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(GeneralBaselineSettingsFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(GeneralBaselineSettingsFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(GeneralBaselineSettingsFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(GeneralBaselineSettingsFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new GeneralBaselineSettingsFrame( ).setVisible( true );
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.ButtonGroup m_baselineModelTypeButtonGroup;
    private javax.swing.JButton m_cancelButton;
    private javax.swing.JRadioButton m_flexibleDefaultBaselineModelRadioButton;
    private javax.swing.JRadioButton m_freeBaselineModelRadioButton;
    private javax.swing.JRadioButton m_gaussianWidthAbsolutelyFixedRadioButton;
    private javax.swing.ButtonGroup m_gaussianWidthButtonGroup;
    private javax.swing.JButton m_generateGeneralBaselineButton;
    private javax.swing.JRadioButton m_lorentzianWidthAbsolutelyFixedRadioButton;
    private javax.swing.ButtonGroup m_lorentzianWidthButtonGroup;
    private javax.swing.JLabel m_maximumPPMLabel;
    private javax.swing.JLabel m_minimumPPMLabel;
    private javax.swing.JTextField m_numberOfComponentsTextField;
    private javax.swing.ButtonGroup m_offsetButtonGroup;
    private javax.swing.JRadioButton m_offsetsAbsolutedFixed;
    private javax.swing.JRadioButton m_oneCommonlyVaryingGaussianWidthRadioButton;
    private javax.swing.JRadioButton m_oneCommonlyVaryingLorentzianWIdthRadioButton;
    private javax.swing.JRadioButton m_oneCommonlyVaryingOffsetRadioButton;
    private javax.swing.JRadioButton m_oneCommonlyVaryingPhaseRadioButton;
    private javax.swing.ButtonGroup m_phaseButtonGroup;
    private javax.swing.JRadioButton m_phasesAbsolutelyFixedRadioButton;
    private javax.swing.JRadioButton m_rigidDefaultBaselineModelRadioButton;
    private javax.swing.JTextField m_startingAmplitudesTextField;
    private javax.swing.JTextField m_startingGaussianWidthTextField;
    private javax.swing.JTextField m_startingLorentzianWidthTextField;
    private javax.swing.JTextField m_startingOffsetDifferencesTextField;
    private javax.swing.JTextField m_startingPhaseTextField;
    private javax.swing.JRadioButton m_veryFlexibleDefaultBaselineModelRadioButton;
    private javax.swing.JRadioButton m_veryRigidDefaultBaselineModelRadioButton;
    // End of variables declaration//GEN-END:variables

    List m_generalBaseLineModel = null;
    LinkedList<ActionListener> m_actionListeners = new LinkedList<>( ); 
    
    
    public void addActionListener( ActionListener listener )
    {
        m_actionListeners.add( listener );
    }
    
    public void notifyActionListeners( int ID, String actionCommand )
    {
        Iterator it = m_actionListeners.iterator( );
        while ( it.hasNext( ) )
        {
            ( ( ActionListener )it.next( ) ).actionPerformed( new ActionEvent( this, ID, actionCommand ) );
        }
    }
    
    public float getMinimumPPMValue( ) 
    {
        return Float.parseFloat( m_minimumPPMLabel.getText( ) );
    }
    
    public float getMaximumPPMValue( ) 
    {
        return Float.parseFloat( m_maximumPPMLabel.getText( ) );
    }

    public int getNumberOfBaselineComponents( ) 
    {
        return Integer.parseInt( m_numberOfComponentsTextField.getText( ) );
    }

    public float getDefaultStartingAmplitudes() 
    {
        return Float.parseFloat( m_startingAmplitudesTextField.getText( ) );
    }

    public float getDefaultStartingPhases() 
    {
        return Float.parseFloat( this.m_startingPhaseTextField.getText( ) );
    }

    public float getDefaultStartingOffsets( ) 
    {
        return Float.parseFloat( this.m_startingOffsetDifferencesTextField.getText( ) );
    }

    public float getDefaultLorentzianWidths( ) 
    {
      return Float.parseFloat( this.m_startingLorentzianWidthTextField.getText( ) );
    }

    public float getDefaultGaussianWidths( ) 
    {
        return Float.parseFloat( this.m_startingGaussianWidthTextField.getText( ) );
    }

    public boolean areOffsetsAbsolutelyFixed( ) 
    {
        return m_offsetsAbsolutedFixed.isSelected( );
    }

    public boolean areFhasesAbsolutelyFixed( ) 
    {
        return m_phasesAbsolutelyFixedRadioButton.isSelected( );
    }

    public boolean areLorentzianWidthsAbsolutelyFixed() 
    {
        return m_lorentzianWidthAbsolutelyFixedRadioButton.isSelected( );
    }

    public boolean areGaussianWidthsAbsolutelyFixed() 
    {
        return m_gaussianWidthAbsolutelyFixedRadioButton.isSelected( );
    }
    
}
