/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.spectrim.tdfdfit.quantitativeresults;

import javax.swing.JTable;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

/**
 * Class implementing a listener to the normal value database table.
 * @author slotboom
 */
public class NormalDataBaseSelectionTableSelectionListener implements ListSelectionListener
{


    /**
     * Creates a new instance of OverlayPropertiesTableSelectionListener.
     * It is necessary to keep the m_table since it is not possible
     * to determine the m_table from the event's source
     * @param table
     */
    public NormalDataBaseSelectionTableSelectionListener( JTable table )
    {
        m_table = table;
    }

    /**
     * Is called whenever changes in the m_table are detected.
     */
    @Override
    public void valueChanged( ListSelectionEvent e )
    {
        // If cell selection is enabled, both row and column change events are fired
        if ( e.getSource( ) == m_table.getSelectionModel( ) && m_table.getRowSelectionAllowed( ) )
        {
            // Column selection changed
            int first = e.getFirstIndex( );
            int last = e.getLastIndex( );

        }
        else if ( e.getSource( ) == m_table.getColumnModel( ).getSelectionModel( ) && m_table.getColumnSelectionAllowed( ) )
        {
            // Row selection changed
            int first = e.getFirstIndex( );
            int last = e.getLastIndex( );

        }

        if ( e.getValueIsAdjusting( ) )
        {
            // The mouse button has not yet been released
        }
    }

    // Attributes
    private final JTable m_table;

    public final static int ROW_SELECTION_CHANGED    = 0;
    public final static int COLUMN_SELECTION_CHANGED = 1;

}
