/*
 * TwoCompartmentFittingConditionsPanel.java
 *
 * Created on April 18, 2006, 9:51 AM
 */

package org.spectrim.tdfdfit.waterreferencemodelling;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.LinkedList;
import javax.swing.JFrame;

/**
 * Class that enables the definition of the ranges for the two compartment
 * model fitting parameters to be fitted.
 * @author  hans
 */
public class TwoCompartmentWaterReferenceModelFittingConditionsPanel extends javax.swing.JPanel implements ActionListener {
    
    /** 
     * Creates new form TwoCompartmentFittingConditionsPanel.
     * @param parent
     */
    public TwoCompartmentWaterReferenceModelFittingConditionsPanel( JFrame parent )
    {
        m_parent = parent;

        initComponents( );
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        m_selectFitMethodButtonGroup = new javax.swing.ButtonGroup();
        m_fittingStartingValuesPanel = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        m_TC_Amplitude1_StartingValue = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        m_TC_TimeConstant1_StartingValue = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        m_TC_Amplitude2_StartingValue = new javax.swing.JTextField();
        jLabel11 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        m_TC_TimeConstant2_StartingValue = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        m_fitStartPanel = new javax.swing.JPanel();
        m_performFitButton = new javax.swing.JButton();
        m_aboutButton = new javax.swing.JButton();
        m_fitParameterConstraintPanel = new javax.swing.JPanel();
        jLabel6 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        m_minimumAllowedTC_Amplitude1 = new javax.swing.JTextField();
        jLabel13 = new javax.swing.JLabel();
        m_maximumAllowedTC_Amplitude1 = new javax.swing.JTextField();
        jLabel14 = new javax.swing.JLabel();
        m_minimumAllowed_TC1_TimeConstant = new javax.swing.JTextField();
        m_maximumAllowed_TC1_TimeConstant = new javax.swing.JTextField();
        m_minimumAllowed_TC_Amplitude2 = new javax.swing.JTextField();
        m_maximum_Allowed_TC_Amplitude2 = new javax.swing.JTextField();
        m_minimumAllowed_TC2_TimeConstant = new javax.swing.JTextField();
        m_maximumAllowed_TC2_TimeConstant = new javax.swing.JTextField();
        jLabel15 = new javax.swing.JLabel();
        jLabel16 = new javax.swing.JLabel();
        jLabel17 = new javax.swing.JLabel();
        jLabel18 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        jLabel19 = new javax.swing.JLabel();
        m_numberOfFitRepetitionsTextField = new javax.swing.JTextField();
        jLabel20 = new javax.swing.JLabel();
        m_numberOfFunctionValueEvaluationsInRandomFitTextField = new javax.swing.JTextField();
        jLabel21 = new javax.swing.JLabel();
        m_numberOfIterationsRandomFitTextField1 = new javax.swing.JTextField();
        m_fitMethodPanel = new javax.swing.JPanel();
        m_selectLevenbergMarquardtRadioButton = new javax.swing.JRadioButton();
        m_selectRandomMethodRadioButton = new javax.swing.JRadioButton();
        jPanel2 = new javax.swing.JPanel();
        m_fittingProgressBar = new javax.swing.JProgressBar();
        m_progressLabel = new javax.swing.JLabel();

        setBorder(javax.swing.BorderFactory.createEmptyBorder(5, 5, 5, 5));
        setMaximumSize(new java.awt.Dimension(698, 810));

        m_fittingStartingValuesPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Starting values"));

        jLabel1.setText("Amplitude factor A1");

        m_TC_Amplitude1_StartingValue.setText("0.90");

        jLabel9.setText("--");

        jLabel2.setText("Time constant     TC1");

        m_TC_TimeConstant1_StartingValue.setText("100");

        jLabel7.setText("msec");

        jLabel4.setText("Amplitude factor A2");

        m_TC_Amplitude2_StartingValue.setText("0.10");

        jLabel11.setText("--");

        jLabel3.setText("Time constant     TC2");

        m_TC_TimeConstant2_StartingValue.setText("800");

        jLabel5.setText("msec");

        org.jdesktop.layout.GroupLayout m_fittingStartingValuesPanelLayout = new org.jdesktop.layout.GroupLayout(m_fittingStartingValuesPanel);
        m_fittingStartingValuesPanel.setLayout(m_fittingStartingValuesPanelLayout);
        m_fittingStartingValuesPanelLayout.setHorizontalGroup(
            m_fittingStartingValuesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_fittingStartingValuesPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(m_fittingStartingValuesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(m_fittingStartingValuesPanelLayout.createSequentialGroup()
                        .add(jLabel2)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 189, Short.MAX_VALUE)
                        .add(m_TC_TimeConstant1_StartingValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 76, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(org.jdesktop.layout.GroupLayout.LEADING, m_fittingStartingValuesPanelLayout.createSequentialGroup()
                        .add(jLabel4)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 199, Short.MAX_VALUE)
                        .add(m_TC_Amplitude2_StartingValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 76, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(org.jdesktop.layout.GroupLayout.LEADING, m_fittingStartingValuesPanelLayout.createSequentialGroup()
                        .add(jLabel1)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 199, Short.MAX_VALUE)
                        .add(m_TC_Amplitude1_StartingValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 76, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(org.jdesktop.layout.GroupLayout.LEADING, m_fittingStartingValuesPanelLayout.createSequentialGroup()
                        .add(jLabel3)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 189, Short.MAX_VALUE)
                        .add(m_TC_TimeConstant2_StartingValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 76, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_fittingStartingValuesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel5)
                    .add(jLabel11)
                    .add(jLabel7)
                    .add(jLabel9))
                .addContainerGap(61, Short.MAX_VALUE))
        );
        m_fittingStartingValuesPanelLayout.setVerticalGroup(
            m_fittingStartingValuesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_fittingStartingValuesPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(m_fittingStartingValuesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(jLabel9)
                    .add(m_TC_Amplitude1_StartingValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_fittingStartingValuesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2)
                    .add(jLabel7)
                    .add(m_TC_TimeConstant1_StartingValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_fittingStartingValuesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel4)
                    .add(jLabel11)
                    .add(m_TC_Amplitude2_StartingValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_fittingStartingValuesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel3)
                    .add(jLabel5)
                    .add(m_TC_TimeConstant2_StartingValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        m_performFitButton.setText("Perform fit");
        m_performFitButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_performFitButtonActionPerformed(evt);
            }
        });

        m_aboutButton.setText("About");
        m_aboutButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_aboutButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout m_fitStartPanelLayout = new org.jdesktop.layout.GroupLayout(m_fitStartPanel);
        m_fitStartPanel.setLayout(m_fitStartPanelLayout);
        m_fitStartPanelLayout.setHorizontalGroup(
            m_fitStartPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, m_fitStartPanelLayout.createSequentialGroup()
                .add(76, 76, 76)
                .add(m_performFitButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 103, Short.MAX_VALUE)
                .add(100, 100, 100)
                .add(m_aboutButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 249, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(41, 41, 41))
        );
        m_fitStartPanelLayout.setVerticalGroup(
            m_fitStartPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_fitStartPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(m_fitStartPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(m_performFitButton)
                    .add(m_aboutButton))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        m_fitParameterConstraintPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Parameter constraints"));

        jLabel6.setText("Amplitude factor range A1");

        jLabel8.setText("Time constant range     TC1");

        jLabel10.setText("Amplitude factor range A2");

        jLabel12.setText("Time constant range     TC2");

        m_minimumAllowedTC_Amplitude1.setText("0.0");

        jLabel13.setText("minimum ");

        m_maximumAllowedTC_Amplitude1.setText("10.0");

        jLabel14.setText("maximum");

        m_minimumAllowed_TC1_TimeConstant.setText("10");

        m_maximumAllowed_TC1_TimeConstant.setText("300");

        m_minimumAllowed_TC_Amplitude2.setText("0.0");

        m_maximum_Allowed_TC_Amplitude2.setText("5.0");

        m_minimumAllowed_TC2_TimeConstant.setText("301");

        m_maximumAllowed_TC2_TimeConstant.setText("2000");

        jLabel15.setText("msec");

        jLabel16.setText("msec");

        jLabel17.setText("--");

        jLabel18.setText("--");

        org.jdesktop.layout.GroupLayout m_fitParameterConstraintPanelLayout = new org.jdesktop.layout.GroupLayout(m_fitParameterConstraintPanel);
        m_fitParameterConstraintPanel.setLayout(m_fitParameterConstraintPanelLayout);
        m_fitParameterConstraintPanelLayout.setHorizontalGroup(
            m_fitParameterConstraintPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_fitParameterConstraintPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(m_fitParameterConstraintPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel6)
                    .add(jLabel8)
                    .add(jLabel10)
                    .add(jLabel12))
                .add(100, 100, 100)
                .add(m_fitParameterConstraintPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(m_minimumAllowed_TC_Amplitude2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 76, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel13)
                    .add(m_minimumAllowedTC_Amplitude1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 76, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(m_minimumAllowed_TC1_TimeConstant, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 76, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(m_minimumAllowed_TC2_TimeConstant, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 76, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(m_fitParameterConstraintPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(m_fitParameterConstraintPanelLayout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(m_fitParameterConstraintPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(m_maximumAllowed_TC1_TimeConstant, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 76, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(m_maximumAllowedTC_Amplitude1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 76, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(m_fitParameterConstraintPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel17)
                            .add(jLabel16)))
                    .add(m_fitParameterConstraintPanelLayout.createSequentialGroup()
                        .add(21, 21, 21)
                        .add(jLabel14))
                    .add(m_fitParameterConstraintPanelLayout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(m_fitParameterConstraintPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(m_maximumAllowed_TC2_TimeConstant, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 76, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(m_maximum_Allowed_TC_Amplitude2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 76, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(m_fitParameterConstraintPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel18)
                            .add(jLabel15))))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        m_fitParameterConstraintPanelLayout.setVerticalGroup(
            m_fitParameterConstraintPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_fitParameterConstraintPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(m_fitParameterConstraintPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(m_fitParameterConstraintPanelLayout.createSequentialGroup()
                        .add(m_fitParameterConstraintPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel14)
                            .add(jLabel13))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(m_fitParameterConstraintPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(m_maximumAllowedTC_Amplitude1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel6)
                            .add(m_minimumAllowedTC_Amplitude1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(jLabel17))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_fitParameterConstraintPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(m_maximumAllowed_TC1_TimeConstant, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel16)
                    .add(jLabel8)
                    .add(m_minimumAllowed_TC1_TimeConstant, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_fitParameterConstraintPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(m_maximum_Allowed_TC_Amplitude2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel10)
                    .add(m_minimumAllowed_TC_Amplitude2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel18))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_fitParameterConstraintPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel12)
                    .add(m_maximumAllowed_TC2_TimeConstant, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(m_minimumAllowed_TC2_TimeConstant, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel15))
                .addContainerGap())
        );

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Fitting algorithm parameters"));

        jLabel19.setText("Number of fit repetitions");

        m_numberOfFitRepetitionsTextField.setText("10");
        m_numberOfFitRepetitionsTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_numberOfFitRepetitionsTextFieldActionPerformed(evt);
            }
        });

        jLabel20.setText("Number of function computions");

        m_numberOfFunctionValueEvaluationsInRandomFitTextField.setText("1000");
        m_numberOfFunctionValueEvaluationsInRandomFitTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_numberOfFunctionValueEvaluationsInRandomFitTextFieldActionPerformed(evt);
            }
        });

        jLabel21.setText("Number of interations");

        m_numberOfIterationsRandomFitTextField1.setText("100");
        m_numberOfIterationsRandomFitTextField1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_numberOfIterationsRandomFitTextField1ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel19)
                    .add(jLabel20)
                    .add(jLabel21))
                .add(66, 66, 66)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(m_numberOfIterationsRandomFitTextField1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 76, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(m_numberOfFunctionValueEvaluationsInRandomFitTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 76, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(m_numberOfFitRepetitionsTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 76, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(153, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel19)
                    .add(m_numberOfFitRepetitionsTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel20)
                    .add(m_numberOfFunctionValueEvaluationsInRandomFitTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel1Layout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 22, Short.MAX_VALUE)
                        .add(jLabel21)
                        .addContainerGap())
                    .add(jPanel1Layout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(m_numberOfIterationsRandomFitTextField1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())))
        );

        m_fitMethodPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Fit method"));

        m_selectFitMethodButtonGroup.add(m_selectLevenbergMarquardtRadioButton);
        m_selectLevenbergMarquardtRadioButton.setText("Levenberg-Marquardt");
        m_selectLevenbergMarquardtRadioButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        m_selectLevenbergMarquardtRadioButton.setEnabled(false);

        m_selectFitMethodButtonGroup.add(m_selectRandomMethodRadioButton);
        m_selectRandomMethodRadioButton.setSelected(true);
        m_selectRandomMethodRadioButton.setText("Random");
        m_selectRandomMethodRadioButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));

        org.jdesktop.layout.GroupLayout m_fitMethodPanelLayout = new org.jdesktop.layout.GroupLayout(m_fitMethodPanel);
        m_fitMethodPanel.setLayout(m_fitMethodPanelLayout);
        m_fitMethodPanelLayout.setHorizontalGroup(
            m_fitMethodPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_fitMethodPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(m_selectLevenbergMarquardtRadioButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 245, Short.MAX_VALUE)
                .add(147, 147, 147)
                .add(m_selectRandomMethodRadioButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 141, Short.MAX_VALUE)
                .addContainerGap())
        );
        m_fitMethodPanelLayout.setVerticalGroup(
            m_fitMethodPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, m_fitMethodPanelLayout.createSequentialGroup()
                .add(m_fitMethodPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(m_selectLevenbergMarquardtRadioButton)
                    .add(m_selectRandomMethodRadioButton))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Progress"));

        m_progressLabel.setText("Fitting ..");

        org.jdesktop.layout.GroupLayout jPanel2Layout = new org.jdesktop.layout.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .add(m_progressLabel)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_fittingProgressBar, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 459, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(m_progressLabel)
                    .add(m_fittingProgressBar, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(20, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(m_fitParameterConstraintPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .add(m_fittingStartingValuesPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, m_fitMethodPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, m_fitStartPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(m_fittingStartingValuesPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(2, 2, 2)
                .add(m_fitParameterConstraintPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_fitMethodPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 56, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_fitStartPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void m_performFitButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_performFitButtonActionPerformed
        notifyActionListeners( FIT_EVENT );
    }//GEN-LAST:event_m_performFitButtonActionPerformed

    private void m_aboutButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_aboutButtonActionPerformed
        TwoCompartmentWaterReferenceModelFittingInfomationPanel infoPanel = new TwoCompartmentWaterReferenceModelFittingInfomationPanel( m_parent );
}//GEN-LAST:event_m_aboutButtonActionPerformed

    private void m_numberOfFitRepetitionsTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_numberOfFitRepetitionsTextFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_m_numberOfFitRepetitionsTextFieldActionPerformed

    private void m_numberOfFunctionValueEvaluationsInRandomFitTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_numberOfFunctionValueEvaluationsInRandomFitTextFieldActionPerformed
        // TODO add your handling code here:
}//GEN-LAST:event_m_numberOfFunctionValueEvaluationsInRandomFitTextFieldActionPerformed

    private void m_numberOfIterationsRandomFitTextField1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_numberOfIterationsRandomFitTextField1ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_m_numberOfIterationsRandomFitTextField1ActionPerformed
    
    /**
     * Adds an action listener to the list of listeners
     * @param listener
     */
    public void addActionListener( ActionListener listener )
    {
        m_listeners.add( listener );
    }
    
    /**
     * Sends a notification to all listeners to this object.
     * @param event
     */
    public void notifyActionListeners( int event )
    {
        Iterator it = m_listeners.iterator( );
        while( it.hasNext( ) )
        {
            ( ( ActionListener )it.next( ) ).actionPerformed( new ActionEvent( this, event, "" ) );
        } 
    }
    
    
    /**
     * Returns the fitting method.
     * @return 
     */
    public int getFittingMethod( )
    {
        if ( m_selectLevenbergMarquardtRadioButton.isSelected() == true )
        {
            return LEVENBERG_MARQUARDT_METHOD;
        }
        else
        {
            return this.RANDOM_METHOD;
        }
    }

    /**
     *
     * Returns the number of fitting repetitions used to compute an error
     * from.
     *
     * @return
     */
    public int getNumberOfFittingRepetitions( )
    {
        return Integer.parseInt(m_numberOfFitRepetitionsTextField.getText( ) );
    }

    /**
     * Returns the number of iterations in random fit.
     * @return
     */
    public int getNumberOfFunctionEvaluationsInRandomFit( )
    {
        return Integer.parseInt(m_numberOfFunctionValueEvaluationsInRandomFitTextField.getText( ) );
    }

    /**
     * Returns the number of iterations in random fit.
     * @return
     */
    public int getNumberOfIterationsInRandomFit( )
    {
        return Integer.parseInt(this.m_numberOfIterationsRandomFitTextField1.getText( ) );
    }


    /**
     * Returns the amplitude of the slowly decaying component.
     * @return 
     */
    public double getTC_Amplitude2_StartingValue( )
    {
        return ( new Double( m_TC_Amplitude2_StartingValue.getText( ) ) );
    }
    
    /**
     * Returns the time constant of the slowly decaying component.
     * @return 
     */
    public double getTC_TimeConstant2_StartingValue( )
    {
        return ( new Double( m_TC_TimeConstant2_StartingValue.getText( ) ) );
    }
    
    /**
     * Returns the amplitude of the quickly decaying component.
     * @return 
     */
    public double getTC_Amplitude1_StartingValue( )
    {
        return ( new Double( m_TC_Amplitude1_StartingValue.getText( ) ) );
    }
    
    /**
     * Returns the time constant of the rapid decaying component.
     * @return 
     */
    public double getTC_TimeConstant1_StartingValue( )
    {
        return ( new Double( m_TC_TimeConstant1_StartingValue.getText( ) ) );
    }

    /**
     * Returns the minimum allowed short time constant.
     * @return 
     */
    public double getMinimumAllowedTC_Amplitude_1( )
    {
         return ( new Double( m_minimumAllowedTC_Amplitude1.getText( ) ) );
    }

    /**
     * Returns the maximum allowed short time constant.
     * @return 
     */
    public double getMaximumAllowedTC_Amplitude_1( )
    {
         return ( new Double( m_maximumAllowedTC_Amplitude1.getText( ) ) );
    }
    
    /**
     * Returns the minimum allowed long time constant.
     * @return 
     */
    public double getMinimum_Allowed_TC_Amplitude_2( )
    {
         return ( new Double( m_minimumAllowed_TC_Amplitude2.getText( ) ) );
    }
    
    /**
     * Returns the minimum allowed long time constant.
     * @return 
     */
    public double getMaximum_Allowed_TC_Amplitude_2( )
    {
         return ( new Double( m_maximum_Allowed_TC_Amplitude2.getText( ) ) );
    }
    
    /**
     * Returns the maximum allowed short time constant.
     * @return 
     */
    public double getMaximumAllowed_TC1_TimeConstant( )
    {
        return ( new Double( m_maximumAllowed_TC1_TimeConstant.getText( ) ) );
    }
        
    /**
     * Returns the minimum allowed short time constant.
     * @return 
     */
    public double getMinimumAllowed_TC1_TimeConstant( )
    {
        return ( new Double( m_minimumAllowed_TC1_TimeConstant.getText( ) ) );
    }


    /**
     * Returns the maximum allowed short time constant.
     * @return 
     */
    public double getMaximumAllowed_TC2_TimeConstant( )
    {
        return ( new Double( m_maximumAllowed_TC2_TimeConstant.getText( ) ) );
    }
        
    /**
     * Returns the minimum allowed short time constant.
     * @return 
     */
    public double getMinimumAllowed_TC2_TimeConstant( )
    {
        return ( new Double( m_minimumAllowed_TC2_TimeConstant.getText( ) ) );
    }
    
    
    // Manually added variables
    LinkedList<ActionListener> m_listeners = new LinkedList<>( );
    
    // Possible Events
    public final static int FIT_EVENT = 0;
    
    public final static int LEVENBERG_MARQUARDT_METHOD = 0;
    public final static int RANDOM_METHOD = 1;


    /**
     * Handles events from the AutoTwoCompartmentModelFittingFrame
     * @param e
     */
    @Override
    public void actionPerformed( ActionEvent e )
    {
        
        if ( e.getActionCommand( ).compareTo( TwoCompartmentWaterReferenceModelFittingFrame.FIT_STEP_PROGRESS_EVENT_CMD ) == 0 )
        {
            //System.out.println( "Progress in fitting occurred FIT_STEP_PROGRESS_EVENT_ID " );
            m_fittingProgressBar.setValue( ( ( TwoCompartmentWaterReferenceModelFittingFrame)e.getSource( ) ) .getFittingProgress( ) );
            // m_fittingProgressBar.setValue( 0 );
            m_fittingProgressBar.setStringPainted( true );
        }

        if ( e.getActionCommand( ).compareTo( TwoCompartmentWaterReferenceModelFittingFrame.FIT_FINISHED_EVENT_CMD ) == 0 )
        {
            //System.out.println( "Progress in fitting occurred FIT_STEP_PROGRESS_EVENT_ID " );
            m_fittingProgressBar.setValue( ( ( TwoCompartmentWaterReferenceModelFittingFrame)e.getSource( ) ) .getFittingProgress( ) );
            m_fittingProgressBar.setValue( 0 );
            m_fittingProgressBar.setStringPainted( false );
        }
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JTextField m_TC_Amplitude1_StartingValue;
    private javax.swing.JTextField m_TC_Amplitude2_StartingValue;
    private javax.swing.JTextField m_TC_TimeConstant1_StartingValue;
    private javax.swing.JTextField m_TC_TimeConstant2_StartingValue;
    private javax.swing.JButton m_aboutButton;
    private javax.swing.JPanel m_fitMethodPanel;
    private javax.swing.JPanel m_fitParameterConstraintPanel;
    private javax.swing.JPanel m_fitStartPanel;
    private javax.swing.JProgressBar m_fittingProgressBar;
    private javax.swing.JPanel m_fittingStartingValuesPanel;
    private javax.swing.JTextField m_maximumAllowedTC_Amplitude1;
    private javax.swing.JTextField m_maximumAllowed_TC1_TimeConstant;
    private javax.swing.JTextField m_maximumAllowed_TC2_TimeConstant;
    private javax.swing.JTextField m_maximum_Allowed_TC_Amplitude2;
    private javax.swing.JTextField m_minimumAllowedTC_Amplitude1;
    private javax.swing.JTextField m_minimumAllowed_TC1_TimeConstant;
    private javax.swing.JTextField m_minimumAllowed_TC2_TimeConstant;
    private javax.swing.JTextField m_minimumAllowed_TC_Amplitude2;
    private javax.swing.JTextField m_numberOfFitRepetitionsTextField;
    private javax.swing.JTextField m_numberOfFunctionValueEvaluationsInRandomFitTextField;
    private javax.swing.JTextField m_numberOfIterationsRandomFitTextField1;
    private javax.swing.JButton m_performFitButton;
    private javax.swing.JLabel m_progressLabel;
    private javax.swing.ButtonGroup m_selectFitMethodButtonGroup;
    private javax.swing.JRadioButton m_selectLevenbergMarquardtRadioButton;
    private javax.swing.JRadioButton m_selectRandomMethodRadioButton;
    // End of variables declaration//GEN-END:variables
   
    // For proper serialization
    private static final long serialVersionUID = 6482325678121223L;

    private final JFrame m_parent;


}
