/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.toolbars;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.Iterator;
import java.util.LinkedList;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JToolBar;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;

/**
 *
 * @author johan
 */
public final class TDFDFitModelToolbar extends JPanel implements ActionListener
{
    public TDFDFitModelToolbar ( )
    {
        super( new BorderLayout( ) );

        // Create the toolbar.
        JToolBar toolBar = new JToolBar( "TDFDFit model toolbar " );
        addButtons( toolBar );

        add( toolBar, BorderLayout.PAGE_START );
        
        setVisible( true );
    }

    /**
     * Add the buttons to the toolbar.
     * @param toolBar
     */
    protected void addButtons( JToolBar toolBar )
    {
        
        // first button
        m_setDefaultMetaboliteFitModelButton = makeBasicFileToolBarButton( "Defmetabmodel24", SET_DEFAULT_METABOLITE_MODEL,
                                             SET_DEFAULT_METABOLITE_MODEL,
                                             "Set-def-metab-model" );
        toolBar.add( m_setDefaultMetaboliteFitModelButton );
        
        // second button
        m_setDefaultWaterModelButton = makeBasicFileToolBarButton( "Defwatermodel24", SET_DEFAULT_WATER_MODEL,
                                             SET_DEFAULT_WATER_MODEL,
                                             "Set-def-wat-model" );
        toolBar.add( m_setDefaultWaterModelButton );
        
        // third button
        m_addVoigtLineViaGUIButton = makeBasicFileToolBarButton( "AddVoigtLineViaGUI24", ADD_INTERACTIVE_VOIGT_LINE,
                                                                   ADD_INTERACTIVE_VOIGT_LINE,
                                                                   "Add-voigt-line" );
        toolBar.add( m_addVoigtLineViaGUIButton );
        
        
        // third button
        m_addParametricPatternButton = makeBasicFileToolBarButton( "AddparametricPattern24", ADD_PARAMETRIC_PATTERN,
                                                                   ADD_PARAMETRIC_PATTERN,
                                                                   "Add-par-pat" );
        toolBar.add( m_addParametricPatternButton );

        // fourth button
        m_addNumericPatternNPFButton = makeBasicFileToolBarButton( "AddnumericPattern1-24", ADD_NUMERIC_PATTERN_NPF,
                                                                   ADD_NUMERIC_PATTERN_NPF,
                                                                   "Add-met-pat-npf" );
        toolBar.add( m_addNumericPatternNPFButton );

        // fifth button
        m_addNumericPatternMRUIButton = makeBasicFileToolBarButton( "AddnumericPattern2-24", ADD_NUMERIC_PATTERN_JMRUI,
                                                                    ADD_NUMERIC_PATTERN_JMRUI,
                                                                    "Add-met-pat-jmrui" );
        toolBar.add( m_addNumericPatternMRUIButton );
        
        // sixth button
        m_addNumericPatternBINButton = makeBasicFileToolBarButton( "AddnumericPattern3-24", ADD_NUMERIC_PATTERN_BIN,
                                                                   ADD_NUMERIC_PATTERN_BIN,
                                                                   "Add-met-pat-bin" );
        
        toolBar.add( m_addNumericPatternBINButton );

        // seventh button
        m_addMetabolitePatternMPFButton = makeBasicFileToolBarButton( "Addmetabolite24", ADD_METABOLITE_PATTERN_MPF,
                                                                      ADD_METABOLITE_PATTERN_MPF,
                                                                      "Add-metabolite-mpf" );
        toolBar.add( m_addMetabolitePatternMPFButton );
        
        // eigths button
        m_addMacroMolecular1HBrainBaselineButton = makeBasicFileToolBarButton( "AddMacroMolecularBaseline24", ADD_MACRO_MOLECULAR_1H_BRAIN_BASELINE,
                                                                                ADD_MACRO_MOLECULAR_1H_BRAIN_BASELINE,
                                                                                "Add-macro-mol-baseline" );
        toolBar.add( m_addMacroMolecular1HBrainBaselineButton );
        
        // nineth button
        m_performWaterReferenceModellingButton = makeBasicFileToolBarButton( "Waterrefmodeltool24", WATER_REFERENCE_MODELLING,
                                                                             WATER_REFERENCE_MODELLING,
                                                                             "Launch-water-ref-gui" );
        toolBar.add( m_performWaterReferenceModellingButton );
        m_performWaterReferenceModellingButton.setEnabled( false );
        // tenth button
        m_launchQuantitativeViewerButton = makeBasicFileToolBarButton( "QuantitativeEvaluationSVS24", QUANTITATIVE_VIEWER,
                                                                       QUANTITATIVE_VIEWER,
                                                                       "Launch-quant-viewer" );
        toolBar.add( m_launchQuantitativeViewerButton );
        m_launchQuantitativeViewerButton.setEnabled( false );
        
        // eleventh button
        m_setDefaultParameterRangesButton = makeBasicFileToolBarButton( "RangeDefine24", SET_DEFAULT_PARAMETER_RANGES,
                                                                        SET_DEFAULT_PARAMETER_RANGES,
                                                                        "Launch-param-range-definer" );
        m_setDefaultParameterRangesButton.setEnabled( false );
        toolBar.add( m_setDefaultParameterRangesButton );
        
    }


    /**
     *
     * Creates all buttons of the Toolbar
     *
     * @param imageName
     * @param actionCommand
     * @param toolTipText
     * @param altText
     * @return the button to add
     */
    protected JButton makeBasicFileToolBarButton( String imageName,
                                                  String actionCommand,
                                                  String toolTipText,
                                                  String altText )
    {
        //Look for the image.
        String workingDir = System.getProperty( "user.dir" );
        String imgLocation = workingDir + System.getProperty( "file.separator" )
                                        + "images"
                                        + System.getProperty( "file.separator" )
                                        + imageName
                                        + ".gif";
        File imageFile = new File( imgLocation );

        //Create and initialize the button.
        JButton button = new JButton( );
        button.setActionCommand( actionCommand );
        button.setToolTipText( toolTipText );
        button.addActionListener( this );

        if ( imageFile.exists( ) )
        {                      //image found
            button.setIcon( new ImageIcon( imgLocation ) );
        } 
        else
        {                                     //no image found
            button.setText( altText );
            System.err.println( "Resource not found: "
                               + imgLocation );
        }

        return button;
    }
    
    /**
     *
     * Is called whenever a registered component raises an ActionEvent.
     *
     * @param e
     */
    @Override
    public void actionPerformed( ActionEvent e )
    {
        String cmd = e.getActionCommand( );
        String description = null;

        // Handle each button.
        if ( SET_DEFAULT_METABOLITE_MODEL.equals( cmd ) )
        {   //first button clicked
            notifyActionListeners( SET_DEFAULT_METABOLITE_MODEL, SET_DEFAULT_METABOLITE_MODEL_ID );
        }
        else if ( SET_DEFAULT_WATER_MODEL.equals( cmd ) )
        {   //second button clicked
            notifyActionListeners( SET_DEFAULT_WATER_MODEL, SET_DEFAULT_WATER_MODEL_ID );
        }
        else if ( ADD_INTERACTIVE_VOIGT_LINE.equals( cmd ) )
        {   // third button clicked
            notifyActionListeners( ADD_INTERACTIVE_VOIGT_LINE, ADD_INTERACTIVE_VOIGT_LINE_ID );
        }
        else if ( ADD_PARAMETRIC_PATTERN.equals( cmd ) )
        {   // fourth button clicked
            notifyActionListeners( ADD_PARAMETRIC_PATTERN, ADD_PARAMETRIC_PATTERN_ID );
        }
        else if ( ADD_NUMERIC_PATTERN_NPF.equals( cmd ) )
        {   // fifth button clicked
            notifyActionListeners( ADD_NUMERIC_PATTERN_NPF, ADD_NUMERIC_PATTERN_NPF_ID );
        }
        else if ( ADD_NUMERIC_PATTERN_JMRUI.equals( cmd ) )
        {   // sixth button clicked
            notifyActionListeners( ADD_NUMERIC_PATTERN_JMRUI, ADD_NUMERIC_PATTERN_JMRUI_ID );
        } 
        else if ( ADD_NUMERIC_PATTERN_BIN.equals( cmd ) )
        {   // seventh button clicked
            notifyActionListeners( ADD_NUMERIC_PATTERN_BIN, ADD_NUMERIC_PATTERN_BIN_ID );
        }
        else if ( ADD_METABOLITE_PATTERN_MPF.equals( cmd ) )
        {   // eighth button clicked
            notifyActionListeners( ADD_METABOLITE_PATTERN_MPF, ADD_METABOLITE_PATTERN_MPF_ID );
        }
        else if ( ADD_MACRO_MOLECULAR_1H_BRAIN_BASELINE.equals( cmd ) )
        {   // nineth button clicked
            notifyActionListeners( ADD_MACRO_MOLECULAR_1H_BRAIN_BASELINE, ADD_MACRO_MOLECULAR_1H_BRAIN_BASELINE_ID );
        } 
        else if ( WATER_REFERENCE_MODELLING.equals( cmd ) )
        {   // tenth button clicked
            notifyActionListeners( WATER_REFERENCE_MODELLING, WATER_REFERENCE_MODELLING_ID );
        }
        else if ( QUANTITATIVE_VIEWER.equals( cmd ) )
        {   // eleventh button clicked
            notifyActionListeners( QUANTITATIVE_VIEWER, QUANTITATIVE_VIEWER_ID );
        }
        else if ( SET_DEFAULT_PARAMETER_RANGES.equals( cmd ) )
        {   // twelfth button clicked
            notifyActionListeners( SET_DEFAULT_PARAMETER_RANGES, SET_DEFAULT_PARAMETER_RANGES_ID );
        } 
        
    }

     /**
     * Notifies actionEvent to all registered listeners.
     */
    private void notifyActionListeners( String actionCommand, int actionID )
    {
        Iterator it = m_actionListeners.iterator( );
        while( it.hasNext( ) )
        {
            ( ( ActionListener )it.next( ) ).actionPerformed( new ActionEvent( this, actionID, actionCommand ) );
        }
    }

    /**
     * Adds an ActionListener to the list of listeners.
     * @param e
     */
    public void addActionListener( ActionListener e )
    {
        m_actionListeners.add( e );
    }

    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event dispatch thread.
     */
    private static void createAndShowGUI( )
    {
        //Create and set up the window.
        JFrame frame = new JFrame( "BasicFileMenuToolbar" );
        frame.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );

        //Add content to the window.
        frame.add(new TDFDFitFileMenuToolbar( ) );

        //Display the window.
        frame.pack( );
        frame.setVisible( true );
    }

    public void setDefaultMetaboliteFitModelButtonEnabled( boolean enable )
    {
        m_setDefaultMetaboliteFitModelButton.setEnabled( enable );
    }
    
    public void m_setDefaultWaterModelButtonEnabled( boolean enable )
    {
        m_setDefaultWaterModelButton.setEnabled( enable );
    }
    
    public void m_addParametricPatternButtonEnabled( boolean enable )
    {
        m_addParametricPatternButton.setEnabled( enable );
    }        
            
    public void m_addNumericPatternNPFButtonEnabled( boolean enable )
    {
        m_addNumericPatternNPFButton.setEnabled( enable );
    }
    
    public void m_addVoigtLineViaGUIButtonEnabled( boolean enable)
    {
        m_addVoigtLineViaGUIButton.setEnabled( enable );
    }
    
    public void m_addNumericPatternMRUIButtonEnabled( boolean enable )
    {
        m_addNumericPatternMRUIButton.setEnabled( enable );
    }
    public void m_addNumericPatternBINButtonEnabled( boolean enable )
    {
        m_addNumericPatternBINButton.setEnabled( enable );
    }
    public void m_addMetabolitePatternMPFButton( boolean enable )
    {
        m_addMetabolitePatternMPFButton.setEnabled( enable );
    }
    public void m_addMacroMolecular1HBrainBaselineButtonEnabled( boolean enable )
    {
        m_addMacroMolecular1HBrainBaselineButton.setEnabled( enable );
    }
    
    public void m_performWaterReferenceModellingEnabled( boolean enable )
    {
        m_performWaterReferenceModellingButton.setEnabled( enable );
    }
    
    public void m_launchQuantitativeViewerEnabled( boolean enable )
    {
        m_launchQuantitativeViewerButton.setEnabled( enable );
    }
    
    public void m_setDefaultParameterRangesButtonEnabled( boolean enable )
    {
        m_setDefaultParameterRangesButton.setEnabled( enable );
    }
    
    public static void main( String[] args )
    {
        //Schedule a job for the event dispatch thread:
        //creating and showing this application's GUI.
        SwingUtilities.invokeLater( new Runnable( )
        {
            @Override
            public void run( )
            {
                //Turn off metal's use of bold fonts
                UIManager.put( "swing.boldMetal", Boolean.FALSE );
                createAndShowGUI( );
            }
        });
    }

    protected JTextArea textArea;
    protected String newline = "\n";
    
    JButton m_setDefaultMetaboliteFitModelButton;
    JButton m_setDefaultWaterModelButton;
    JButton m_addVoigtLineViaGUIButton;
    JButton m_addParametricPatternButton;
    JButton m_addNumericPatternNPFButton;
    JButton m_addNumericPatternMRUIButton;
    JButton m_addNumericPatternBINButton;
    JButton m_addMetabolitePatternMPFButton;
    JButton m_addMacroMolecular1HBrainBaselineButton;
    JButton m_performWaterReferenceModellingButton;
    JButton m_launchQuantitativeViewerButton;
    JButton m_setDefaultParameterRangesButton;
    
    static final public String SET_DEFAULT_METABOLITE_MODEL   = "Set default fit model";
    static final public String SET_DEFAULT_WATER_MODEL        = "Set default water model";
    static final public String ADD_INTERACTIVE_VOIGT_LINE     = "Add Voigt-line via GUI";
    static final public String ADD_PARAMETRIC_PATTERN     = "Add parametric pattern";
    static final public String ADD_NUMERIC_PATTERN_NPF    = "Add numeric pattern from .npf file";
    static final public String ADD_NUMERIC_PATTERN_JMRUI  = "Add numeric pattern from .jmrui file";
    static final public String ADD_NUMERIC_PATTERN_BIN    = "Add numeric pattern from .bin";
    static final public String ADD_METABOLITE_PATTERN_MPF     = "Add metaboltie pattern from .mpf file";
    static final public String ADD_MACRO_MOLECULAR_1H_BRAIN_BASELINE = "Add 1H brain baseline model";
    static final public String WATER_REFERENCE_MODELLING = "Launch water reference modelling tool";
    static final public String QUANTITATIVE_VIEWER = "Launch quantitative result evaluation tool";
    static final public String SET_DEFAULT_PARAMETER_RANGES = "Define default parameter ranges";
   
    static final public int SET_DEFAULT_METABOLITE_MODEL_ID     = 0;
    static final public int SET_DEFAULT_WATER_MODEL_ID          = 1;
    static final public int ADD_INTERACTIVE_VOIGT_LINE_ID       = 2;
    static final public int ADD_PARAMETRIC_PATTERN_ID           = 3;
    static final public int ADD_NUMERIC_PATTERN_NPF_ID          = 4;
    static final public int ADD_NUMERIC_PATTERN_JMRUI_ID        = 5;
    static final public int ADD_NUMERIC_PATTERN_BIN_ID          = 6;
    static final public int ADD_METABOLITE_PATTERN_MPF_ID       = 7;
    static final public int ADD_MACRO_MOLECULAR_1H_BRAIN_BASELINE_ID   = 8;
    static final public int WATER_REFERENCE_MODELLING_ID        = 9;
    static final public int QUANTITATIVE_VIEWER_ID              = 10;
    static final public int SET_DEFAULT_PARAMETER_RANGES_ID     = 11;
    
    LinkedList<ActionListener> m_actionListeners = new LinkedList<>( );

}
