/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.view;

import org.spectrim.imagegraphicobjects.Point3D;
import java.awt.image.BufferedImage;
import java.awt.image.Raster;
import java.awt.image.WritableRaster;
import java.util.ArrayList;

/**
 *
 * @author nunopbarros
 */
public class OverlaySlice extends ImageSlice {

    public BufferedImage buffImg;

    public enum colorMode {

        warm
    };

    public OverlaySlice(Point3D dirX, Point3D dirY, Point3D pos, int sizex, int sizey, float spacingx, float spacingy, Raster image, String file) {
        super(dirX, dirY, pos, sizex, sizey, spacingx, spacingy, image, file);
        buffImg = new BufferedImage(image.getWidth(), image.getHeight(), BufferedImage.TYPE_INT_ARGB);
    }

    public void updateImage(float min, float max, colorMode mode) {
        for (int i = 0; i < this.buffImg.getWidth(); i++) {
            for (int j = 0; j < this.buffImg.getHeight(); j++) {
                double[] val = new double[1];
                val = image.getPixel(i, j, val);
                int r = 0;
                int g = 0;
                int b = 0;
                int a = 0;
                if (val[0] < min || val[0] > max) {
                    a = 0;
                } else {
                    a = 255;
                    float step = (max - min) / 2;

                    switch (mode) {
                        case warm:
                            r = 255;
                            if (val[0] <= (min + step)) {
                                g = (int) Math.round(2 * (val[0] - min) * 255f / (max - min));
                                if (g > 255) {
                                    g = 255;
                                }
                                b = 0;
                            } else {
                                g = 255;
                                b = (int) Math.round(2 * (val[0] - min - step) * 255f / (max - min));
                                if (b > 255) {
                                    b = 255;
                                }
                            }
                            break;
                    }
                }

                int col = (a << 24) | (r << 16) | (g << 8) | b;
                buffImg.setRGB(i, j, col);
            }
        }
    }

    public static OverlaySlice getMeanSlice(ArrayList<OverlaySlice> slices) {
        OverlaySlice res = slices.get(0);
        res.clearMinMax();
        for (int j = 0; j < res.sizeX; j++) {
            for (int k = 0; k < res.sizeY; k++) {
                double[] val = new double[res.image.getNumBands()];
                for (int i = 0; i < slices.size(); i++) {
                    for (int l = 0; l < val.length; l++) {
                        val[l] += slices.get(i).image.getPixel(j, k, val)[l] / (double) slices.size();
                    }
                }
                ((WritableRaster) res.image).setPixel(j, k, val);
            }
        }
        return res;
    }

    public static OverlaySlice getStdDevSlice(ArrayList<OverlaySlice> slices) {
        OverlaySlice res = slices.get(0);
        res.clearMinMax();
        for (int j = 0; j < res.sizeX; j++) {
            for (int k = 0; k < res.sizeY; k++) {
                double[] mean = new double[res.image.getNumBands()];
                double[] stddev = new double[res.image.getNumBands()];
                for (int i = 0; i < slices.size(); i++) {
                    for (int l = 0; l < mean.length; l++) {
                        mean[l] += slices.get(i).image.getPixel(j, k, mean)[l] / slices.size();
                    }
                }
                for (int i = 0; i < slices.size(); i++) {
                    for (int l = 0; l < mean.length; l++) {
                        stddev[l] += Math.pow(slices.get(i).image.getPixel(j, k, stddev)[l] - mean[l], 2) / (double) slices.size();
                    }
                }
                for (int l = 0; l < mean.length; l++) {
                    stddev[l] = Math.sqrt(stddev[l]);
                }
                ((WritableRaster) res.image).setPixel(j, k, stddev);
            }
        }
        return res;
    }
}
